commit 2b74e1b01af2d56d6e7ebc135143fbe81f6ca455
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Oct 8 11:00:01 2018 +0200

    Releasing 1.1pre17.

commit 32ff5ab8a22ab80cd6c141625538dcc027458c0e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 7 18:05:50 2018 +0200

    Update THANKS.

commit 5f3e9858952277ef3d6ac9d119826cbdda0746d7
Author: Rafael Sadowski <rafael@sizeofvoid.org>
Date:   Mon Oct 1 15:14:24 2018 +0200

    OpenBSD has a proper tap device.

commit 5e1f7fb11138bc552facfb4b64eca9131f3f25b1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 7 13:41:23 2018 +0200

    Update README and links to required libraries.

commit a03991b7911a5f0afbf1269ac47143d09be76c52
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 7 13:32:25 2018 +0200

    Don't check for NULL-pointers before calling free().

commit b0ffeb7eeb21920842382c302ca15ec0d758e9b6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 7 13:05:49 2018 +0200

    Fix spelling errors.
    
    Found by codespell.

commit 1c475ecb575367a6b3f9328b0f643ad636155341
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 6 23:31:05 2018 +0200

    Fix all warnings when compiling with -Wall -W -pedantic.

commit 953f5b4231bbbb8269bb0c55b96a1c8c4bb34a59
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 6 18:18:45 2018 +0200

    Fix warnings from the Clang static analyzer.

commit a6448291834ca7419553a807ee367c719c2956d0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 6 17:51:41 2018 +0200

    Fix compiler warnings.

commit 69e550f5950e31fb97eb4558c3d6e564211ab03a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Sep 9 22:13:43 2018 +0200

    Add a test for backwards compatibility with the legacy protocol.

commit 46f3eba7755089ff68fdc137b0754cae2fa523eb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Sep 9 18:19:15 2018 +0200

    Prevent oracle attacks in the legacy protocol (CVE-2018-16737, CVE-2018-16738)
    
    The legacy authentication protocol allows an oracle attack that could
    potentially be exploited. This commit contains several mitigations:
    
    - Connections are no longer closed immediately on error, but put in
      a "tarpit".
    - The authentication protocol now requires a valid CHAL_REPLY from the
      initiator of a connection before sending a CHAL_REPLY of its own.
    - Reduce the amount of connections per second accepted.
    - Null ciphers or digests are no longer allowed in METAKEYs.
    - Connections that claim to have the same name as the local node are
      rejected.
    
    Just to be on the safe side:
    
    - The new protocol now requires a valid SIG from the initiator of a
      connection before sending a SIG of its own.

commit 01cb1961eac33de9e9d9cecd0910850a2cb549c3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 24 16:19:10 2018 +0200

    Enable AutoConnect by default.

commit 291b8f864ea57dd68b894a3b1482ee822aad66ed
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jun 23 22:32:19 2018 +0200

    Remove address cache debug messages printed to stderr.

commit e5b9bd324cc24355956e9e59e5ec2df72cf9d469
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jun 23 22:26:12 2018 +0200

    Avoid treating compressed MTU probes as having a negative length.
    
    This was not harmful, but caused negative values being logged.

commit 950bbc8f2f9c580ac85bef7bab9a3ae36ea99c4b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 13 22:41:02 2018 +0200

    Print UDP RTT on its own line.

commit 22ae0c3549628739ca7c40e48ce1a276469ded92
Merge: 15341e76 70e1e467
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 13 22:23:27 2018 +0200

    Merge remote-tracking branch 'volth/release-1.1pre16-rtt' into 1.1
    
    Also, reformat the code and fix a compiler warning.

commit 15341e7697fe88a9f3b4646a2cb784dc515609bd
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jun 12 20:50:58 2018 +0200

    Add missing item and attribution to NEWS.

commit e60405831565062c914fe5498cf3b17b0bd13e8b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jun 12 20:50:37 2018 +0200

    Remove the ping test.
    
    This was kind of a hack. The ns-ping test is a much better test, although
    it only works on Linux.

commit 70e1e467f93f885da3e49289e96757d5cd2ae5ba
Author: volth <volth@volth.com>
Date:   Wed Jun 13 18:10:47 2018 +0000

    minor

commit 72136f8418bc7e8a0a5bf3c11215aa49dc679659
Author: volth <volth@volth.com>
Date:   Wed Jun 13 14:12:02 2018 +0000

    expose traffic stats to 'tinc info ___' and 'tinc dump nodes'

commit 0f0585d71b28428792e53258bc570dddc17b0b27
Author: volth <volth@volth.com>
Date:   Tue Jun 12 21:17:30 2018 +0000

    keep track of round trip times of UDP pings

commit 6c0584c55b99dd9814fed5c13536d831b3e5317e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jun 12 20:01:43 2018 +0200

    Releasing 1.1pre16.

commit 75271559a9dc2536b9da1c655a012eb837c58761
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jun 12 19:47:02 2018 +0200

    Remove the wxPython GUI.
    
    This GUI is missing a lot of functionality, and won't be part of an 1.1.0
    release. Therefore, it's being removed, and might be brought back after
    1.1.0.

commit 809ee79b458b0c45d4d60761b1d71171648bdbd5
Author: Oliver Freyermuth <o.freyermuth@googlemail.com>
Date:   Wed Apr 4 22:01:52 2018 +0200

    Fix compiling when support for UML sockets is enabled.

commit f52e4d07706e6314bb11cf9b553f58210f5dd181
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 2 16:49:06 2018 +0200

    Reformat all code using astyle.

commit 7ee885a1f6776be85e5397eda04f75d98ff0b631
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 2 16:33:14 2018 +0200

    Add the ability to set a firewall mark on sockets.
    
    The FWMark option is added, when set it will use setsockopt(SOL_SOCKET, SO_MARK)
    to set the given value as the mark on all sockets created by tinc.
    
    Thanks to Olivier Tirat for submitting a similar patch in the past.

commit d32226bc14428864df08beccb3cf4f8a472f2eef
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 2 12:29:46 2018 +0200

    Fix invitation tests if port 655 is available.
    
    Running the "del Port" command when no Port is set returns an error. But
    it is not necessary anyway since the later "set Port" command will
    overwrite it.

commit 63fbaf7b4a33d5657cd3338b7ea91a173b9973fb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Mar 30 11:50:40 2018 +0200

    Prevent an infinite loop in get_recent_address().
    
    When a node is offline, but we still have edges to it that have the same
    address as we already have in our address cache, an infinite loop would
    happen in get_recent_address(), because we forgot to advance the pointer
    in the list of known addresses, and kept looking at the same one over
    and over.
    
    Thanks to Sven-Haegar Koch for spotting the bug and providing
    diagnostics.

commit 04e498f8b79c1ebfd7080338ffa0399d01862424
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Mar 30 11:38:22 2018 +0200

    Properly implement tinc.texi's dependency on tincinclude.texi.
    
    With this, make distcheck succeeds even without the info-in-builddir
    option to AM_INIT_AUTOMAKE.

commit 63a3369cbc41ba68e221da174c28f5f909c2ed8d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 27 22:54:15 2018 +0200

    Warn if we cannot reload the tincd when creating an invitation.

commit 2d268fc06bc01419e7f7f32d4da1b560e72e4ad3
Author: Mike Sullivan <mksully22@gmail.com>
Date:   Mon Mar 26 14:19:04 2018 -0500

    Fix handling partial SPTPS messages in sptps_test.

commit 69a18395931d657b77641b68ca12473ad6b996da
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 6 19:31:17 2018 +0100

    Ensure we call CloseServiceHandle() in case of errors.

commit a3f04cf74463e783eeddd45e998c1d15db0f868a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 6 19:24:14 2018 +0100

    Reformat all code using astyle.

commit fa305d9570bc7350d04c7de66cfec28b9a2f53d1
Author: Gjergji <gjergjiramku@gmail.com>
Date:   Tue Mar 6 11:10:41 2018 +0100

    fix service removal.
    Windows service was not removed until tincctl exits

commit 7761a6992025ef06bf8dbf88d39a3bf9e459346a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Feb 28 21:34:48 2018 +0100

    Fix compatibility with LibreSSL and OpenSSL < 1.1.
    
    Closes #184 on GitHub.

commit a742ea4d040ecfaabbc875c63f2625654ce68923
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Feb 28 21:28:16 2018 +0100

    Try to process all pending events after select().
    
    If we break out of the loop every time at the first filedescriptor that
    is read/writeable, we risk starving the other filedescriptors.

commit d6c8a1a3d3e945142b251b2897517e10ce0dfce4
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Tue Feb 27 14:20:46 2018 -0700

    Call WSAWaitForMultipleEvents() in a loop until we have checked all events.
    WSAWaitForMultipleEvents() only returns the index of the first event that is read.  We need to call WSAWaitForMultipleEvents() repeatedly to check if other events are also ready.  Otherwise, a single busy event (such as the TAP device) can starve the other events.

commit 7c73cb3ace6659df58ec2382b8d47bb521dad886
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Feb 27 21:08:57 2018 +0100

    Work around a GCC bug that causes inet_checksum() to give wrong results.
    
    Valgrind reports the following bug:
    
    ==24877== Conditional jump or move depends on uninitialised value(s)
    ==24877==    at 0x12283E: inet_checksum (route.c:80)
    ==24877==    by 0x12283E: route_ipv6_unreachable (route.c:315)
    ==24877==    by 0x1236AC: route_ipv6 (route.c:751)
    ==24877==    by 0x1236AC: route (route.c:1160)
    ==24877==    by 0x113DE0: receive_tcppacket (net_packet.c:493)
    ==24877==    by 0x1119D4: receive_meta (meta.c:315)
    ==24877==    by 0x113288: handle_meta_connection_data (net.c:287)
    ==24877==    by 0x11A091: handle_meta_io (net_socket.c:491)
    ==24877==    by 0x10FB0C: event_loop (event.c:370)
    ==24877==    by 0x11362E: main_loop (net.c:489)
    ==24877==    by 0x10CACA: main (tincd.c:551)
    
    Clearing the variable pseudo in route_ipv6_unreachable removes this error,
    but the resulting checksum is still bad. If one instead adds a dummy
    write that depends on checksum, the error goes away and the checksum is
    correct.

commit d661c7c7353da90911e9f2d0195ac861d6837f5c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Feb 27 19:11:38 2018 +0100

    Revert "Unconditionally remove timeouts from the queue before calling the callback."
    
    This reverts commit e8a60109fc91a42420ec626b63956771675f89b0.

commit e8a60109fc91a42420ec626b63956771675f89b0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 26 22:19:43 2018 +0100

    Unconditionally remove timeouts from the queue before calling the callback.
    
    We are going to unlink the timeout from the splay tree anyway, so do it
    unconditionally before the callback, instead of waiting until after the
    callback to check whether or not to remove it based on its expiration
    time.

commit 03a94cb3148544230bdd306e905d2ce88c551c12
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Thu Feb 22 14:27:37 2018 -0700

    In device_handle_read() we need to reset the read event on error or
    it will keep firing.  This is easy to reproduce by suspending the
    machine while tinc is running.

commit f10e98f5e5a3537b43fbc53f07ab691265de999a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Feb 21 20:34:42 2018 +0100

    Update the documentation of the control protocol.

commit 89102b02047d0220766f55ec041c8fc46234cf69
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Tue Feb 20 20:18:38 2018 -0700

    Fix heap corruption on Windows exposed by the use-after free fix.
    reset_address_cache() could call free_known_addresses() on a struct
    addrinfo * that was returned by getaddrinfo().  It seems safest to just
    make a copy of the addresses returned by getaddrinfo() so we can always
    use free_known_addresses() instead of trying to determine whether or
    not we need to use freeaddrinfo().

commit 8f73169567fed6703acbad4f0f5fd5cff700d619
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 19 20:41:21 2018 +0100

    Document the control protocol.

commit ecfef0eeb9b52f6d75b4aa936a1e11e6d8e678e3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 18 16:51:06 2018 +0100

    Reduce memory allocations due to HMAC() and EVP_MD_*().
    
    HMAC() allocates a temporary buffer on the heap each time it is called.
    Similarly, we called EVP_MD_CTX_create() every time we wanted to
    calculate a hash. Use HMAC_CTX and EVP_MD_CTX variables to store the
    state so no (re)allocations are necessary. HMAC() was called for every
    legacy packet sent and received.
    
    This issue was found thanks to heaptrack.

commit 6be453fc63da9f87455b5e579cb686f95fa92102
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 18 15:38:12 2018 +0100

    Reduce memory allocations due to zlib's uncompress().
    
    Everytime uncompress() is called, zlib allocates some buffer on the heap
    and frees it again. When compression is enabled, this is the biggest source
    of memory allocations in tinc. Instead of using this function, use
    inflate(), which can store its state in a z_stream variable, which avoids
    (re)allocating memory for every packet received.
    
    This issue was found thanks to heaptrack.

commit 8f2ef1a174d18a9efdf9b0bd2417132fe7d84e9f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 18 15:33:36 2018 +0100

    Add code coverage testing support.
    
    Allows configure to be run with the --enable-code-coverage flag, allowing
    one to run make check-code-coverage, which runs the test suite and produces
    a code coverage report.

commit d2b03f006f98d504e3e30f2d4b91ce02abd19c51
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Feb 17 14:39:29 2018 +0100

    Reformat all code using astyle.

commit 536fe3ffcdc4c894ed986dfb5fdc0d6f78d6fe25
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Fri Feb 16 14:17:39 2018 -0700

    Fix a use-after-free bug in get_recent_address() and two related issues.
    1) The sockaddr_t * returned may be part of memory freed by the call to
       freeaddrinfo().
    2) The sockaddr_t * returned from a recently seen address not in the
       cache was cast from struct addrinfo *ai, not the struct sockaddr *
       inside of it.
    3) In do_outgoing_connection(), when filling in the address in the
       connection_t, there is a buffer overflow (read, not write) if
       the sa returned by get_recent_address() didn't come from the
       cache of recently seen addresses.  That is, it was really a
       struct sockaddr * and not a sockaddr_t *.  This last was
       found by building tinc with address sanitizer.

commit 8145a3392bdcff4d7856ba72e66a90d73d887c00
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Wed Jan 31 14:55:20 2018 -0700

    In device_issue_read() there is no need to reset Offset and OffsetHigh
    to 0; they are only used for seekable files (not sockets).
    
    Reset the write event before the call to WriteFile().  This is
    consistent with how the read event is reset before ReadFile().
    
    Clear device_write_packet.len() if WriteFile() fails with an error
    other than ERROR_IO_PENDING; otherwise write_packet() will call
    GetOverlappedResult() the next time it is run even though there is
    no write in progress.

commit 5ec513ec0ffc735e30c559a03378659ba4cc4515
Author: Todd C. Miller <Todd.Miller@sudo.ws>
Date:   Tue Jan 23 15:57:58 2018 -0700

    WSAEVENT is a pointer, so we cannot simply return the different of two
    events in io_compare(), which returns an int.  This can return the wrong
    result for 64-bit executables.

commit 92d66492e0824674f68d26e787dd1ba4444a4601
Author: Todd C. Miller <Todd.Miller@courtesan.com>
Date:   Mon Jan 22 10:27:16 2018 -0700

    Add some missing freeaddrinfo() calls to avoid leaking memory.

commit e0f6d90e7fac4c567900e98c354af979c97f8d59
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Jan 22 18:05:09 2018 +0100

    Fix calling freeaddrinfo() on the wrong pointer.
    
    Thanks to Todd C. Miller for finding this issue.

commit 7bf4d225a994d8ce9fb45d42afd53793c4232e8e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Jan 17 19:37:53 2018 +0000

    Move ResetEvent() call before ReadFile().
    
    Commit 313a752 changed the Windows device code such that ResetEvent() is
    called on the read OVERLAPPED structure before GetOverlappedResult(), as
    opposed to before ReadFile(). In [1] Guus pointed out that this doesn't
    make a ton of sense, and I agree with him; it must have been an
    oversight on my part when I wrote this code.
    
    Surprisingly, none of this makes any difference in my testing, at least
    with the standard TAP 9.0.0.9 driver. Nevertheless, this code is
    probably wrong and fixing it will make me sleep better at night.
    
    [1]: https://www.tinc-vpn.org/pipermail/tinc/2018-January/005091.html

commit 43cf631bc10097448db041639ad07f84f647017e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jan 7 14:48:08 2018 +0000

    Fix "use of GNU empty initializer extension" warning.

commit 1b777010e7255cb354e31ca28c6442ee86383bac
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jan 7 14:44:12 2018 +0000

    Fix "void function should not return void expression" warning.

commit ddf798a0ef7df21d682d2f6763d5417400c987ba
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jan 7 14:26:00 2018 +0000

    Fix AC_CHECK_DECLS usage in openssl.m4.
    
    See:
    
      https://www.gnu.org/software/autoconf/manual/autoconf-2.62/html_node/Generic-Declarations.html
    
    "For each of the symbols (comma-separated list)"
    
    When building with aggressive warning settings the current code results
    in the following configure test code being generated:
    
      #ifndef OpenSSL_add_all_algorithms EVP_aes_256_cfb
      #ifdef __cplusplus
        (void) OpenSSL_add_all_algorithms EVP_aes_256_cfb;
      #else
        (void) OpenSSL_add_all_algorithms EVP_aes_256_cfb;
      #endif
      #endif
    
    Which is obviously wrong and makes the configure check fail.

commit 04543a57e73e29c3e2a1968fd330f03c94dd6059
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jan 5 22:49:30 2018 +0100

    Add a cache of recently seen addresses.
    
    This maintains a cache file for each host we have communicated with, either
    via TCP or UDP. The cache is used when trying to make outgoing connections,
    and is updated whenever a successful TCP or UDP connection is established.
    Up to 8 addresses are stored in the cache.
    
    Currently, the cache is stored in /etc/tinc/NETNAME/cache. The directory
    has to be manually created to opt in to this feature for now.

commit ca989c0c8b19901cbd7664a9d2b42aa85c9c176e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 20:46:22 2018 +0100

    Fix all spelling errors found by codespell.

commit 6989a070c35b9672683ebb0764ab9051e0650469
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 20:34:37 2018 +0100

    Document how to enable tinc at boot time using systemd.

commit fe9089337093c917d172aa26eedc9285c8bafb6a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 16:59:21 2018 +0100

    Don't include generated files into the tarball.

commit e56589082f6198380d7f2246a776e41d388496f6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 16:21:19 2018 +0100

    Update .gitignore.

commit ee5e3404e49ef08437cd6b6e4c5b83d190efa053
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 16:20:25 2018 +0100

    Ensure the sptps-basic test doesn't fail during make distcheck.

commit c2d8264dbe8478d27ba694062cebecee0a0342c4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 16:20:03 2018 +0100

    Set default systemd unit path to ${libdir}/systemd/system.
    
    This installs systemd unit files into /usr/local, just like the binaries.
    The systemd documentation claims to read this directory as well.

commit c550c85d75ae38b9621147fdca4bf4380d54edda
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 6 16:17:35 2018 +0100

    Remove hardcoded paths from systemd unit files.
    
    Closes #160 on GitHub.

commit bdeba3f9c26f9225c17c097ca490dc651cd40b90
Merge: 696dc2ad 9ca5a3c4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jan 5 19:58:28 2018 +0100

    Merge remote-tracking branch 'dechamps/ipip' into 1.1

commit 9ca5a3c43854fba782d87be080d7a97a88ef3427
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Jan 2 09:55:26 2018 +0000

    Support MSS clamping for IP in IP (RFC 2003) packets.
    
    This change allows tinc MSS clamping to operate on TCP streams that are
    inside an IP in IP tunnel.

commit 696dc2ad9743c62e56a6d21addb8c4e8efbffec1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jan 5 17:13:57 2018 +0100

    Add missing newlines to some error messages.

commit 313b05b67c59c316c0eff631598e0700e0fd3c8d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jan 5 17:13:25 2018 +0100

    Document that invitation files MUST always start with Name = ...

commit 356118324f7cde276f393162fca54040f8c67f04
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jan 5 17:12:06 2018 +0100

    Don't warn about empty lines in invitation files.

commit 50afa82a8f14ead7d4d3eafd2a1347b3bb9a2879
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Dec 18 10:47:40 2017 +0100

    Document the --batch option.

commit 0b2361a9399944cd57def87226f2be7f92646aa5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Dec 16 22:54:31 2017 +0100

    Assume all IPPROTO_* macros exist.

commit b8acb89add4e553d141a45392bc0126c331deee6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:52:17 2017 +0100

    Fix building documentation when using OpenBSD's make.

commit 4986917cb11be70a9103917d58e7aa47ab88f09d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:49:41 2017 +0100

    Update THANKS.

commit 38489e37f50e807e51bfd28ebb8b20396eed1447
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:44:12 2017 +0100

    Const correctness.

commit 61b441dc995c1e6dd21fd85e2014dd981e9c9350
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:35:28 2017 +0100

    Support autoconf's --runstatedir option.
    
    Put the PID file in @runstatedir@ instead of @localstatedir@/run. This
    requires autoconf 2.70, which is not released yet, so add a fallback to
    use @localstatedir@/run if @runstatedir@ is not set.

commit 42d2dff33306beae8ddbd9cc991ad80f135950a6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:28:32 2017 +0100

    Ensure all parameters have names in header files.

commit b34eb5555d40b7e87c1e06988250e4977a793c09
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 22:27:57 2017 +0100

    Remove unused functions.

commit 6123ed30992d671b94fc016660086be6a62a3871
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Nov 6 21:46:17 2017 +0100

    Don't log errors when autoconnecting fails and debuglevel is 0.

commit c84fce52d2191df06e24737449e8983174984ddc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Oct 26 21:33:46 2017 +0200

    If we are using libncurses, also try to link with libtinfo.
    
    On some distributions, tinc might not be linked correctly if -ltinfo is
    not explicitly specified.

commit e88b3fb52fb375cd8ab233a671f38ed2240ed828
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Oct 25 21:08:29 2017 +0200

    Only forward SPTPS packets if Forwarding = internal.
    
    This tries to match what is done for packets using the legacy protocol.
    However, since SPTPS is end-to-end encrypted, Forwarding = kernel cannot
    be implemented. In that case, we also drop the packets.

commit 87f96aec8c48327d879c20ff2b789c88a675173d
Author: Todd C. Miller <Todd.Miller@courtesan.com>
Date:   Wed Oct 25 10:05:06 2017 -0600

    Replace remaining sizeof foo with sizeof(foo).

commit 9e7c6d4dce8b87d40cea537fd0b035a2612580e3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Oct 23 21:10:20 2017 +0200

    Disable PMTU discovery when TCPOnly is used.

commit 7c359313aca273319f94fe18121831ab4b62a4b4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Oct 11 19:30:17 2017 +0200

    Add some information about the requirements of a chroot environment.

commit a0baeddb8aa745007d0302ed06247cabb8facb32
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 8 21:32:12 2017 +0200

    Ensure "make distcheck" really runs without errors.

commit f6e87ab476a0faf8b124ecaaa27f967d825e6457
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 7 17:50:22 2017 +0200

    Reformat all code using astyle.

commit 3a316823b971396a428f020f401b9fe41252d98d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 7 17:47:19 2017 +0200

    Convert sizeof foo to sizeof(foo).
    
    While technically sizeof is an operator and doesn't need the parentheses
    around expressions it operates on, except if they are type names, code
    formatters don't seem to handle this very well.

commit 5822f817aa802c2c5a83e9d99a8ae78cb822799b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 7 17:40:34 2017 +0200

    Update all header guards.
    
    Don't start with underscores, as those are reserved for system
    libraries. Make sure all start with TINC_, and that they appear at
    the top of the file.

commit 3465746b9bf75124b21eab21cdf390696b608405
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Oct 7 16:51:32 2017 +0200

    Remove unused/obsolete checks from configure.ac.

commit ced6c3151d6012df560f088d39d306370bb115b7
Author: Daniel Lublin <daniel@lublin.se>
Date:   Thu Oct 5 09:23:20 2017 +0200

    doc: there is, not their is

commit d3cb2a7342218c1aadfacd92d640c426d725112f
Author: Guus Sliepen <guus@sliepen.org>
Date:   Tue Oct 3 21:23:28 2017 +0200

    Prepare for automatic code formatting using Artistic Style.

commit e3d914a4d5f5be1c263ec77b9b5c62afb5fc1b78
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 1 22:04:40 2017 +0200

    Update THANKS.

commit 453e6070ddfab2157f52536bdd7a79fc16f851f4
Author: Todd C. Miller <Todd.Miller@courtesan.com>
Date:   Thu Sep 28 16:39:59 2017 -0600

    Fix parsing of -b flag
    
    Only the short -b option is missing, --batch works as expected.

commit af81c436d6e11a53803747af7cc8ecfd449ccd4c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 21:56:17 2017 +0200

    Releasing 1.1pre15.

commit 4e5c2193a1fa1ed054956fc0b1df387b19c546a5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 21:55:47 2017 +0200

    Drop h and hh length modifiers from printf format strings.

commit 91d50f8b375503be6b6081985f5948773d64b9d3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 21:54:34 2017 +0200

    Ensure packet priority is cleared when sending PMTU probe replies.
    
    Found by the Clang static analyzer.

commit 00d81ee6236e76f80b84372ac5c635636ad48136
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 21:52:44 2017 +0200

    Fix a file descriptor leak when using an invitation.
    
    Found by cppcheck.

commit a073b2cb0bca646685a83479db6b66d518240bc5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 21:06:25 2017 +0200

    Fix a compiler warning.

commit 843990d8df0c060db9b64e170996e9d49c8c921d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 17:24:05 2017 +0200

    Force IPv4 for sptps-basic.test.
    
    Allow forcing either IPv4 or IPv6 for sptps_test, and use IPv4 for the
    sptps-basic test. Since sptps_test is only opening a single listening
    socket, and you cannot control which address family it uses, this gets
    around a problem where the listening side is using a different address
    family than the one connecting to it.

commit 5f89950f47a9cf73169e797d4e2d6ef8b7f74a5a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Sep 2 17:04:25 2017 +0200

    Add missing break statements.

commit 92fdabc439bdb5e16f64a4bf2ed1deda54f7c544
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Aug 22 20:51:44 2017 +0200

    Make autoconnect try to heal network splits.
    
    When we have less than three connections, we greedily try to connect to any
    viable node. However, once we have three connections, try to connect to
    nodes that we know of but that aren't reachable.
    
    We also make sure that if there are 100 reachable nodes, and 1 unreachable
    one, that not all 100 reachable nodes try to connect to the unreachable
    at the same time.

commit 7c223917cb3d478fc3f5b23ee5602925f083e4d4
Author: pacien <pacien.trangirard@pacien.net>
Date:   Tue Aug 15 19:56:06 2017 +0200

    Add LogLevel config option

commit e4544dbc6989e4a146c19519924e52c116bfc343
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jul 27 10:06:13 2017 +0200

    Forward-port tinc 1.0's handling of device errors.

commit d73cdee5df3e6c7395270c69e944b3c853f013ae
Author: volth <volth@webmaster.ms>
Date:   Thu Jul 27 06:32:28 2017 +0000

    Avoid infinite loop on EBADFD
    
    On Linux network restart, Tinc can get into a loop writing millions of error messages "Error while reading from Linux tun/tap device (tun mode) /dev/net/tun: File descriptor in bad state" to the log. https://github.com/NixOS/nixpkgs/pull/27675
    
    It should be somehow aborted.
    Here is my quick hack.

commit acefa66dbd97617d86dee270b2b95ecdb763434b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 9 16:12:55 2017 +0200

    Store the invitation data after a succesful join.
    
    This can be used by the invitee to examine the file after a join, and
    process it in different ways than the tinc CLI does.

commit cd854fa86a9dc177dcaa56fa774afb127b29651a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 9 15:57:51 2017 +0200

    Add configurable experation time for invitations.

commit 93584bc1cad7c7cc9c95859a8cde548bc18b6fa8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 28 12:48:32 2017 +0200

    Set KillMode=mixed in the systemd service file.
    
    This ensures only the main process is sent the SIGTERM, and not anything
    else that might have started in the same control group, including the
    tinc-down script.
    
    Closes #145 on GitHub.

commit 970799aa3406c22a575f665d3964c15d7c9ab555
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 28 12:26:44 2017 +0200

    Move logging of "would block" messages to debug level 4.

commit 3d8a8363544bfcf75a9124251eff0caae3a8f1a2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 7 15:29:22 2017 +0200

    Remove unused add_scalar function.

commit 958a751e20270da821fee651ff9ecda8a2afc5d0
Author: thorkill <thkr@hannover.ccc.de>
Date:   Thu May 4 23:44:56 2017 +0200

    Fix NULL pointer dereference in send_udp_info

commit 9527f4f22cd71feeee8a49866e29cce98408f1e7
Author: thorkill <thkr@hannover.ccc.de>
Date:   Mon May 1 12:40:22 2017 +0200

    Sanitize input in id_h - prevent integer overflows

commit 18646deca120f0ccc3bfad643dba83547ecc2f20
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Apr 18 20:09:38 2017 +0200

    Fix some minor issues found by cppcheck.

commit 060ab1cd7cdf750a0477f2a8b6193d28849877e8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Apr 18 20:09:08 2017 +0200

    Add field widths to sscanf() calls.
    
    Found by cppcheck.

commit be8e5cbd1cfcd198f975542e52085abdd543ec80
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Apr 18 20:07:33 2017 +0200

    Remove dead stores.
    
    Found by the Clang static analyzer.

commit 70fed5f7ffdeb0416ee6b77881098faab9a7cd47
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 16:05:30 2017 +0200

    Add missing tinc stop command to the scripts test.

commit a14414731925cd59e64b3a90309b5a9ec60ac690
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 13:54:02 2017 +0200

    Fix tests on *BSD.

commit db80dbbac93ce3c714247e0af2147f5e1474a135
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 13:53:48 2017 +0200

    Fix segfault when adding environment variables.

commit 1be0c284c7c8d34c2dd6c2160ce49aeae468e867
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 13:07:15 2017 +0200

    Fix compiler warnings on *BSD.

commit 2b4c0c63628ff9b432ec5d4b4c7b7ab2d4b02fb2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 13:02:39 2017 +0200

    Make sure realname is always initialized.

commit c87a77b5fd2a0378f2b992a5d579a80ee4033cec
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 17 12:50:30 2017 +0200

    Ensure tests compile on *BSD.

commit 95f09569beb2e304e6a2112d20cee6fab88f3729
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 8 13:34:40 2017 +0200

    Use getmsg()/putmsg() instead of read()/write() on Solaris.
    
    This fixes a problem where read() returns packets from the IP layer before
    fragmentation is done.
    
    # Conflicts:
    #       src/solaris/device.c

commit 6011197be5cdb18aa79713990d6a1887b9261d12
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 8 13:31:04 2017 +0200

    Use /dev/udp instead of /dev/ip on Solaris.
    
    # Conflicts:
    #       src/solaris/device.c

commit 9a113db0a61242a0273a7ac95dd536f3a4bdb581
Author: Guus Sliepen <guus@sliepen.org>
Date:   Wed Mar 29 08:08:56 2017 +0200

    Ensure sptps_keypair and sptps_test get build for make check.

commit d9a7f2d1054a7155b5f23855ba28dd98e0df73be
Author: Guus Sliepen <guus@sliepen.org>
Date:   Wed Mar 29 08:08:19 2017 +0200

    Use 127.0.0.1 instead of localhost to ensure tests are reproducible.

commit 3ab1893a4b6c2895075ac889cf06c511e2001a9e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 17:54:37 2017 +0200

    Ensure proper logging in the invite-offline test.

commit 0af3dcf7a838dede699194c02444f1607644bb28
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 17:43:33 2017 +0200

    Add the scripts test.
    
    This test whether all the scripts are run with the right information in
    the right order.

commit ebade1e8f80ebaa476f701089da7ae654837397c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 16:48:02 2017 +0200

    Update .gitignore.

commit fd3ec60757a84b7551e03b3a48dd30f35015c448
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 16:47:54 2017 +0200

    Add the invite-offline test.
    
    This tests generating an invitation on the server while no tinc daemon is
    running.

commit 5fcf6e16acccdaac573eebae21a5a47294e346e4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 16:46:31 2017 +0200

    Remove superfluous sleep command in invite-join test.

commit ccb4fb6f7ac2efbb99d044aa072e75c035f504aa
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 26 16:46:03 2017 +0200

    Use unique ports for all tests.

commit add75303e918af5e94ff545d969872799fac5cef
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 21 21:25:27 2017 +0100

    Add DEBUG environment variable for scripts.
    
    This contains the current debug level used by tinc. Scripts can use it
    to decide whether to log debugging information of their own.
    
    Closes #138 on GitHub.

commit 5cbef906209eb5005f821af8f55a6f5d7e7d060c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 21 21:21:23 2017 +0100

    Put script environment creation/deletion in functions.
    
    This makes environment handling safer, and also has a single place where
    we can add new environment variables that should be present for all
    scripts.

commit 3e643d5d7e5c7db35eacb3703d497c584e93cf18
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Wed Oct 12 13:52:17 2016 +0200

    route: Support ToS/DiffServ priority inheritance when routing IPv6 packets.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>

commit aebaaa8db80ec3931346af710f2182d129c74c41
Merge: 2c333f0f d21d97ea
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Mar 20 22:33:18 2017 +0100

    Merge remote-tracking branch 'dechamps/sleep' into 1.1

commit 2c333f0f45f445d0811a364817d03df0c8cf2d2f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Mar 20 22:19:36 2017 +0100

    Don't try to use kill() on Windows.

commit 26dc50599d6e38be1e7304602ffea0ba282c1091
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Mar 20 22:15:20 2017 +0100

    Add missing #defines used by fd_device.c.

commit 3fc678a8df4d6c057ef9f2c602b86ed106651e68
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Mar 7 19:19:19 2017 +0100

    Use free_known_addresses() to free memory allocated by get_known_addresses().
    
    We know what struct addrinfo looks like, but the standard says nothing
    about how it is allocated. So we cannot trust freeaddrinfo() to work
    correctly on the struct addrinfo list we allocated ourselves in
    get_known_addresses(). To make a distinction by allocations from the
    latter and from str2addrinfo(), we keep two pointers (*ai and *kai) in
    struct outgoing, and use the freeing function that is appropriate for
    each.

commit ef661316f163f2ecf6c75a3dd28e2cad51772c56
Author: Roman Savelyev <roman@savelyev.net>
Date:   Tue Mar 7 19:07:19 2017 +0100

    Fix lost pointer trails in get_known_addresses().

commit 7a54fe5e884e98ade91af527c67f9c5df1452a50
Author: Pacien TRAN-GIRARD <pacien.trangirard@pacien.net>
Date:   Mon Feb 27 20:56:55 2017 +0100

    Add fd_device

commit 4a45a65fe2555efc5b6763a293d30251755e78a8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Feb 14 20:51:43 2017 +0100

    Remove the description of the LocalDiscoveryAddress option from the manual.
    
    This option is no longer implemented.

commit d3cc96b027a919e22bbf06d634edb0a2a069ac92
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jan 31 12:05:03 2017 +0100

    Don't build sptps_* binaries by default.

commit 88d158e15b9e16b4227b374d8bb4640010670cef
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jan 31 12:03:27 2017 +0100

    Fix potential segfault in the replacement vasprintf() function.

commit 06b820133285f83f7e1a839cccbed13358b84081
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 18 14:53:33 2016 +0000

    Fix address memory leaks in add_edge_h().
    
    Note that this is not as bad as it looks, because in practice
    sockaddrfree() is a no-op for typical address types.

commit 02093b12b0133b51dd04613c94c762ad2761cd3c
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 18 14:32:25 2016 +0000

    Clarify the flow of add_edge_h().
    
    This is an attempt at making the control flow through this function
    easier to understand by rearranging branches and cutting back on
    indentation levels.
    
    This is a pure refactoring; there is no change in behavior.

commit 3bf3d7d3e7d51034bda873861c52578f3abe6b5d
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 18 14:25:20 2016 +0000

    Fix edge updates containing local address changes.
    
    This commit fixes a logic bug in the edge update code where local
    address changes are not taken into account if they are bundled in with
    other changes. This bug breaks local discovery in some scenarios.
    
    The regression was introduced by commit
    e4670fc4a0576eb76f1807ce29fa9455dd247632.

commit 0792a10a5a66bcbf56185e479feed78252122667
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 18 16:56:27 2016 +0000

    Fix edge local addresses not being set when connections are established.
    
    This bug prevented nodes from advertising their local addresses, thus
    breaking local discovery.
    
    The regression was introduced in
    ab13c14a1480561bb9f59ccfbbd6045e0484ce9c.

commit d21d97eaf5db9e848d8eee28784c4f54af85f43d
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Dec 3 23:13:46 2016 +0000

    On Windows, don't cancel I/O when disabling the device.
    
    I have observed cases where disable_device() can get stuck on the
    GetOverlappedResult() call, especially when the computer is waking up
    from sleep. This is problematic when combined with DeviceStandby=yes:
    
        other_side (1.2.3.4 port 655) didn't respond to PING in 5 seconds
        Closing connection with other_side (1.2.3.4 port 655)
        Disabling Windows tap device
        <STUCK>
    
    gdb reveals the following stack trace:
    
        #0  0x77c7dd3c in ?? ()
        #1  0x7482aad0 in KERNELBASE!GetOverlappedResult () from C:\WINDOWS\SysWoW64\KernelBase.dll
        #2  0x0043c343 in disable_device () at mingw/device.c:244
        #3  0x0040fcee in device_disable () at net_setup.c:759
        #4  0x00405bb5 in check_reachability () at graph.c:292
        #5  0x00405be2 in graph () at graph.c:301
        #6  0x004088db in terminate_connection (c=0x4dea5c0, report=true) at net.c:108
        #7  0x00408aed in timeout_handler (data=0x5af0c0 <pingtimer>) at net.c:168
        #8  0x00403af8 in get_time_remaining (diff=0x2a8fd64) at event.c:239
        #9  0x00403b6c in event_loop () at event.c:303
        #10 0x00409904 in main_loop () at net.c:461
        #11 0x00424a95 in main2 (argc=6, argv=0x2b42a60) at tincd.c:489
        #12 0x00424788 in main (argc=6, argv=0x2b42a60) at tincd.c:416
    
    This is with TAP-Win32 9.0.0.9. I suspect driver bugs related to sleep.
    In any case, this commit fixes the issue by cancelling I/O only when the
    entire tinc process is being gracefully shut down, as opposed to every
    time the device is disabled. Thankfully, the driver seems to be
    perfectly fine with this code issuing TAP_IOCTL_SET_MEDIA_STATUS ioctls
    while there are I/O operations inflight.

commit 1672dbd66b619f84cb86950298ad89df93e1dcba
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Dec 3 22:52:30 2016 +0000

    Fix crash on Windows when a socket is available for both write and read.
    
    Currently, if both write and read events fire at the same time on a
    socket, the Windows-specific event loop will call both the write and
    read callbacks, in that order. Problem is, the write callback could have
    deleted the io handle, which makes the next call to the write callback a
    use-after-free typically resulting in a hard crash.
    
    In practice, this issue is triggered quite easily by putting the
    computer to sleep, which basically freezes the tinc process. When the
    computer wakes up and the process resumes, all TCP connections are
    suddenly gone; as a result, the following sequence of events might
    appear in the logs:
    
        Metadata socket read error for node1 (1.2.3.4 port 655): (10054) An existing connection was forcibly closed by the remote host.
        Closing connection with node1 (1.2.3.4 port 655)
        Sending DEL_EDGE to everyone (BROADCAST): 13 4bf6 mynode node1
        Sending 43 bytes of metadata to node2 (5.6.7.8 port 655)
        Could not send 10891 bytes of data to node2 (5.6.7.8 port 655): (10054) An existing connection was forcibly closed by the remote host.a
        Closing connection with node2 (5.6.7.8 port 655)
        <CRASH>
    
    In this example the crash occurs because the socket to node2 was
    signaled for reading *in addition* to writing, but since the connection
    was terminated, the attempt to call the read callback crashed the
    process.
    
    This commit fixes the problem by not even attempting to fire the write
    callback when the write event on the socket is signaled - instead, we
    just rely on the part of the event loop that simulates level-triggered
    write events. Arguably that's even cleaner and faster, because the code
    being removed was technically redundant - we have to go through that
    write check loop anyway.

commit 979acc48aded5bb04f1574128d174d56550be302
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 30 15:19:12 2016 +0100

    Enforce maximum amount of bytes sent/received on meta-connections.
    
    This is 2^{block_length_in_bits / 2 - 1}.

commit edc1efed3c0cf5aebb1c765066c0413757229a31
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Oct 30 15:17:52 2016 +0100

    Use AES256 and SHA256 by default for the legacy protocol.
    
    At the start of the decade, there were still distributions that shipped
    with versions of OpenSSL that did not support these algorithms. By now
    everyone should support them. The old defaults were Blowfish and SHA1,
    both of which are not considered secure anymore.
    
    The meta-protocol now always uses AES in CFB mode, but the key length
    will adapt to the one specified by the Cipher option. The digest for the
    meta-protocol is hardcoded to SHA256.

commit fcaf158494af7cb015d8658a3241c324518e8d7f
Author: Dennis Lan <dennis.yxun@gmail.com>
Date:   Wed Oct 12 13:35:39 2016 +0200

    Fix typo in src/upnp.c.

commit 9cbd3c2b5b03c29c116a14f196db8a32c7135391
Author: Vittorio G (VittGam) <github@vittgam.net>
Date:   Tue Oct 11 20:30:41 2016 +0200

    tincctl: Avoid falling back to 1024 bits RSA key generation when an invalid key size is specified.
    
    Also warn the user if a key smaller than 2048 bits is being generated.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>

commit c7c5c74d4af7442b92d863fc9eb04395c456b0be
Author: Vittorio G (VittGam) <github@vittgam.net>
Date:   Tue Oct 11 13:30:05 2016 +0200

    fsck: Fix ed25519 public key reading, and fclose usage.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>

commit e6497a23f7689663aa2c19311a278e20661bddc1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jul 26 16:47:45 2016 +0200

    Log warnings about dropped packets only with debug level 5 or higher.

commit 2784a171ec39e2a34aabf8194a651de570e19e0e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jul 14 19:15:35 2016 +0100

    Fix error handling when setting up the UDP socket.
    
    Due to this typo, if tinc managed to set up the TCP socket but not the
    UDP socket, it would continue anyway.
    
    The regression was introduced in
    6bc5d626a8726fc23365ee705761a3c666a08ad4.

commit b1c29464b68d756035acc4b4d1681f05d8831eaf
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jun 24 11:22:24 2016 +0200

    Fix compiling with OpenSSL < 1.1.0.

commit 9a9f6fac009caf31c3786e13231eb05b3bad0681
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Jun 24 11:22:11 2016 +0200

    Add missing m4 files.
    
    ax_cflags_warn_all.m4 depends on them.

commit b9b0defaf422bcc1272f87d791d9ac53c9539734
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jun 23 15:59:43 2016 +0200

    Fix potential memory leaks found by the Clang static analyzer.

commit 49edf9c53a31714b740d0ee67c29aca503973d81
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jun 23 15:59:16 2016 +0200

    Fix warnings from the Clang static analyzer.
    
    These are all false positives or harmless dead stores.

commit e16ab7b89948c24a2c47652e8eb1a817a4b1424c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jun 23 15:26:58 2016 +0200

    Force nul-termination of strings after vsnprintf().
    
    Apparently, on Windows this function might not always be properly
    terminated.

commit 2de5d866b5e4d4e6b827dcfb985c24edbda71f4f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 22 23:08:30 2016 +0200

    Use EVP_MD_CTX_destroy() instead of _free().
    
    Thanks to azrdev for pointing out the build failure on Fedora 23.

commit 9b148fd844587fbf956e28f57e4bd39a11edc07f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 22 17:42:25 2016 +0200

    Check return value of RSA_generate_key_ex().

commit 172763f4af4340ac2c2549e8fbb7490f5f995d47
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 22 17:35:12 2016 +0200

    Add -Wall to CFLAGS.

commit 323c17e232539f3f06e7cebc664ab48f60127e0e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 22 16:32:05 2016 +0200

    Ensure compatibility with OpenSSL 1.1.0.

commit 74eb4cc974f6d24370f439a1761dc4412d7fa58d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 5 15:20:57 2016 +0200

    Fix the previous commit.

commit ab13c14a1480561bb9f59ccfbbd6045e0484ce9c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 5 14:47:21 2016 +0200

    Preserve IPv6 scope_id in edges.
    
    When creating an edge after authenticating a peer, we copy the
    address used for the TCP connection, but change the port to that used
    for UDP. But the way we did it discarded the scope_id for IPv6
    addresses. This prevented UDP communication from working correctly when
    connecting to a peer on the same LAN using an IPv6 link-local address.
    
    Thanks to Rafał Leśniak for pointing out this issue.

commit e47fe48aed76bfd7d2cb957e402a8cdcb0c84759
Author: Sean McVeigh <sean@vger.beerbot.ca>
Date:   Sat May 21 17:38:14 2016 -0400

    fix check in cmd_pid() for failure to connect to tincd

commit 4314df644e22778a554ca1760941a2bfae08bce2
Author: Sean McVeigh <sean@vger.beerbot.ca>
Date:   Sat May 21 17:25:18 2016 -0400

    check for daemon pid existence before trying to connect to the control socket, and clean up stale files otherwise.

commit 9d0e86683cdb7d53263569ad2e49dd87bd217939
Author: lemoer <git@irrelefant.net>
Date:   Thu May 19 17:24:31 2016 +0200

    Added comments and unfold deep "if"-construct in timeout_handler

commit 5baecfd11be67bb80aab6c482e0b0ac98b267cca
Author: thorkill <thkr@hannover.ccc.de>
Date:   Thu May 19 15:48:15 2016 +0200

    Prevent tincd from sending packets to unexpecting nodes
    
    Make tincd recognize when it was asleep and close connections to it's
    peers. This happens when e.g. RoadWarrior has been suspended for
    "longer" time period. After resume, it will start to communicate
    with it's peers using the contextes it had before suspend.
    
    On the other side, the nodes closed the connections since PingTimeout
    and/or TCP connection went down.
    
    Sending data to such unaware (sptps mostly) nodes will cause
    havoc in the logs. Misleading the developers to wrong assumptions
    that something is wrong with sptps.
    
    # Conflicts:
    #       src/net.c

commit 0cf943753ab16704c818bebe74b4e7ea96399b05
Author: thorkill <thkr@hannover.ccc.de>
Date:   Wed May 11 19:27:05 2016 +0200

    Send PKT_PROBE only when handshake has been done already.

commit 0edef996a6d944e9143f87dd3c72390979c33630
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 1 20:35:26 2016 +0200

    Releasing 1.1pre14.

commit 3f6c663a06aac728912c4e47cbc2dc4343a3798c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 1 12:07:44 2016 +0200

    Revert "Remove tinc.service, it is not necessary."
    
    This reverts commit 0b6f84f96eeed20a0d771fedb72c0e19941adb7e. Although
    systemd does automatically provide a "tinc.slice" when there is only a
    tinc@.service template, it doesn't quite work the same way as
    tinc.service.

commit 0a6d89acc6417399dcf95efd68553d21e1f744e3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 30 20:55:12 2016 +0200

    Releasing 1.1pre13.

commit 2055c3e21d5b3f4217883d52d5e5b0fbad504785
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 30 20:05:22 2016 +0200

    AutoConnect now only chooses from nodes for which we know an address.
    
    Based partially on work from Rafał Leśniak.

commit 0b6f84f96eeed20a0d771fedb72c0e19941adb7e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 30 18:08:31 2016 +0200

    Remove tinc.service, it is not necessary.
    
    Thanks to Alexander Ried for pointing out that if you have
    tinc@.service template, systemd will provide a default slice containing
    all instances of that template. So "systemctl start tinc" will still do
    what we want it to do.

commit 8377d0b8569b8d5240ad88683ad527c67237617a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Apr 27 20:30:36 2016 +0200

    Fix BSD tun device support.
    
    This was broken by a botched merge from the master branch in commit d7f6737.

commit 390d25f0b80dd7418e147de3561c70461628574d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 24 13:23:06 2016 +0200

    Releasing 1.1pre12.

commit 5a7c6546a46bdcc97cf73a9aef206d2a83bb1eb4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 21:39:53 2016 +0200

    Don't check file permissions on Windows during fsck.

commit 83fa44ce42c67837dad30ba1538bf1fa8c49a47d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 21:32:42 2016 +0200

    Fix starting tinc as a service on Windows.
    
    Don't assume tincd.exe is in the working directory, especially now that
    chdir() is called very early. We use GetModuleFileName() instead.

commit 9a66d7499ae2c838c25f9c6bfcc277c3fa231dea
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 21:32:29 2016 +0200

    Fix a compiler warning on Windows.

commit ab5f4cbdc65cbc55062b36a6c11482c217884fe8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 17:28:30 2016 +0200

    Fix possible read of freed memory when verifying the signature of a file.

commit 76955a6c8b7a76d00ed401853c9d283e32d9ce1c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 17:20:08 2016 +0200

    Have "tinc fsck" recognize Ed25519PublicKey statements.

commit 6805b157312c1f9adeee0035f540f4cbd63a79fd
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 23 16:05:41 2016 +0200

    Move documentation of invitations to the manual.

commit 51a0dc51451897cc0290d5040e42616dda9bdc8a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 18:11:04 2016 +0200

    Fix the "network" command in tinc shell.

commit b6b302cee9de92d157f73d7739cc259d269c0ca0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 17:06:11 2016 +0200

    Speed up AutoConnect at startup.
    
    Call periodic_handler() immediately at startup. Also, don't try to
    connect to ourself.

commit f934417aa658367587dadc81bd5c466baef407ef
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 16:23:31 2016 +0200

    Don't call terminate_connection(myself->connection).
    
    It doesn't do anything except give a confusing error message that we are
    closing the connection to ourself. Replace it with connection_del().
    This also fixes a double free.

commit 2213ecaea550ce81c595464ad4347414bcb5d786
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 16:01:49 2016 +0200

    Handle special characters in sptps_test only if the --special option is given.
    
    sptps_test treats lines starting with #, ^ and $ specially, in order to
    test the SPTPS protocol. However, this should only be done if explicitly
    requested, otherwise it can unexpectedly fail.

commit c2dc3784f127ef6db6e9960a4abecc1aab6f4e31
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 14:38:37 2016 +0200

    Add stricter checks for netnames.
    
    When passing a NetName via an invitation, we don't allow any characters
    that are unsafe (either because they could cause shells to expand things,
    or because they are not allowed on some filesystems).
    
    Also, warn when tinc is started with unsafe netnames.

commit 097c69fc6a223213302fe9ffbe00a4c05357e660
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 14:36:29 2016 +0200

    Use ifconfig_header().

commit af9ee7ff003fb448b783ccf39347907adc239cb2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 14:04:57 2016 +0200

    Chdir() to the configuration directory instead of /.

commit 9bd978cc8ebf2fd9075f2be646fafd90128d403f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 13:56:37 2016 +0200

    Add a test for tinc-up creation from invitations.

commit 0b96b6967256803c739a6b0a89d54ab8d6f63335
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 13:55:36 2016 +0200

    Fix compiler warnings.

commit a08860ff8c2ad859836ed51c5629d6a85343e802
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 13:55:18 2016 +0200

    Fix gateway parsing in invitation files.

commit 6d0452896673c36226c24144d4bde824a49c3950
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 13:23:01 2016 +0200

    Allow gateways to be specified for routes.
    
    Also improve the variable names, and ensure the % symbols in
    %INTERFACE% are properly quoted.

commit 03878f12150cbdb1aeb43e207404a0929a35ff13
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 01:13:56 2016 +0200

    Move some stray #includes.

commit 3273e3254107a4b89cd9963012d5fac8927c417c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 17 01:13:27 2016 +0200

    Generate a tinc-up script from an invitation.
    
    This adds the ability for an invitation to provision an invitee with a
    tinc-up script. This is quite strictly controlled; only address configuration
    and routes are supported by adding "Ifconfig" and "Route" statements to
    the invitation file. The "tinc join" command will generate a tinc-up script
    from those statements, and will ask before enabling the tinc-up script.

commit b2200f216658e07ab4e45592fa7de012a2ed96df
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 16 22:06:47 2016 +0200

    Document how invitation files work.
    
    This should eventually be merged in to tinc.texi.

commit a31e1f03c4eff16403178695d971a0838996ba2e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 16:56:56 2016 +0200

    Stop using SOL_TCP, SOL_IP and SOL_IPV6.
    
    Instead, use IPPROTO_TCP, _IP and _IPv6. This fixes an issue on OS X where
    it didn't create an UDP socket that listened on IPv4.

commit a0a8f8f81fc8da068e93088c7c13f689a96fac66
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 16:30:45 2016 +0200

    Fix crash at startup when Device is not specified on OS X.

commit 8afb52a39a72805cd24b6979248135e0d8b17c32
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 14:27:52 2016 +0200

    Fix conditional checking of tun/tap headers on DragonFly BSD.

commit 039d6d48afe00a0fa9e11bcdbfea8e996cce4ad0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 12:42:30 2016 +0200

    Fix some compiler warnings from MinGW.

commit 1f5c26102e228420fd954af1d73d3a89fc700d9d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 12:30:01 2016 +0200

    Fix generation of version_git.h for some versions of BSD make.
    
    In order to support VPATH builds, we have to use ${srcdir}/version.c as
    the target for the rule that depends on the generation of version_git.h.
    When not doing a VPATH build, ${srcdir} expands to ".", so the target
    will be "./version.c". However, on some BSDs, make does not understand
    that "./version.c" is the same as "version.c", and therefore it doesn't
    trigger generating version_git.h when trying to build version.o. (It
    works fine if you do a VPATH build, and OpenBSD's make does the right
    thing in all cases.)
    
    The trick is to have version.c depend on ${srcdir}/version.c. Of course,
    Linux's make knows this is nonsense and will complain about a circular
    dependency, so add this rule only on BSD platforms.

commit 0037ec7cb38994dda6ab5e4fa85ce595b9a59f6b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 12:29:31 2016 +0200

    Fix a non-working cast to get rid of a compiler warning.

commit 25bcdad878eb7349d19ea877fdcc058d4c6b2242
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 11:38:56 2016 +0200

    Don't use HAVE_SYSTEM, the autoconf check was removed.

commit cd5f222cc4e769395a7c6c8646abefe1d657f844
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 11:25:18 2016 +0200

    Remove use of strcpy() and sprintf().
    
    Even though they were safe, compilers like to warn about them nowadays.

commit d4410d0cce40929db9a0ce7042ef962f1867234d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 11:10:50 2016 +0200

    Don't assume sa.sa_family is a short int.
    
    Because FreeBSD's compiler complained about it.

commit d704a89ecc0811eb0cdac4e4be8ff3bdb0838976
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 15 11:00:14 2016 +0200

    Add version_git.h and sample-config.tar.gz to CLEANFILES.

commit 3cceae93f61a44d4f9f38d729555b2f31e209beb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 23:51:18 2016 +0200

    Make some platform-specific header checks conditional.
    
    Don't check for linux/if_tun.h on BSD platforms for example.

commit d10834e92015f1e0e5bf74e03b161b3a5dc363fb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 23:24:22 2016 +0200

    Remove support for Windows 2000 and anything that doesn't support getaddrinfo().

commit 615ecb7a8a6e0ffc8d37f08fe46d5c50cef8b3e0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 23:10:59 2016 +0200

    Remove checks for non-C99 compliant compilers.

commit ed09fa4e03c907736b2be0a831d10863ce4cae84
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 23:01:18 2016 +0200

    Fix version_get.h generation on BSD.
    
    It doesn't like .PHONY rules that are actually doing stuff. So make a really
    phony rule that does nothing and depend in it in the version_git.h rule.

commit 2802b3a49797a0f58d6a8f4d9945d54acc64d996
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 22:59:42 2016 +0200

    Fix typo in Makefile.am.

commit 46ebfbb6eb9966239f7826e002d99554420bbbc8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 17:29:25 2016 +0200

    Use getcwd() instead of get_current_dir_name().

commit b5b04910b928c63a31a0859f04bf067ca9bd1cc2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 17:20:36 2016 +0200

    Replace usleep() with nanosleep().

commit 491839a81aba00d4af50b66563cedaac4fa7028c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 17:05:10 2016 +0200

    Fix compiling under MinGW.

commit 34ea20af73a35cd918ce9dc25796bebf9493b49c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Apr 14 17:03:01 2016 +0200

    Remove checks for headers and functions that are in C99.

commit fd3800324f4e4c67b087eaf5e0a61a184a270812
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Apr 13 15:34:16 2016 +0200

    Make text files Markdown-compatible.

commit 7f749c7e75c08549d7ce43838622624a8093de85
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 11 15:28:26 2016 +0200

    Update .gitignore.

commit 9ba3e95a9a559240d16de71ca1513c7bfa98a70c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 11 15:27:08 2016 +0200

    Remove elliptic curve stubs from gcrypt/, add PRF implementation.

commit 20dd1c21dc6d238200e62a1111a7d0d145168548
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 8 17:49:49 2016 +0200

    Really don't compile getopt*.c if the system provides getopt_long().

commit 9527622abc75ef41498de70ed6ded6bf5b38cfac
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Apr 9 22:17:47 2016 +0200

    Enable silent builds by default.
    
    Cleaner build messages make it easier to spot compiler warnings and errors.
    Use make V=1 to get the verbose output back.
    
    # Conflicts:
    #       configure.ac
    #       doc/Makefile.am

commit 413faffca356b25cf69ddf0a718730d46f9941bc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 15:04:59 2016 +0200

    Update links in the documentation.
    
    # Conflicts:
    #       doc/tinc.conf.5.in
    #       doc/tinc.texi
    #       src/avl_tree.c
    #       src/avl_tree.h

commit 5cbc12b3d482231fc7e71fbe176c91971993760e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 14:47:21 2016 +0200

    Explicitly mention that LibreSSL can be used as well.
    
    # Conflicts:
    #       doc/tinc.texi
    #       m4/openssl.m4

commit d7f6737cfcae75e8c2f522c68aaedee0519a6131
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 11 14:49:51 2016 +0200

    Update support for BSD tun/tap devices, add support for OS X utun interfaces.

commit 2a7871990bc401921b8bb9accbc6a8206d564f72
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Nov 1 21:07:56 2015 +0100

    Update "now" after connect() when making outgoing connections.
    
    It could be that address resolution takes a long time, don't let that
    count against a connection. This is especially important when using a
    nameserver from the VPN.
    
    # Conflicts:
    #       src/net_socket.c

commit cadbf587a09bd4adde664cd635b962315228b3f5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 3 20:06:12 2015 +0200

    Never call putenv() with data on the stack.
    
    Even though we are using putenv() here to remove items from the
    environment, there is no guarantee that putenv() doesn't add the
    argument to the environment anyway. In that case, we have to make sure
    that it doesn't go away. We also don't want a memory leak, so keep a
    list of things we unputenv()ed around, so we can reuse things.
    
    Thanks to Poul-Henning Kamp for pointing out this problem.
    
    # Conflicts:
    #       src/process.c

commit 0e8e53b4cee8f1ea27bad501cbc18292ced54fa1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Apr 14 11:20:24 2015 +0200

    Fix --logfile without a filename on Windows.
    
    On Windows, the log filename now defaults to "tinc.log" in the same
    directory as tinc.conf.
    
    # Conflicts:
    #       src/tincd.c

commit c544e5e8fe22250b230a46f0340483db5403a6c1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 17:22:41 2016 +0200

    Support ToS/DiffServ for IPv6 meta and UDP connections.
    
    Also remember ToS/DiffServ priority for each socket individually. This
    is a port of commits c72e237 and 042a6c1.

commit e355088535ee9ebb12a4db0043bf6a9743085b28
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 8 18:09:30 2016 +0200

    Use iface instead of interface.
    
    This was accidentally added in commit 2f03a5d.

commit 6f97c0011572a1e12fa6267068b7f3fd46ceffd8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 17:01:04 2016 +0200

    Update THANKS.

commit 8be447ac0227a8ecb89facb2831c121a7ca81748
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 16:51:03 2016 +0200

    Update .gitignore.

commit 9f0fb224a6c2eab93b6917ef6c034423c49126cd
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 8 17:49:49 2016 +0200

    Don't compile getopt*.c if the system provides getopt_long().
    
    # Conflicts:
    #       configure.ac
    #       src/Makefile.am
    #       src/tincd.c

commit c2726dae62d632883f822741f9619265640e57b3
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 10 16:38:45 2016 +0200

    Fix typo.
    
    Found by LunarShaddow.

commit e44c337eae674120745f7c7c56a1a70919ff40ca
Author: LunarShaddow <aflyhorse@hotmail.com>
Date:   Mon Mar 7 15:43:04 2016 +0800

    re-arrange include sequence to avoid a mingw introduced bug.
    refers: https://www.cygwin.com/ml/cygwin/2012-12/msg00194.html
    
    # Conflicts:
    #       src/cygwin/device.c

commit af83d0b9e87fe795a3d01d0ee3fb35e0d8579b88
Author: LunarShaddow <aflyhorse@hotmail.com>
Date:   Mon Mar 7 15:42:34 2016 +0800

    fix typo

commit bf50b3502a022b406424d0d03aaf7670133452b2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 28 16:38:49 2016 +0100

    Fix for botched cherry-pick commit 60fb230.

commit 1ceea259c3ba5efb9b8b12161e75256270ba4804
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Feb 27 14:46:01 2016 +0100

    Add warnings for bad combinations of Device and Interface.
    
    On Linux, the name of the tun/tap interface can be set freely. However,
    on most other operating systems, tinc cannot change the name of the
    interface. In those situations, it is possible to specify a Device and
    an Interface that conflict with each other. On BSD, this can cause
    $INTERFACE to be set incorrectly, on Windows, this results in a
    potentially unreliable way in which a TAP-Win32 interface is selected.
    
    # Conflicts:
    #       src/bsd/device.c

commit e3f80e9167ecef8db8add9359b6660ecdcaeb7af
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Feb 27 14:22:36 2016 +0100

    Small fixes for the documentation.
    
    # Conflicts:
    #       doc/tinc.texi

commit 72cfd4f047210cc7cab9014cbf48e007bfd704e6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Feb 27 14:21:53 2016 +0100

    Clarify that scripts are called synchronously.
    
    # Conflicts:
    #       doc/tinc.conf.5.in
    #       doc/tinc.texi

commit 4d7469e0da6652bddc8acde499068db4b41b646d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 28 16:28:28 2016 +0100

    Fix forwarding of edge updates.
    
    Commit e4670fc accidentily prevented ADD_EDGE messages from propagating
    in some cases.

commit 60fb2308e5bf1fd9ce642f6c4bcde81997593504
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Feb 27 14:18:20 2016 +0100

    Improve performance of edge updates.

commit 994adadf2752fd7515ee30ed5fdb91178a615fe9
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Fri Sep 25 16:51:51 2015 +0200

    Remove forward declaration for do_decrement_ttl.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>
    
    # Conflicts:
    #       src/route.c

commit 0f3ae1a9f29c845a69e44a4f691f43d6a6651583
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Fri Sep 25 15:35:28 2015 +0200

    s/broadcast_packet_helper/route_broadcast/
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>
    
    # Conflicts:
    #       src/route.c

commit 496f775568873bb769e48ceb644b15ab9f150d62
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Fri Sep 25 04:52:25 2015 +0200

    Fix DecrementTTL option for packets destined to the local node.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>
    
    # Conflicts:
    #       src/route.c

commit 17e54ea0bec4d3a3b9a760854dde6039c7a1c421
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Fri Sep 4 17:04:03 2015 +0200

    Try to reply with node address only when decrementing the TTL.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>

commit 92203bdbcb1af4a52c7ca9d0e1a271168435c905
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Fri Sep 4 04:00:57 2015 +0200

    Fix source IP address for ICMP unreachable packets generated by tinc.
    
    Try to send ICMP unreachable replies from an address assigned to the
    local machine, instead of the destination address of the original
    packet.
    
    The address is found by looking up the route towards the sender of
    the packet that generated the error; in usual configurations, this
    is the tinc interface.
    
    This also fixes the traceroute display in mtr when using the
    DecrementTTL option.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>
    
    # Conflicts:
    #       src/route.c

commit a8a3a2c8ceb19bcb6c2c3ef0647c94d7d0624b7a
Author: Vittorio Gambaletta (VittGam) <github@vittgam.net>
Date:   Thu Sep 3 16:02:50 2015 +0200

    Fix DecrementTTL option.
    
    The option was not actually working, as it could be seen on traceroute or mtr.
    
    The problem is that it was checking if the TTL was < 1 (so equal to 0) before decrementing it.
    
    This meant that a packet with a TTL of 1 was being sent with a TTL of 0 on the VPN, instead of being discarded with the ICMP error message.
    
    Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net>
    
    # Conflicts:
    #       src/route.c

commit ac9e32ff91ee2318c49808522f0c7d458c79eb44
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 28 15:48:19 2016 +0100

    Use nostdinc instead of overriding DEFAULT_INCLUDES.

commit 96dd6e5f6c6f3f7717102fb3b38759b6cc0c0555
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 5 16:03:03 2015 +0200

    Only check for -fno-strict-overflow if -fwrapv does not work.

commit 92f0c4db77a5e2733442491227625d0233f94a97
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Feb 28 15:39:41 2016 +0100

    Update .gitignore.

commit d8ca00fe40ff4b6d87e7e64c273f536fab462356
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jan 27 00:09:29 2016 +0100

    Add the ability to sign and verify files.

commit 7418e9077f84db10ef6bb082a375870a7130bd7d
Merge: 420989e4 b6ed5c13
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 17 23:29:23 2016 +0100

    Merge remote-tracking branch 'mweinelt/tinc-gui' into 1.1

commit 420989e4c3ff109c7d077b2f8c06506540f1c0bd
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jan 14 15:07:22 2016 +0100

    Only add a reflexive address when we're sure it's working.

commit cda5a477c8138226d184a176256d559971b4f7ed
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Dec 10 16:45:05 2015 +0100

    Use static buffers for recvmmsg(), initialize them only as needed.
    
    As suggested by Michael Tokarev.

commit e4fd81ed2d66b8fe3c2857244fe3da85c803cf60
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Dec 10 16:30:32 2015 +0100

    Add support for recvmmsg().
    
    Based on a patch from Samuel Thibault and input from Michael Tokarev.

commit cef40b8b978694fc0e7c02e292fcbb60806bf028
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Nov 26 11:29:54 2015 +0100

    list_delete() already free()s the deleted element.

commit 9fdf4278f8c8c1563d45205c9e9f1bc351bd814f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Nov 24 16:48:44 2015 +0100

    Don't leave dead outgoing_t's in the outgoing_list.
    
    If an outgoing connection cannot be made because no address is known for
    it, it should be removed from the outgoing_list, otherwise it will
    prevent it from being re-added later when we do know addresses for it.

commit c58eba587da3ac884c6c18b64c262aed8fd1c452
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Nov 22 18:57:59 2015 +0000

    Add upnp.h to tincd SOURCES.
    
    This was missing from 513bffe1fee07bcbcb50691e221874adc1507857.

commit 613d586afd22159cee57c9524218c7200f4f1096
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Nov 22 17:14:14 2015 +0000

    Don't unset validkey when receiving SPTPS handshakes over ANS_KEY.
    
    This fixes a hairy race condition that was introduced in
    1e89a63f1638e43dee79afbb18d5f733b27d830b, which changed
    the underlying transport of handshake packets from REQ_KEY to ANS_KEY.
    Unfortunately, what I missed in that commit is, on the receiving side,
    there is a slight difference between req_key_h() and ans_key_h():
    indeed, the latter resets validkey to false.
    
    The reason why this is not a problem during typical operation is
    because the normal SPTPS key regeneration procedure looks like this:
    
        KEX ->
        <- KEX
        SIG ->
        <- SIG
    
    All these messages are sent over ANS_KEY, therefore the receiving side
    will unset validkey. However, that's typically not a problem in practice
    because upon reception of the last message (SIG), SPTPS will call
    sptps_receive_record(), which will set validkey to true again, and
    everything works out fine in the end.
    
    However, that was the *typical* scenario. Now let's assume that the
    SPTPS channel is in active use at the same time key regeneration
    happens. Specifically, let's assume a normal VPN data packet sneaks in
    during the key regeneration procedure:
    
        KEX ->
        <- KEX
        <- (SPTPS packet, over TCP or UDP)
        <- KEX (wtf?)
        SIG -> (refused with Invalid packet seqno: XXX != 0)
    
    At this point, both nodes are extremely confused and the SPTPS channel
    becomes unusable with various errors being thrown on both sides. The
    channel will stay down until automatic SPTPS channel restart kicks in
    after 10 seconds.
    
    (Note: the above is just an example - the race can occur on either side
    whenever a packet is sent during the period of time between KEX and SIG
    messages are received by the node sending the packet.)
    
    I've seen this race occur in the wild - it is very likely to occur if
    key regeneration occurs on a heavily loaded channel. It can be
    reproduced fairly easily by setting KeyExpire to a short value (a few
    seconds) and then running something like ping -f foobar -i 0.01.
    
    The reason why this occurs is because tinc's TX code path triggers the
    following:
    
     - send_packet()
     - try_tx()
     - try_tx_sptps()
     - validkey is false because we just received an ANS_KEY message
     - waitingforkey is false because it's not used for key regeneration
     - send_req_key()
     - SPTPS channel restart (sptps_stop(), sptps_start()).
    
    Obviously, it all goes downhill from there and the two nodes get very
    confused quickly (for example the seqno gets reset, hence the error
    messages).
    
    This commit fixes the issue by keeping validkey set when SPTPS data is
    received over ANS_KEY messages.

commit 95935cecb6290fd13b1266a96be1b8f9c1c54d0f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Nov 21 19:41:14 2015 +0100

    Update THANKS file.

commit 0f6d34dc1b43edc6f5bea45c17ce2d6a417265f1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Nov 15 17:42:14 2015 +0000

    Try to ensure we build correctly against various libminiupnpc versions.
    
    Unfortunately, libminiupnpc has a somewhat... "peculiar" approach to
    backwards compatibility for their API, where they reserve the right to
    make breaking changes when they feel like it, forcing users to resort
    to #ifdefs to ensure they use the correct API. Sigh.
    
    Previously, tinc would only build against API versions <= 13, because I
    was doing my initial development using miniupnpc-1.9.20140610 which is
    the version that ships with Debian. The changes in this commit are
    required for tinc to build against more recent versions, from
    1.9.20150730 to the latest one at the time of this commit, 1.9.20151026.

commit 675e3b497bdc87f5a4dfdef7508cd2070850e69e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Nov 15 15:30:01 2015 +0000

    Allow tinc to be built with miniupnpc on Windows.
    
    Contrary to what I expected, it so happens that modern versions of MinGW
    include an implementation of pthread natively by default, so there is no
    need to introduce Win32-specific threading code. This means the only
    changes required to make UPnP work on Windows are just build parameter
    tuning.
    
    This commit forces MinGW to be built statically. This makes linking
    against miniupnpc simpler (otherwise we would have to handle the mess
    of dllimport & co.) and it also prevents libwinpthread from being linked
    dynamically (which it is by default), as this would require additional
    DLLs to be distributed. Since static linking is how tinc is
    traditionally built on Windows, I don't expect this to be a big deal.

commit 513bffe1fee07bcbcb50691e221874adc1507857
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Nov 15 13:40:07 2015 +0000

    Add UPnP support to tincd.
    
    This commit makes tincd capable of discovering UPnP-IGD devices on the
    local network, and add mappings (port redirects) for its TCP and/or UDP
    port.
    
    The goal is to improve reliability and performance of tinc with nodes
    sitting behind home routers that support UPnP, by making it less reliant
    on UDP Hole Punching, which is prone to failure when "hostile" NATs are
    involved.
    
    The way this is implemented is by leveraging the libminiupnpc library,
    which we have just added a new dependency on. We use pthread to run the
    UPnP client code in a dedicated thread; we can't use the tinc event loop
    because libminiupnpc doesn't have a non-blocking API.

commit 2bb567c6a31e333ebdd16d6d076ba9976e6ed4fb
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Nov 14 14:47:42 2015 +0000

    Add a new optional dependency on the miniupnpc library.
    
    The miniupnpc library is a lightweight UPnP-IGD client.
    
    http://miniupnp.free.fr/
    
    Contrary to other libraries, this dependency is disabled by default.
    This is because the library is somewhat obscure and is only tangentially
    useful, so enabling it by default would probably annoy most users.

commit bdd84660c756437cf3bc8f64adf612055acc84ea
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Nov 7 11:04:13 2015 +0000

    Make sure the packet source MAC address is always set.
    
    When tinc is used in router mode with a TAP device, Ethernet (MAC)
    headers are not present in packets flowing over the VPN; it is the
    node's responsibility to fill out this header before handing the
    packet over to the TAP interface (which expects such headers).
    
    Currently, tinc fills out the destination MAC address of the packet
    (otherwise the host would not recognize the packets, and nothing would
    work), but it does not fill out the source MAC address. In practice this
    doesn't seem to cause any real issues (the host doesn't care about the
    source address), but it does look weird when looking at the packets with
    a sniffer, and it also result in the following valgrind warning:
    
        ==13651== Syscall param write(buf) points to uninitialised byte(s)
        ==13651==    at 0x5C4B620: __write_nocancel (syscall-template.S:81)
        ==13651==    by 0x1445AA: write_packet (device.c:183)
        ==13651==    by 0x118C7C: send_packet (net_packet.c:1259)
        ==13651==    by 0x12B70A: route_ipv4 (route.c:443)
        ==13651==    by 0x12D5F8: route (route.c:971)
        ==13651==    by 0x1152BC: receive_packet (net_packet.c:250)
        ==13651==    by 0x117E1B: receive_sptps_record (net_packet.c:904)
        ==13651==    by 0x1309A8: sptps_receive_data_datagram (sptps.c:488)
        ==13651==    by 0x130A90: sptps_receive_data (sptps.c:508)
        ==13651==    by 0x115569: receive_udppacket (net_packet.c:286)
        ==13651==    by 0x119856: handle_incoming_vpn_data (net_packet.c:1499)
        ==13651==    by 0x10F3DA: event_loop (event.c:287)
        ==13651==  Address 0xffeffea3a is on thread 1's stack
        ==13651==  in frame #6, created by receive_sptps_record (net_packet.c:821)
        ==13651==
    
    This commit fixes the issue by filling out the source MAC address. It is
    generated by negating the last byte of the device MAC address, which is
    consistent with what route_arp() does.
    
    In addition, this commit stops route_arp() from filling out the Ethernet
    header of the packet - this is the responsibility of send_packet(), not
    route().

commit 684bd659ae0c6ca623422851c245188037658698
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Nov 4 19:18:12 2015 +0000

    Revert "Cache node IDs in a hash table for faster lookups."
    
    This reverts commit c2319e90b16962fe899bc60abc8af0e2542bb176.
    
    As a general principle, I do not believe it is worthwhile to cache
    nodes. Sure, it brings lookup time down from O(log n) to O(1), but
    considering that the scalability target of tinc is around 1000 nodes
    and log2(1000) is 10, that looks like premature optimization; tree
    lookups should already be very fast. Therefore, I believe it makes sense
    to remove the cache as a code cleanup initiative.

commit eeebff55c07c09c5bc5e62a7b2a21f68ecd1c802
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Nov 4 19:07:14 2015 +0000

    Use a splay tree for node UDP addresses in order to avoid collisions.
    
    This commit replaces the node UDP address hash table "cache" with a
    full-blown splay tree, aligning it with node_tree (name-indexed) and
    node_id_tree (ID-indexed).
    
    I'm doing this for two reasons. The first reason is to make sure we
    don't suddenly degrade to O(n) performance when two "hot" nodes end up
    in the same hash table bucket (collision).
    
    The second, and most important, reason, has to do with the fact that
    the hash table that was being used overrides elements that collide.
    Indeed, it turns out that there is one scenario in which the contents of
    node_udp_cache has *correctness* implications, not just performance
    implications. This has to do with the way handle_incoming_vpn_data() is
    implemented.
    
    Assume the following topology:
    
      A <-> B <-> C
    
    Now let's consider the perspective of tincd running on B, and let's
    assume the following is true:
    
     - All nodes are using the 1.1 protocol with node IDs and relaying
       support.
     - Nodes A and C have UDP addresses that hash to the same value.
     - Node C "wins" in the node_udp_cache (i.e. it overwrites A in the
       cache).
     - Node A has a "dynamic" UDP address (i.e. an UDP address that has been
       detected dynamically and cannot be deduced from edge addresses).
    
    Then, before this commit, A would be unable to relay packets through B.
    
    This is because handle_incoming_vpn_data() will fall back to
    try_harder(), which won't be able to match any edge addresses, doesn't
    check the dynamic UDP addresses, and won't be able to match any keys
    because this is a relayed packet which is encrypted with C's key, not
    B's. As a result, tinc will fail to match the source of the packet and
    will drop the packet with a "Received UDP packet from unknown source"
    message.
    
    I have seen this happen in the wild; it is actually quite likely to
    occur when there are more than a handful of nodes because node_udp_cache
    only has 256 buckets, making collisions quite likely. This problem is
    quite severe because it can completely prevent all packet communication
    between nodes - indeed, if node A tries to initiate some communication
    with C, it will use relaying at first, until C responds and helps A
    establish direct communication with it (e.g. hole punching). If relaying
    is broken, C will not help establish direct communication, and as a
    result no packets can make it through at all.
    
    The bug can be reproduced fairly easily by reproducing the topology
    above while changing the (hardcoded) node_udp_cache size to 1 to force a
    collision. One will quickly observe various issues when trying to make A
    talk to C. Setting IndirectData on B will make the issue even more
    severe and prevent all communication.
    
    Arguably, another way to fix this problem is to make try_harder()
    compare the packet's source address to each node's dynamic UDP
    addresses. However, I do not like this solution because if two "hot"
    nodes are contending on the same hash bucket, try_harder() will be
    called very often and packet routing performance will degrade closer to
    O(N) (where N is the total number of nodes in the graph). Using a more
    appropriate data structure fixes the bug without introducing this
    performance problem.

commit 7a8515112a4bf94da3cec157ada6e0794a03b946
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Oct 26 13:46:30 2015 +0100

    Avoid undefined behavior.
    
    Left shifts of negative values is undefined in C. This happens a lot in
    the Ed25519 code. Cast to unsigned first, then cast the result back to
    signed where necessary.

commit b6ed5c134fc43d438c622d24f949c240632f5e67
Author: Martin Weinelt <mweinelt@gmail.com>
Date:   Mon Sep 28 06:34:15 2015 +0200

    tinc-gui: Properly initialize class attributes for VPN in __init__

commit 927efeff6242e262b176976a1eb298891578f77d
Author: Martin Weinelt <mweinelt@gmail.com>
Date:   Mon Sep 28 05:54:17 2015 +0200

    tinc-gui: Use ArgumentParser, default to python2

commit e92bb7d1dd7adc02503e3ee795e53b15634df570
Author: Martin Weinelt <mweinelt@gmail.com>
Date:   Mon Sep 28 05:34:22 2015 +0200

    tinc-gui: Fix GetListCtrl method name in SuperListCtrl
    
    wxPython wrongly expects camelcase method names, this however
    is against PEP8

commit 53333d6d0d870de6801352bda106286255f14319
Author: Martin Weinelt <mweinelt@gmail.com>
Date:   Mon Sep 28 05:31:59 2015 +0200

    tinc-gui: Update Node object to correctly parse responses
    
    The application was expecting a different respoonse from tinc
    and wouldn't properly it, and thus not start at all.

commit 0c7e0210d900185d4c1a9ffd969dc2a26d9523a9
Author: Martin Weinelt <mweinelt@gmail.com>
Date:   Mon Sep 28 05:20:03 2015 +0200

    tinc-gui: Reformat codebase according to PEP8

commit 73068238436d8a22abb86e67b08f573b09fd04e1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Sep 25 10:06:18 2015 +0200

    Fix a few memory leaks in the CLI found by AddressSanitizer.

commit 543c0abbd91a7b076670b8763548b8d5849860a0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Sep 25 10:05:24 2015 +0200

    Fix struct node_status_t.
    
    Although not a problem for tinc internally, the size of the struct was 12
    bytes instead of 4, causing some problems when interpreting the value
    received from tincd by the CLI.

commit 706d855e507980de3845556989d7de7a3b9c76e8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Sep 24 22:20:00 2015 +0200

    Replace bare if statements with AS_IF in configure.ac.

commit f54a87b800d551bec4532a5d3bf124d02e167856
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Sep 24 21:53:49 2015 +0200

    Optionally install systemd service files.
    
    If --with-systemd is given when running the configure script, two
    systemd service files will be installed. There is a template
    tinc@.service, which can be used to control individual instances of
    tinc. For example:
    
    systemctl enable tinc@foo
    
    Will create an instance for tinc with netname foo. There is also a
    tinc.service, which can be used to start and stop all instances at once.

commit 5ad43673acf03f86643f1463f1ebfa6e9ca189cc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Sep 24 17:10:25 2015 +0200

    Add -I m4 back to ACLOCAL_AMFLAGS.
    
    In commit b7b5d51, AC_CONFIG_MACRO_DIRS([m4]) was added to configure.ac,
    which is the current proper way of including the m4 directory. However,
    old versions of autoconf ignore it and need the -I m4 statement in
    Makefile.am. Both the old and new way of indicating that the m4/
    directory should be included can coexist.

commit ae89a25695411149a7499189c9771762ad1f1726
Author: Nathan Stratton Treadway <nathanst@ontko.com>
Date:   Sat Sep 12 16:33:52 2015 +0200

    Fix invalid checksum generation.
    
    Use equation 3 given in RFC 1624 and the UpdateTTL() example function given
    RFC 1141.
    
    # Conflicts:
    #       src/route.c

commit 56a8b90d863171d62e0a337b5635fbfc53a67fb0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jul 22 14:33:56 2015 +0200

    In sssp_bfs(), never try to update myself.

commit f75e6f61f280b138082b87ce69bdbdee3e4ba56e
Author: thorkill <thkr@hannover.ccc.de>
Date:   Sun Jul 19 18:53:29 2015 +0200

    Do not access e->to->prevedge if not defined
    
    In some cases - mostly when e->to == myself the prevedge is set to NULL,
    causing invalid memory access. In rare cases this may lead to malformed mst
    or segfaults.

commit f92c3446f2052a59d1e6a28f1bc7cec278cb1e48
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jul 15 15:12:53 2015 +0200

    Use AC_CONFIG_MACRO_DIR() instead of _DIRS().
    
    The former is guaranteed to work with autoconf 2.58 and later, and we
    don't have multiple m4 directories anyway.

commit 9ca1750245b28ed8306f150b6371139c656be111
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 12 16:31:32 2015 +0200

    Fix the PRF function when compiling without OpenSSL.

commit 3c54765bcdf8bd6114da0cb31f45404950089e3a
Author: thorkill <thkr@hannover.ccc.de>
Date:   Tue Jul 7 23:14:08 2015 +0200

    Prevent tinc from forgeting e->local_address
    
    If ADD_EDGE came from tinc version 1.0.x local_address.sa.sa_family is set to 0.
    If it came from tinc version 1.1.x forwarded for older verion it will be 255 - AF_UNKNOWN.

commit 1e7ef381980a5c4c84d699522265290dde5ac728
Author: thorkill <thkr@hannover.ccc.de>
Date:   Tue Jul 7 21:19:26 2015 +0200

    Make sure we do not allocate new edge when talking to old nodes and the same edge already exists
    
    When tinc gets ADD_EDGE from older versions it will allocate
    new edge in protocol_edge.c:189 due to missed case in lines 149-171 where
    local_address is not defined.

commit 7b831804aafa370a6c8d9e86caee31cda1a3dd72
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 12 13:08:34 2015 +0200

    Make subnet caches static.

commit 322ffadac43c7e357cc12340d7b8112a0aaad5af
Author: thorkill <thkr@hannover.ccc.de>
Date:   Tue Jun 30 19:11:45 2015 +0200

    Included missing names.h

commit b7b5d516137713c594990cd982a29f7e5718b45b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 12 13:05:51 2015 +0200

    Use AC_CONFIG_MACRO_DIRS([m4]).

commit 97457716d7efc541d18d08263bbd338e94195bd9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 12 12:55:13 2015 +0200

    Remove unused code that caused warnings about an uninitialized variable.

commit b22b9d438970a0442559949da35be9cc0ffaec00
Author: thorkill <thkr@hannover.ccc.de>
Date:   Mon Jun 29 00:23:13 2015 +0200

    Removed double break;

commit b396585383fe12c890ef7953efaa13a83963b5d7
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jul 12 12:33:07 2015 +0200

    Fix undefined behaviour when left-shifting signed integers.
    
    Found by -fsanitize=undefined.

commit de7d9ee437bc0e5d72f8c6744e1df7ea7b64d2e9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 4 17:53:11 2015 +0200

    Call sockaddrfree(&e->local_address) in free_edge() instead of exit_edges().
    
    The proper place to clean up resources of objects is in their
    destructor. This makes sure proper cleanup when edge_del() is called as
    well. At exit, free_edge() is called on all edges by free_edge_tree(),
    which is called by exit_nodes().

commit 36cec9af88909cb2cf012d609e5c4d8c444ddab9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 4 17:51:05 2015 +0200

    Coalesce two if statements that check for the same thing.

commit 14ccf509540e338502ad806f60bdc3f71ddce66f
Author: Jo-Philipp Wich <jow@openwrt.org>
Date:   Thu Jun 18 23:58:31 2015 +0200

    fix musl compatibility
    
    Let configure include sys/if_tun.h when testing for netinet/if_ether.h
    to detect the Kernel/libc header conflict on musl.
    
    After this patch, configure will correctly detect netinet/if_ether.h as
    unusable and the subsequent compilation will not attempt to use it.
    
    Conflicts:
            src/have.h

commit 37588b8d5cface1bc72424a198b1cc1a6044adb0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 4 17:18:40 2015 +0200

    Don't #include OpenSSL headers when compiling without OpenSSL.

commit abb24e9d71b3edb9cacf4c04361cc0dfd4e6a061
Author: thorkill <thkr@hannover.ccc.de>
Date:   Sat Jul 4 03:21:01 2015 +0200

    Cleanup local_address in protocol_edge.c
    
    In line 131 local_address has been defined,
    but the memory was never freed on return.

commit 92df36a610421ed5fcae90e832f64e3acfb7d431
Author: thorkill <thkr@hannover.ccc.de>
Date:   Sat Jul 4 02:39:12 2015 +0200

    Cleanup edges stored in edge_weight_tree on exit
    
    protocol_edge.c: 131 defines local_address using str2sockaddr
    
    str2sockaddr() allocates memory which has to be freed on exit.

commit 1140ca6d3004b228947bad8736f0b49d6b169267
Author: thorkill <thkr@hannover.ccc.de>
Date:   Sat Jul 4 00:29:36 2015 +0200

    Fixed 2 leaks in setup_myself()

commit 0267aef826ba627aba3a525b36c0e7bfc0f9a221
Author: Florian Klink <flokli@flokli.de>
Date:   Thu Jul 2 12:35:42 2015 +0200

    setup_outgoing_connection: log to LOG_DEBUG on if no known address
    
    With AutoConnect = yes, tinc tries to establish connections to known hosts.
    However, you could have set no Address for this host, which is perfectly fine
    (as long as there is at least one bootstrap node with an address or a local
    discovered node already part of the network)
    
    So log this to LOG_DEBUG

commit 91355b9ac5a80d6d7da6951a72ea0c22651bdfa8
Author: Florian Klink <flokli@flokli.de>
Date:   Thu Jul 2 12:35:41 2015 +0200

    (read|append)_config_file: log open errors as LOG_DEBUG
    
    In a "decentrally managed vpn" it is very likely that host config
    files for some reachable nodes do not exist. Currently, tinc
    fills the logs with "Cannot open config file" messages.
    
    This commit changes the log level to LOG_DEBUG so
    syslog doesn't get filled by default.

commit ebffa40aa7832459f63801e3a91cc741e6b339a8
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jun 20 11:41:20 2015 +0100

    Protect against callbacks removing items from the io tree.
    
    The definition of the splay_each() macro is somewhat complicated for
    syntactic reasons. Here's what it does in a more readable way:
    
      for (splay_node_t* node = tree->head; node;) {
        type* item = node->data;
        splay_node_t* next = node->next;
    
        // RUN USER BLOCK with (item)
    
        node = next;
      }
    
    list_each() works in the same way. Since node->next is saved before the
    user block runs, this construct supports removing the current item from
    within the user block. However, what it does *not* support is removing
    *other items* from within the user block, especially the next item.
    Indeed, that will invalide the next pointer in the above loop and
    therefore result in an invalid pointer dereference.
    
    Unfortunately, there is at least one code path where that unsupported
    operation happens. It is located in ack_h(), where the authentication
    protocol code detects a double connection (i.e. being connected to
    another node twice). Running in the context of a socket read event, this
    code will happily terminate the *other* metaconnection, resulting in its
    socket being removed from the io tree. If, by misfortune, this other
    metaconnection happened to have the next socket FD number (which is
    quite possible due to FD reuse - albeit unlikely), and was part of the
    io tree (which is quite likely because if that connection is stuck, it
    will most likely have pending writes) then this will result in the next
    pending io item being destroyed. Invalid pointer dereference ensues.
    
    I did a quick audit of other uses of splay_each() and list_each() and
    I believe this is the only scenario in which this "next pointer
    invalidation" problem can occur in practice. While this bug has been
    there since at least 6bc5d626a8726fc23365ee705761a3c666a08ad4 (November
    2012), if not sooner, it happens quite rarely due to the very specific
    set of conditions required to trigger it. Nevertheless, it does manage
    to crash my central production nodes every other week or so.

commit 7f020cf456b327313f0cfa8d103fb14f06f71994
Author: Dato Simó <dato@net.com.org.es>
Date:   Tue Jun 16 20:44:45 2015 -0300

    Fix typo in tinc.texi.

commit 45a46f068cf8fbe6cc8c59673de2d8580d18f87f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Jun 10 23:42:17 2015 +0200

    Fix crash is sptps_logger().
    
    Unfortunately, sptps_logger() cannot know if s->handle is pointing to a
    connection_t or a node_t. But it needs to print name and hostname in
    both cases. So make sure both types have name and hostname fields at the
    start with the same offset.

commit bfe231b977284ba78a582db96a05b5854ddf0d91
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 7 23:20:14 2015 +0200

    Fix alignment of output of sptps_speed.

commit a797b4a19235be740c51bcb3bb6ec5de01915f46
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 7 23:14:48 2015 +0200

    Fix receiving SPTPS data in sptps_speed and sptps_test.
    
    The sptps_receive_data() was changed in commit d237efd to only process
    one SPTPS record from a stream input. So now we have to put a loop
    around it to ensure we process everything.

commit d8d1ab4ee1e92ec84fe9ea86eec2396275483a92
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 7 22:50:05 2015 +0200

    Fix warnings about missing return value checks.
    
    In some harmless places, checks for the return value of ECDSA and RSA
    key generation and verification was omitted. Add them to keep the
    compiler happy and to warn end users in case something is wrong.

commit ab0576a2034b03f92943ac477e4e97731a899554
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 7 22:25:22 2015 +0200

    Fix autoconf check for function attributes.
    
    GCC warns when a function attribute has no effect. The autoconf check
    turns warnings about attributes into errors, therefore thinking that
    they did not work. The reason was that the test function returned void,
    which is not suitable for checking both __malloc__ and
    __warn_unused_result__.

commit 84ecc972e5c11f683ac618c5a734a17c295d9b46
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 31 23:51:39 2015 +0200

    Fix missing return value caused by the previous commit.

commit eca357ed916c9782a64a68a2f30b144d84027795
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 31 20:19:48 2015 +0100

    Don't try to relay packets to unreachable nodes.
    
    It is not unusual for tinc to receive SPTPS packets to be relayed to
    nodes that just became unreachable, due to state propagation delays in
    the metagraph.
    
    Unfortunately, the current code doesn't handle that situation correctly,
    and still tries to relay the packet to the unreachable node. This
    typically ends up segfaulting.
    
    This commit fixes the issue by checking for reachability before relaying
    the packet.

commit 9e3adef5cb31cb73fbbbd25d3fce115aac107714
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 24 09:49:16 2015 +0100

    Fix invalid pointer use in get_my_hostname().
    
    clang-3.7 warnings surfaced an actual bug:
    
    invitation.c:185:5: error: address of array 'filename' will always evaluate to 'true'
          [-Werror,-Wpointer-bool-conversion]
            if(filename) {
            ~~ ^~~~~~~~
    
    The regression was introduced in 3ccdf50beb6b2d3f2730bdc66006b43190537cde.

commit 7fcfbe2bd2d14d13e06e3e2addfe0ea12b67873f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 24 09:45:09 2015 +0100

    Fix wrong format string type in send_sptps_tcppacket().
    
    This issue was found through a clang-3.7 warning:
    
    protocol_misc.c:167:46: error: format specifies type 'short' but the argument has type 'int'
          [-Werror,-Wformat]
            if(!send_request(c, "%d %hd", SPTPS_PACKET, len))
                                    ~~~                 ^~~
                                    %d

commit 3e61c7233b087b8400c29ca7a8d079aad8b706d8
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat May 23 17:24:05 2015 +0100

    Don't set up an ongoing connection to myself.
    
    It is entirely possible that the configuration file could contain a
    ConnectTo statement refering to its own name; that's a reasonable
    scenario when one deploys semi-automatically generated tinc.conf files.
    
    Amusingly, tinc does not like that at all, and actually sets up an
    outgoing_t structure to myself (which obviously makes no sense). This is
    mostly benign, though it does result in non-sensical "Already connected
    to myself" messages every retry interval.
    
    However, that also makes things blow up in close_network_connections(),
    because there we delete the entire outgoing list and *then* the myself
    node, which still has a reference to the freshly deleted outgoing
    structure. Boom.

commit 8587e8c0d9ac997fcd2040470c1ccf5930bc18c3
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat May 23 10:24:00 2015 +0100

    Fix crashes when trying unreachable nodes.
    
    timeout_handler() calls try_tx(c->node) when c->edge exists.
    Unfortunately, the existence of c->edge is not enough to conclude that
    the node is reachable.
    
    In fact, during connection establishment, there is a short period of
    time where we create an edge for the node at the other end of the
    metaconnection, but we don't have one from the other side yet.
    Unfortunately, if timeout_handler() runs during that short time
    window, it will call try_tx() on an unreachable node, which makes
    things explode because that function is not prepared to handle that
    case.
    
    A typical symptom of this race condition is a hard SEGFAULT while trying
    to send packets using metaconnections that don't exist, due to
    n->nexthop containing garbage.
    
    This patch fixes the issue by making try_tx() check for reachability,
    and then making all code paths use try_tx() instead of the more
    specialized methods so that they go through the check.
    
    This regression was introduced in
    eb7a0db18ea71a44999d6a37b4b179dac0ed9bc7.

commit 537a9366718b39278fd4eb33b2ac568011e374cc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu May 21 11:09:01 2015 +0200

    Update copyright notices.

commit 0a786ffbb9d293d7704b8e264f3943a616ed25cc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu May 21 11:06:38 2015 +0200

    Set the CLOEXEC flag on the umbilical socket.

commit 87e09527735632aae3f595f5a28667880ca4c8c1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 21:28:54 2015 +0200

    Use socketpair() instead of pipe() for the umbilical.
    
    This prepares for a possible conversion of the umbilical socket to a
    control socket.

commit 19e0d449ebd06450c9d7f16f032c0806242c7515
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 21:25:06 2015 +0200

    Don't write log messages to the umbilical pipe if we don't detach.
    
    If we run in the foreground and are started by the CLI, this would
    otherwise cause the first few log messages to appear twice.

commit 11868b890d1a7f4cfbfb37099393b32019010f66
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 16:59:43 2015 +0200

    Ensure "tinc start" knows if the daemon really started succesfully.
    
    We do this by creating an umbilical between the CLI and the daemon. The
    daemon pipes log messages to the CLI until it starts the main loop. The
    daemon then cuts the umbilical. The CLI copies all the received log
    messages to stderr, and the last byte indicates whether the daemon
    started succesfully or not, so the CLI can exit with a useful exit code.

commit 7f96ef081dc0dc41e3955e35c1a36a62fd47f72b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 11:11:12 2015 +0200

    Fix check for LOCALSTATEDIR accessibility for the CLI.
    
    The CLI does not need write access to the directory where the PID file
    is stored, it just needs to be able to read the PID file.

commit 3ccdf50beb6b2d3f2730bdc66006b43190537cde
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 00:55:00 2015 +0200

    Allocate temporary filenames on the stack.
    
    This gets rid of xasprintf() in a number of places, and removes the need
    to free() the temporary strings. A few potential memory leaks have been
    fixed.

commit 58e8f598f38dbb2f210d8a62c8fb4b46513dc39f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 00:12:01 2015 +0200

    Allow dumping a list of outstanding invitations.
    
    This dumps the name of the invitation file, as well as the name of the
    node that is being invited. This can make it easier to find the
    invitation file belonging to a given node.

commit 7c8f54cdb2925ba787209f5358b62d3cee414d43
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 20 00:02:53 2015 +0200

    Add "list" as an alias for "dump" in the CLI.

commit 69ba5f621e4931417f9f41061a7689e36c70e3d9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 22:26:32 2015 +0200

    Quit with an error message if ioctl(TUNSETIFF) fails.
    
    It is possible that opening /dev/net/tun works but that interface
    creation itself fails, for example if a non-root user tries to create a
    new interface, or if the desired interface is already opened by another
    process. In this case, the ioctl() fails, but we actually silently
    ignored this condition.

commit 60fbdb3f2cf0216afb2cfcc2c4128fb5765471ac
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 22:17:18 2015 +0200

    If LOCALSTATEDIR is inaccessible, store the pid and socket files in the configuration directory.
    
    The compile time local state directory is usually /var or
    /usr/local/var. If this is not accessible for some reason, for example
    because someone ./configured tinc without --localstatedir and
    /usr/local/var does not exist, or if tinc is started by a non-root user,
    then tinc will fall back to the directory where tinc.conf is stored.
    A warning is logged when this happens.

commit dece2db78e2c4ccd6e617e69195754639b086170
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 21:32:30 2015 +0200

    Don't log seqno failures in sptps_verify_datagram().
    
    This function is not used for normal traffic, only when a packet from an
    unknown source is received and we need to check against candidates. No
    failures should be logger in this case; if the packet is really not
    valid this will be logged by handle_incoming_vpn_data().

commit a7522118018928e17fc53840b420df570cf1bec5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 21:23:35 2015 +0200

    Add source of SPTPS errors to log messages.

commit d89f37eb17196e38105a92d746ed7cb6b6f6ba45
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 14:25:20 2015 +0200

    Add newline at end of precomp_data.h and sc.h.

commit d8a3a182de30d649ed6764dd5d64b57ad77a446e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 14:09:53 2015 +0200

    Fix src/Makefile.am for *BSD.
    
    Apparently the BSDs don't like $(srcdir) but want to see ${srcdir} in
    their rules.

commit 96a323e16a1f3e99d0b498aa90423b060c3d458f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 19 13:31:26 2015 +0200

    Remove info-in-builddir option from AM_INIT_AUTOMAKE().
    
    This option is not supported by older, but still widely used versions of
    automake. The drawback is that when doing multiple VPATH builds in a
    row, the info manual may mention incorrect paths, but it doesn't affect
    the executables at all.

commit 51b5aab9b042dffc6ef0791358f097895a3234eb
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Wed May 13 21:24:29 2015 +0200

    Fix check for public key in invite-join.test.
    
    Small fix to test/invite-join.test, comparing no-longer-existing
    ECDSAPublicKey does not make sense.

commit a196e9b0fde1e8a67108eacd51ac663eac5a63ae
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon May 18 21:06:16 2015 +0100

    Fix direct UDP communciation with pre-relaying 1.1 nodes.
    
    try_tx_sptps() gives up on UDP communication if the recipient doesn't
    support relaying. This is too restrictive - we only need the other node
    to support relaying if we actually want to relay through them. If the
    packet is sent directly, it's fine to send it to an old pre-node-IDs
    tinc-1.1 node.

commit fef29d0193afc7e0a9dc766ef75b79cd4dc6fa37
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon May 18 20:48:45 2015 +0100

    Don't parse node IDs if the sending node doesn't support them.
    
    Currently, tinc tries to parse node IDs for all SPTPS packets, including
    ones sent from older, pre-node-IDs tinc-1.1 nodes, and therefore doesn't
    recognize packets from these nodes. This commit fixes that.
    
    It also makes code slightly clearer by reducing the amount of fiddling
    around packet offset/length.

commit 643149b44991121c618a2412c64072ad22955991
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon May 18 20:35:44 2015 +0100

    Fix SPTPS condition in try_harder().
    
    A condition in try_harder() is always evaluating to false when talking
    to a SPTPS node because n->status.validkey_in is always false in that
    case. Fix the condition so that the SPTPS status is correctly checked.
    
    This prevented recent tinc-1.1 nodes from talking to older, pre-node-ID
    tinc-1.1 nodes.
    
    The regression was introduced in
    6056f1c13bb37bf711dff9c25a6eaea99f14d31f.

commit 01d251986260faf306927aa91daff705ee0523d6
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 22:36:15 2015 +0100

    Don't pollute the system header directory namespace.
    
    Since commit 13f9bc1ff199bea46d3dde391a848f119e2cc0f0, tinc passes the
    -I. option to the preprocessor so that version_git.h can be found during
    out-of-tree ("VPATH") builds.
    
    The problem is, this option also affects the directory search for files
    included *from* system headers. For example, on MinGW, unistd.h contains
    the following line:
    
      #include <process.h>
    
    Which, due to -I. putting the tinc directory at the head of the search
    order, results in tinc's process.h being included instead of the file
    from MinGW. Hilarity ensues.
    
    This commit fixes the issue by using -iquote, which doesn't affect
    system headers.

commit c1154bf696b0b3ad22126a76750d610e32e2ffc1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 22:21:11 2015 +0100

    Make sure the MIN() macro is defined.
    
    On MinGW this is not automatically the case, thereby breaking the build.

commit 5c32bd1578d59e005f634621d17ca96af32bb630
Merge: aa52300b 1a7a9078 2cb216d8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 17 21:07:45 2015 +0200

    Merge remote-tracking branches 'dechamps/sptpsrestart' and 'dechamps/keychanged' into 1.1

commit 2cb216d83d825fcca2fa2b66c756b253f8f0828b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 19:23:12 2015 +0100

    Don't send KEY_CHANGED messages if we don't support the legacy protocol.
    
    KEY_CHANGED messages are only useful to invalidate keys for non-SPTPS nodes;
    SPTPS nodes use a different internal mechanism (forced KEX) for that purpose.
    Therefore, if we know we can't talk to legacy nodes, there's no point in
    sending them these messages.

commit 1a7a9078c093f77950192c32be009bbe463fe372
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 18:50:11 2015 +0100

    Proactively restart the SPTPS tunnel if we get receive errors.
    
    There are a number of ways a SPTPS tunnel can get into a corrupt state.
    For example, during key regeneration, the KEX and SIG messages from
    other nodes might arrive out of order, which confuses the hell out of
    the SPTPS code. Another possible scenario is not noticing another node
    crashed and restarted because there was no point in time where the node
    was seen completely disconnected from *all* nodes; this could result in
    using the wrong (old) key. There are probably other scenarios which have
    not even been considered yet. Distributed systems are hard.
    
    When SPTPS got confused by a packet, it used to crash the entire
    process; fortunately that was fixed by commit
    2e7f68ad2b51648b89c4b5c61aeb4cec67c2fbbb. However, the error handling
    (or lack thereof) leaves a lot to be desired. Currently, when SPTPS
    encounters an error when receiving a packet, it just shrugs it off and
    continues as if nothing happened. The problem is, sometimes getting
    receive errors mean the tunnel is completely stuck and will not recover
    on its own. In that case, the node will become unreachable - possibly
    indefinitely.
    
    The goal of this commit is to improve SPTPS error handling by taking
    proactive action when an incoming packet triggers a failure, which is
    often an indicator that the tunnel is stuck in some way. When that
    happens, we simply restart SPTPS entirely, which should make the tunnel
    recover quickly.
    
    To prevent "storms" where two buggy nodes flood each other with invalid
    packets and therefore spend all their time negotiating new tunnels, we
    limit the frequency at which tunnel restarts happen to ten seconds.
    
    It is likely this commit will solve the "Invalid KEX record length
    during key regeneration" issue that has been seen in the wild. It is
    difficult to be sure though because we do not have a full understanding
    of all the possible conditions that can trigger this problem.

commit aa52300b2b6e9d923d6d5b8c95fa500f549620d0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 17:51:05 2015 +0100

    Trivial: make sptps_receive_data_datagram() a little more readable.
    
    The new code updates variables as stuff is being consumed, so that the
    reader doesn't have to do that in his head.

commit 30e839b0a1810b9cb0a2de2595cef2f8ebb06357
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 17 18:44:09 2015 +0200

    Don't send local_address in ADD_EDGE messages if it's AF_UNSPEC.

commit 23fda4db6d1bb400a97f6d2a07d9b700f9546129
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Sun May 17 05:29:21 2015 +0200

    Let sockaddr2hostname() handle AF_UNSPEC addresses.

commit 1e89a63f1638e43dee79afbb18d5f733b27d830b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 17 17:09:56 2015 +0100

    Prevent SPTPS key regeneration packets from entering an UDP relay path.
    
    Commit 10c1f60c643607d9dafd79271c3475cddf81e903 introduced a mechanism
    by which a packet received by REQ_KEY could continue its journey over
    UDP. This was based on the assumption that REQ_KEY messages would never
    be used for handshake packets (which should never be sent over UDP,
    because SPTPS currently doesn't handle lost handshake packets very
    well).
    
    Unfortunately, there is one case where handshake packets are sent using
    REQ_KEY: when regenerating the SPTPS key for a pre-established channel.
    With the current code, such packets risk getting relayed over UDP.
    
    When processing a REQ_KEY message, it is impossible for the receiving
    end to distinguish between a data SPTPS packet and a handshake packet,
    because this information is stored in the type field which is encrypted
    with the end-to-end key.
    
    This commit fixes the issue by making tinc use ANS_KEY for all SPTPS
    handshake messages. This works because ANS_KEY messages are never
    forwarded using the SPTPS relay mechanisms, therefore they are
    guaranteed to stick to TCP.

commit eecfeadeb4fc70ee002b81c20ba12ba3e3acb843
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat May 16 02:01:54 2015 +0200

    Let sockaddr2str() handle AF_UNSPEC addresses.

commit 613c121cdceec0199dc4d056857be021ed1d21de
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri May 15 23:35:46 2015 +0200

    Try all addresses for the hostname in an invitation URL.

commit 54a8bd78e3fbe2de4d9daea748643f9c9b5b240e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri May 15 23:08:53 2015 +0200

    Be more liberal accepting ADD_EDGE messages with conflicting local address information.
    
    If the ADD_EDGE is for one of the edges we own, and if it is not the
    same as we actually have, send a correcting ADD_EDGE back. Otherwise, if
    the ADD_EDGE contains new information, update our idea of the local
    address for that edge.
    
    If the ADD_EDGE does not contain local address information, then we
    never make a correction nor log a warning.

commit 8028e01100eb40f64da5e50ef33fbf9e3f8099de
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri May 15 23:01:06 2015 +0200

    Use AF_UNSPEC instead of AF_UNKNOWN for unspecified local address in add_edge_h().
    
    AF_UNKNOWN is reserved for valid addresses that the local node cannot
    parse, but remote nodes possibly can.

commit fd1cff6df23c3f16a46edaff8a52a7212914b2f0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri May 15 00:21:48 2015 +0200

    Fix receiving UDP packets from tinc 1.0.x nodes.
    
    In try_mac(), the wrong offsets were used into the packet buffer,
    causing the digest verification to always fail.

commit 44e9f1e1d8d6dbd4625e5458cfffcf6b5168374a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed May 13 14:28:28 2015 +0200

    Fix invitations.
    
    These were broken due to a change in behaviour of sptps_receive_data()
    introduced in commit d237efd325cd7bdd73f5eb111c769470238dce6e.

commit 7e6b2dd1ea51057b7135139c200d97a9e8f9c9cb
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 10 19:00:03 2015 +0100

    Introduce raw TCP SPTPS packet transport.
    
    Currently, SPTPS packets are transported over TCP metaconnections using
    extended REQ_KEY requests, in order for the packets to pass through
    tinc-1.0 nodes unaltered. Unfortunately, this method presents two
    significant downsides:
    
     - An already encrypted SPTPS packet is decrypted and then encrypted
       again every time it passes through a node, since it is transported
       over the SPTPS channels of the metaconnections. This
       double-encryption is unnecessary and wastes CPU cycles.
    
     - More importantly, the only way to transport binary data over
       standard metaconnection messages such as REQ_KEY is to encode it
       in base64, which has a 33% encoding overhead. This wastes 25% of the
       network bandwidth.
    
    This commit introduces a new protocol message, SPTPS_PACKET, which can
    be used to transport SPTPS packets over a TCP metaconnection in an
    efficient way. The new message is appropriately protected through a
    minor protocol version increment, and extended REQ_KEY messages are
    still used with nodes that do not support the new message, as well as
    for the intial handshake packets, for which efficiency is not a concern.
    
    The way SPTPS_PACKET works is very similar to how the traditional PACKET
    message works: after the SPTPS_PACKET message, the raw binary packet is
    sent directly over the metaconnection. There is one important
    difference, however: in the case of SPTPS_PACKET, the packet is sent
    directly over the TCP stream completely bypassing the SPTPS channel of
    the metaconnection itself for maximum efficiency. This is secure because
    the SPTPS packet that is being sent is already encrypted with an
    end-to-end key.

commit d237efd325cd7bdd73f5eb111c769470238dce6e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 10 19:28:11 2015 +0100

    Only read one record at a time in sptps_receive_data().
    
    sptps_receive_data() always consumes the entire buffer passed to it,
    which is somewhat inflexible. This commit improves the interface so that
    sptps_receive_data() consumes at most one record. The goal is to allow
    non-SPTPS stuff to be interleaved with SPTPS records in a single TCP
    stream.

commit de14308840a96060d700c93117789e83ec948c01
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 10 18:05:19 2015 +0100

    Rename REQ_SPTPS to SPTPS_PACKET.
    
    REQ_SPTPS implies the message has an ANS_ counterpart (like REQ_KEY,
    ANS_KEY), but it doesn't. Therefore dropping the REQ_ seems more
    appropriate, and we add a _PACKET suffix to reduce the likelihood of
    naming conflicts.

commit 10c1f60c643607d9dafd79271c3475cddf81e903
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat May 9 18:09:23 2015 +0100

    Try to use UDP to relay SPTPS packets received over TCP.
    
    Currently, when tinc receives a SPTPS packet over TCP via the REQ_KEY
    encapsulation mechanism, it forwards it like any other TCP request. This
    is inefficient, because even though we received the packet over TCP,
    we might have an UDP link with the next hop, which means the packet
    could be sent over UDP.
    
    This commit removes that limitation by making sure SPTPS data packets
    received through REQ_KEY requests are not forwarded as-is but passed
    to send_sptps_data() instead, thereby using the same code path as if
    the packet was received over UDP.

commit 1296f715b57c88c17299cacadaccdc0be898e0b1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat May 9 17:54:34 2015 +0100

    Expose the raw SPTPS send interface from net_packet.
    
    net_packet doesn't actually use send_sptps_data(); it only uses
    send_sptps_data_priv(). In addition, the only user of send_sptps_data()
    is protocol_key. Therefore it makes sense to expose
    send_sptps_data_priv() directly, and move send_sptps_data() (which is
    basically just boilerplate) as a local function in protocol_key.

commit 8e43a2fc744559956640d3eb9a7a26a945d94fde
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 10 18:46:47 2015 +0100

    Use the correct originator node when relaying SPTPS UDP packets.
    
    Currently, when relaying SPTPS UDP packets, the code uses the direct
    sender as the originator, instead of preserving the original source ID.
    
    This wouldn't cause any issues in most cases because the originator and
    the sender are the same in simple one-hop relay chains, but this will
    break as soon as there is more than one relay.

commit 9d223cb7e7f337c6b9707f07e3e9796108a3b597
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun May 10 18:37:30 2015 +0100

    When relaying, send probes to the destination, not the source.
    
    This seems to be a typo from c23e50385d9de538af676706596f6508b2ceb01a.
    Achievement unlocked: got a one-line commit wrong.

commit 13f9bc1ff199bea46d3dde391a848f119e2cc0f0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 16:01:41 2014 +0100

    Add support for out-of-tree ("VPATH") builds.
    
    This fixes some issues with the build system when building out of tree.
    
    With this commit, it is now possible to do the following:
    
        $ cd /tmp/build
        $ /path/to/tinc/configure
        $ make

commit 462e9892ae2765d0c7036005fafe036fd2a9f4f2
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 16:21:32 2014 +0100

    Remove explicit distribution rules for m4 scripts.
    
    It turns out Automake is smart enough to include these files in the
    distribution by itself.

commit 362b79176439a2eb643612633aa0ff210a6a4d81
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat May 9 15:41:37 2015 +0200

    Really remove "release-" from the git-derived version string.

commit b109e8b16488f9bbfdc4aefe0e9b00c4f202e905
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 18:26:55 2014 +0100

    Use git describe to populate autoconf's VERSION.
    
    This uses the output of "git describe" directly in configure.ac to
    determine the version number to use, instead of hardcoding it.
    
    With this change, current version information is completely removed
    from the codebase itself, and is always fetched on-the-fly from git as
    the single source of truth.
    
    In order to ensure make dist always uses the current version number in
    the contents of the packaged configure script as well as the package
    name, a dependency is added to the dist target such that autoconf is
    always run before dist to regenerate the version number. If this wasn't
    the case, make dist would use the version number from when autoconf was
    originally run, not the version number that make dist is running from.
    That said, errors from that rule are ignored so that people can still
    run make dist without a working autoconf.
    
    In addition, the NEWS check is dropped, as it would then become annoying
    because it would force make dist users to always have a line for the
    current commit in the NEWS file.

commit 1c77069064e0cf0e0ddd81bab1b1354a8952fb33
Author: Pierre Emeriaud <petrus.lt@gmail.com>
Date:   Sat May 9 00:03:51 2015 +0200

    Fix typo in tincctl help.

commit 54554cc2765befc2e95fd7fe2fedfd75a94b5926
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 5 23:05:22 2015 +0200

    Don't include build-time generated version_git.h in the tarball.

commit c46bdbde18629f0a0613c776c13a79fea0ec6093
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 5 23:03:41 2015 +0200

    Remove "release-" from displayed git version.
    
    Also make sure that version_git.h is only written to if the "git
    describe" command succeeds.

commit 120e0567cba17eeb57c12a34686fddbbb491b62f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 15:22:10 2014 +0100

    Use git description as the tinc version.
    
    Instead of using the hardcoded version number in configure.ac, this
    makes tinc use the live version reported by "git describe",
    queried on-the-fly during the build process and regenerated for every
    build.
    
    This makes tinc version output more useful, as tinc will now display the
    number of commits since the last tag as well as the commit the binary is
    built from, following the format described in git-describe(1).
    
    Here's an example of tincd --version output:
    
      tinc version release-1.1pre10-48-gc149315 (built Jun 29 2014 15:21:10, protocol 17.3)
    
    When building directly from a release tag, this will look like the following:
    
      tinc version release-1.1pre10 (built Jun 29 2014 15:21:10, protocol 17.3)
    
    (Note that the format is slightly different - because of the way the
    tags are named, it says "release-1.1pre10" instead of just "1.1pre10")
    
    If git describe fails (for example when building from a release
    tarball), the build automatically falls back to the autoconf-provided
    VERSION macro (i.e. the old behavior).

commit 95594f47384b60a6f994f0fca6fd9f79b2b283aa
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 24 23:51:29 2015 +0200

    Fix typo 0fda572c88d02b0b200ef81d72cc4da594fa0e38 that prevented some errors from being logged.

commit 0fda572c88d02b0b200ef81d72cc4da594fa0e38
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 24 23:43:58 2015 +0200

    Don't log an error message when receiving a TERMREQ.

commit ea1e815223e99f3747f94cf0d10eb06e52f70b21
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 24 23:43:19 2015 +0200

    Fix a possible segmentation fault during key upgrades.
    
    read_rsa_public_key() was bailing out early if the given node already has an Ed25519 key, and
    returned true even though c->rsa was NULL. The early bailout code isn't necessary anymore, so just
    remove it.

commit 2059814238320b761fb93608b7f8a114de861302
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 24 23:40:20 2015 +0200

    Allow one-sided upgrades to Ed25519.
    
    This deals with the case where one node knows the Ed25519 key of another node, but not the other
    way around. This was blocked by an overly paranoid check in id_h(). The upgrade_h() function already
    handled this case, and the node that already knows the other's Ed25519 key checks that it has not
    been changed, otherwise the connection will be aborted.

commit 3def9d2ad88a9015af4c42aac329e0e2a80679f7
Merge: 95921696 0c010ff9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:43:05 2015 +0200

    Merge remote-tracking branch 'dechamps/wintapver' into 1.1

commit 95921696a49d1eff058880c90a80efd208de959d
Merge: f500a3d4 7027bba5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:42:48 2015 +0200

    Always call res_init() before getaddrinfo().
    
    Unfortunately, glibc assumes that /etc/resolv.conf is a static file that
    never changes. Even on servers, /etc/resolv.conf might be a dynamically
    generated file, and we never know when it changes. So just call
    res_init() every time, so glibc uses up-to-date nameserver information.
    
    Conflicts:
            src/have.h
            src/net.c
            src/net_setup.c

commit f500a3d4e6e51ea1d88235e89e494ecb8f71ba5b
Merge: 41798146 89715454
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:36:50 2015 +0200

    Merge remote-tracking branch 'dechamps/windevice' into 1.1

commit 417981462a2dde7800768eb58cf8f4e5238d4ad7
Merge: 11effab8 176ee015
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:35:50 2015 +0200

    Merge remote-tracking branch 'dechamps/winmtu' into 1.1

commit 11effab85b6b278ccf0ac3ba52a12bbca3e3dcc5
Merge: 9e71b74e 43b41e90
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:35:37 2015 +0200

    Merge remote-tracking branch 'dechamps/fsckwin' into 1.1

commit 9e71b74ed83c51e0b35114a4f153b62b54fd3702
Merge: 76a9be5b fa432426
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 12 15:34:50 2015 +0200

    Merge remote-tracking branch 'dechamps/staticfix' into 1.1

commit 0c010ff9fe50b4046b5c7977bafac3e74037f075
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 15 18:30:39 2015 +0000

    Warn about performance if using TAP-Windows >=9.21.
    
    Testing has revealed that the newer series of Windows TAP drivers (i.e.
    9.0.0.21 and later, also known as NDIS6, tap-windows6) suffer from
    serious performance issues in the write path. Write operations seems to
    take a very long time to complete, resulting in massive packet loss even
    for throughputs as low as 10 Mbit/s.
    
    I've made some attempts to alleviate the problem using parellelism. By
    using custom code that allows up to 256 write operations at the same
    time the results are much better, but it's still about 2 times worse
    than the traditional 9.0.0.9 driver.
    
    We need to investigate more and file a bug against tap-windows6, but in
    the mean time, let's inform the user that he might not want to use the
    latest drivers.

commit 0f328d9d2853ca723ff3205f39bb22207d21a932
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 15 18:18:04 2015 +0000

    Log TAP-Windows driver version on startup.
    
    This is generally useful. We've seen issues that are specific to some
    version of these drivers (especially the newer 9.0.0.21 version), so
    it's relevant to log it, especially since that means it will be
    copy-pasted by people posting their logs asking for help.

commit 7027bba541eca3e34f689bebd6f6e408ba4e7710
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 15 18:01:03 2015 +0000

    Increase the ReplayWindow default from 16 to 32.
    
    As a rule, it seems reasonable to make sure that tinc operates correctly
    on at least 1G links, since these are pretty common. However, I have
    observed replay window issues when operating at speeds of 600 Mbit/s and
    above, especially when the receiving end is a Windows system (not sure
    why). This commit increases the default so that this won't occur on
    fresh setups.

commit 94f49a163aa570ea272bf3bbd7734187098d88b7
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 15 17:50:53 2015 +0000

    Set the default for UDPRcvBuf and UDPSndBuf to 1M.
    
    It may not be obvious, but due to the way tinc operates (single-threaded
    control loop with no intermediate packet buffer), UDP send and receive
    buffers can have a massive impact on performance. It is therefore of
    paramount importance that the buffers be large enough to prevent packet
    drops that could occur while tinc is processing a packet.
    
    Leaving that value to the OS default could be reasonable if we weren't
    relying on it so much. Instead, this makes performance somewhat
    unpredictable.
    
    In practice, the worst case scenario occurs on Windows, where Microsoft
    had the brillant idea of making the buffers 8K in size by default, no
    matter what the link speed is. Considering that 8K flies past in a
    matter of microseconds on >1G links, this is extremely inappropriate. On
    these systems, changing the buffer size to 1M results in *obscene*
    raw throughput improvements; I have observed a 10X jump from 40 Mbit/s
    to 400 Mbit/s on my system.
    
    In this commit, we stop trusting the OS to get this right and we use a
    fixed 1M value instead, which should be enough for <=1G links.

commit 89715454c083aaeb4dc73340f2d0ab9a3d9503e0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Mar 14 18:19:22 2015 +0000

    Fix Windows device asynchronous write behavior.
    
    Write operations to the Windows device do not necessarily complete
    immediately; in fact, with the latest TAP-Win32 drivers, this never
    seems to be the case.
    
    write_packet() does not handle that case correctly, because the
    OVERLAPPED structure and the packet data go out of scope before the
    write operation completes, resulting in race conditions.
    
    This commit fixes the issue by making sure these data structures are
    kept in global scope, and by dropping any packets that may arrive while
    the previous write operation is still pending.

commit 675142c7d88c9d325c0ca0bc5761072a5d810c75
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Mar 14 17:27:14 2015 +0000

    When disabling the Windows device, wait for pending reads to complete.
    
    On Windows, when disabling the device, tinc uses the CancelIo() to
    cancel the pending read operation, and then proceeds to delete the event
    handle immediately.
    
    This assumes that CancelIo() blocks until the pending read request is
    completely torn down and no references to it remain. While MSDN is not
    completely clear on that subject, it does suggest that this is not the
    case:
    
      http://msdn.microsoft.com/en-us/library/windows/desktop/aa363791.aspx
      If the function succeeds [...] the cancel operation for all pending
      I/O operations issued by the calling thread for the specified file
      handle was successfully requested.
    
    This implies that cancellation was merely "requested", and that there
    are no guarantees as to the state of the operation when CancelIo()
    returns. Therefore, care must be taken not to close event handles
    prematurely.
    
    While I'm no aware of this potential race condition causing any problems
    in practice, I don't want to take any chances.

commit 176ee015267d87ff4fd4d2615e9f5ac978116171
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 15 10:00:56 2015 +0000

    Make sure packet header structures are correctly packed on Windows.
    
    Modern versions of GCC handle structure packing differently when
    compiling for Windows, as reported in the following GCC bug report:
    
      http://gcc.gnu.org/bugzilla/show_bug.cgi?id=52991
    
    In practice, this affects tinc because it uses packed structs as a
    convenient way to populate packet headers. "struct ip" is especially
    affected - on Linux, sizeof(struct ip) returns 20 as expected, while on
    Windows, it returns 24 because of the broken alignment.
    
    This in turn completely breaks code that has to populate an IP header.
    Specifically, this breaks route_ipv4_unreachable() which is responsible,
    among other things, for the generation of ICMP Fragmentation Needed
    messages. On Windows, these messages are corrupted beyond hope because
    of this alignment issue. For TCP connections that are established
    before tinc obtains a fix on the MTU (and thus are not MSS clamped),
    this can result in massive disruption.
    
    This commit fixes the issue by forcing GCC to use standard alignment
    for all packed structures in the tinc codebase instead of the MSVC
    alignment.

commit 43b41e9095e6261c53da1ae46117d018296c3b68
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Mar 14 16:17:32 2015 +0000

    Fix HAVE_DECL_RES_INIT conditionals.
    
    HAVE_DECL_RES_INIT is generated using AC_CHECK_DECLS. tinc checks this
    symbol using #ifdef, which is wrong because (according to autoconf docs)
    the symbol is always defined, it's just set to zero if the check failed.
    
    This broke the Windows build starting from
    0b310bf406dbe58afe37fa31156b9ea47599d7be, because it introduced this
    conditional in code that's not excluded from the Windows build.

commit 4989362300f800a6f407508f1e0127867cf80cba
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Mar 14 16:07:54 2015 +0000

    Fix invalid getuid() call on Windows.
    
    This is breaking the Windows build. Regression was introduced in
    268e3ffca7b45cfc736e1bc9bec7a113c6c45701.

commit fa432426df7e2e364e310ab4bac28e60f732a3c9
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Mar 14 14:04:50 2015 +0000

    Don't send UDP probes past static relays.
    
    Ironically, commit 0f8e2cc78cafe47a087d3fc9b480551b841aeb30 introduced
    a regression on its own, since it accidently removed a return statement
    that prevented try_tx_sptps() from sending UDP/MTU probes to nodes that
    are past static relays.

commit 76a9be5bce43a1a7363c670882f5315c824c903c
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 20:17:27 2015 +0000

    Throttle the rate of MTU_INFO messages.
    
    This makes sure MTU_INFO messages are only sent at the maximum rate of
    5 per second (by default). As usual with these "probe" mechanisms, the
    rate of these messages cannot be higher than the rate of data packets
    themselves, since they are sent from the RX path.

commit 467397f25d3a99ec1a97d4419502c37b64276f49
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 19:54:44 2015 +0000

    Throttle the rate of UDP_INFO messages.
    
    This makes sure UDP_INFO messages are only sent at the maximum rate of
    5 per second (by default). As usual with these "probe" mechanisms, the
    rate of these messages cannot be higher than the rate of data packets
    themselves, since they are sent from the RX path.

commit b1421b919090351e885ed3d06df67fb2eb69e765
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 18:54:50 2015 +0000

    Add MTU_INFO protocol message.
    
    In this commit, nodes use MTU_INFO messages to provide MTU information.
    
    The issue this code is meant to address is the non-trivial problem of
    finding the proper MTU when UDP SPTPS relays are involved. Currently,
    tinc has no idea what the MTU looks like beyond the first relay, and
    will arbitrarily use the first relay's MTU as the limit. This will fail
    miserably if the MTU decreases after the first relay, forcing relays to
    fall back to TCP. More generally, one should keep in mind that relay
    paths can be arbitrarily complex, resulting in packets taking "epic
    journeys" through the graph, switching back and forth between UDP (with
    variable MTUs) and TCP multiple times along the path.
    
    A solution that was considered consists in sending standard MTU probes
    through the relays. This is inefficient (if there are 3 nodes on one
    side of relay and 3 nodes on the other side, we end up with 3*3=9 MTU
    discoveries taking place at the same time, while technically only
    3+3=6 are needed) and would involve eyebrow-raising behaviors such as
    probes being sent over TCP.
    
    This commit implements an alternative solution, which consists in
    the packet receiver sending MTU_INFO messages to the packet sender.
    The message contains an MTU value which is set to maximum when the
    message is originally sent. The message gets altered as it travels
    through the metagraph, such that when the message arrives to the
    destination, the MTU value contained in the message can be used to
    send packets while making sure no relays will be forced to fall back to
    TCP to deliver them.
    
    The operating principles behind such a protocol message are similar to
    how the UDP_INFO message works, but there is a key difference that
    prevents us from simply reusing the same message: the UDP_INFO message
    only cares about relay-to-relay links (i.e. it is sent between static
    relays and the information it contains only makes sense between two
    adjacent static relays), while the MTU_INFO cares about the end-to-end
    MTU, including the entire relay path. Therefore, UDP_INFO messages stop
    when they encounter static relays, while MTU_INFO messages don't stop
    until they get to the original packet sender.
    
    Note that, technically, the MTU that is obtained through this mechanism
    can be slightly pessimistic, because it can be lowered by an
    intermediate node that is not being used as a relay. Since nodes have no
    way of knowing whether they'll be used as dynamic relays or not (and
    have no say in the matter), this is not a trivial problem. That said,
    this is highly unlikely to result in noticeable issues in realistic
    scenarios.

commit 9bb230f30f665779eb89dcce077a15360ec50be1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jan 3 17:46:33 2015 +0000

    Add UDP_INFO protocol message.
    
    In this commit, nodes use UDP_INFO messages to provide UDP address
    information. The basic principle is that the node that receives packets
    sends UDP_INFO messages to the node that's sending the packets. The
    message originally contains no address information, and is (hopefully)
    updated with relevant address information as it gets relayed through the
    metagraph - specifically, each intermediate node will update the message
    with its best guess as to what the address is while forwarding it.
    
    When a node receives an UDP_INFO message, and it doesn't have a
    confirmed UDP tunnel with the originator node, it will update its
    records with the new address for that node, so that it always has the
    best possible guess as to how to reach that node. This applies to the
    destination node of course, but also to any intermediate nodes, because
    there's no reason they should pass on the free intel, and because it
    results in nice behavior in the presence of relay chains (multiple nodes
    in a path all trying to reach the same destination).
    
    If, on the other hand, the node does have a confirmed UDP tunnel, it
    will ignore the address information contained in the message.
    
    In all cases, if the node that receives the message is not the
    destination node specified in the message, it will forward the message
    but not before overriding the address information with the one from its
    own records. If the node has a confirmed UDP tunnel, that means the
    message is updated with the address of the confirmed tunnel; if not,
    the message simply reflects the records of the intermediate node, which
    just happen to be the contents of the UDP_INFO message it just got, so
    it's simply forwarded with no modification.
    
    This is similar to the way ANS_KEY messages are currently
    overloaded to provide UDP address information, with two differences:
    
     - UDP_INFO messages are sent way more often than ANS_KEY messages,
       thereby keeping the address information fresh. Previously, if the UDP
       situation were to change after the ANS_KEY message was sent, the
       sender would virtually never get the updated information.
    
     - Once a node puts address information in an ANS_KEY message, it is
       never changed again as the message travels through the metagraph; in
       contrast, UDP_INFO messages behave the opposite way, as they get
       rewritten every time they travel through a node with a confirmed UDP
       tunnel. The latter behavior seems more appropriate because UDP tunnel
       information becomes more relevant as it moves closer to the
       destination node. The ANS_KEY behavior is not satisfactory in some
       cases such as multi-layered graphs where the first hop is located
       before a NAT.
    
    Ultimately, the rationale behind this whole process is to improve UDP
    hole punching capabilities when port translation is in effect, and more
    generally, to make tinc more reliable in (very) hostile network
    conditions (such as multi-layered NAT).

commit 6568cffd52d4803effaf52a9bb9c98d69cf7922a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Mar 14 12:02:29 2015 +0000

    --syslog and --logfile are mutually exclusive.

commit 15ad628f06895175d7e629ce0188805dc00159fd
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Mar 14 12:02:06 2015 +0000

    Fix the case where we detach and use --logfile.

commit 04fc19112da5e7fcefefcf6e490987cdcfb6f620
Merge: f9ecaa10 19d16e40
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Mar 14 11:45:55 2015 +0000

    Merge remote-tracking branch 'seehuhn/1.1' into 1.1

commit f9ecaa10768926302f24a70975f36e360b51c8ce
Merge: c23e5038 2e7f68ad
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Mar 14 11:44:38 2015 +0000

    Merge remote-tracking branch 'dechamps/sptpsabort' into 1.1

commit 19d16e40ccfb39461eda5336f4e754e10a640aba
Author: Jochen Voss <voss@seehuhn.de>
Date:   Fri Mar 13 11:05:22 2015 +0000

    Add a new --syslog option for tincd.
    
    This commit adds a new command line option for tincd which allows to
    use tincd in non-detached mode with log messages still going to
    syslog.  The motivation for this change is to ease use of tincd
    in Docker containers.

commit 2e7f68ad2b51648b89c4b5c61aeb4cec67c2fbbb
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 17:32:39 2015 +0000

    Don't abort() willy-nilly in SPTPS code.
    
    If receive_handshake() or the receive_record() user callback returns an
    error, sptps_receive_data_datagram() crashes the entire process. This is
    heavy-handed, makes tinc very brittle to certain failures (i.e.
    unexpected packets), and is inconsistent with the rest of SPTPS code.

commit c23e50385d9de538af676706596f6508b2ceb01a
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 14:32:01 2015 +0000

    Fix UDP/MTU discovery in intermediate SPTPS UDP relays.
    
    Refactoring commit 81578484dc74fd92f1b01f71f882016f120ab1de seems to
    have introduced a regression as it moved discovery code away from
    send_sptps_data_priv() and within send_packet(). The issue is,
    send_packet() is not called when the node is simply relaying an UDP
    SPTPS packet: indeed, send_sptps_data_priv() is called directly from
    handle_incoming_vpn_data() in that case.
    
    As a result, try_tx_sptps() is not called in the relaying case, which in
    practice means that a relay doesn't initiate UDP/MTU discovery with the
    next relay (unless some other activity compels it to do so). This can
    result in packets getting sent over TCP instead of UDP from the relay.

commit 0f8e2cc78cafe47a087d3fc9b480551b841aeb30
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Mar 8 14:20:15 2015 +0000

    Fix dynamic UDP SPTPS relaying.
    
    Refactoring commit 0e653260478005eb7c824a9a1a3df04f39938cd6 broke UDP
    SPTPS relaying by accidently removing try_tx_sptps() logic related to
    establishing connectivity to so-called "dynamic" relays (i.e. relays
    that are not specified by IndirectData configuration statements, but
    are used on-the-fly to circumvent loss of direct UDP connectivity).
    
    Specifically, the TX path was not trying to establish a tunnel to
    dynamic relays (nexthop) anymore. This meant that MTU was not being
    discovered with dynamic relays, which basically meant that all packets
    being sent to dynamic relays went over TCP, thereby defeating the whole
    purpose of SPTPS UDP relaying.
    
    Note that this bug could easily go unnoticed if a tunnel was established
    with the dynamic tunnel for some other reason (i.e. exchanging actual
    data packets with the relay node).

commit 537c3528863c4736e877c4d1b6c6579940e6df5d
Author: xentec <artificial.i7@gmail.com>
Date:   Tue Feb 17 04:02:35 2015 +0100

    Fix compile errors introduced in cfe9285adf391ab66faeb5def811fe08e47a221a
    
    Compiling with `--disable-legacy-protocol` resulted in failure caused by the missing exclusion of some symbols in net_packet.c.

commit cffcaf966b65a61943a00120f1ec5c868c917c1f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 16 08:42:30 2015 +0100

    Suppress warnings about parsing Ed25519 keys when they are not present.

commit 833a8a048b22612cd12d703d55a71448b7179b4a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 16 08:26:49 2015 +0100

    Document that --force should precede commands.

commit 85000a30ca68d3c8e9a98eb9537f4d1505bd849e
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Tue Feb 10 01:17:12 2015 +0100

    Fixed variables.test testsuite after 'Make "tinc add" idempotent.' change.

commit 4b2ddded2c8ae1a1a5930637552eeb48f30d6530
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 9 15:23:59 2015 +0100

    Make "tinc add" idempotent.
    
    When calling "tinc add" multiple times with the same variable and value,
    make sure only one unique line is added to the configuration file.

commit 0b310bf406dbe58afe37fa31156b9ea47599d7be
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Feb 9 15:16:36 2015 +0100

    Always call res_init() before getaddrinfo().
    
    Unfortunately, glibc assumes that /etc/resolv.conf is a static file that
    never changes. Even on servers, /etc/resolv.conf might be a dynamically
    generated file, and we never know when it changes. So just call
    res_init() every time, so glibc uses up-to-date nameserver information.

commit 268e3ffca7b45cfc736e1bc9bec7a113c6c45701
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jan 15 22:57:56 2015 +0100

    Add the "fsck" command to the CLI.
    
    This will report possible problems in the configuration files, and in
    some cases offers to fix them.
    
    The code is far from perfect yet. It expects keys to be in their default
    locations, it doesn't check for Public/PrivateKey[File] statemetns yet.
    It also does not correctly handle Ed25519 public keys yet.

commit a95e182d9ca54960383bfe3950b2b798e1f24f9e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Jan 12 14:43:32 2015 +0100

    Improve packet source detection.
    
    When no UDP communication has been done yet, tinc establishes a guess
    for the UDP address+port of each node. However, when there are multiple nodes
    behind a NAT, tinc will guess the exact same address+port combination
    for them, because it doesn't know about the NAT mappings yet. So when
    receiving a packet, don't trust that guess unless we have confirmed UDP
    communication.
    
    This ensures try_harder() is called in such cases. However, this
    function was actually very inefficient, trying to verify packets
    multiple times for nodes with multiple edges. Only call try_mac() at
    most once per node.

commit ae5b56c03d1e1af7561d7f1d1d8a333c3a9691ff
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 17:44:50 2015 +0100

    Send gratuitous type 2 probe replies.
    
    If we receive any traffic from another node, we periodically send back a
    gratuitous type 2 probe reply with the maximum received packet length.
    On the other node, this causes the udp and perhaps mtu probe timers to
    be reset, so it does not need to send a probe request. Gratuitous probe
    replies from another node also count as received traffic for this
    purpose, so for nodes that also have a meta-connection, UDP keepalive
    packets in principle can now solely be type 2 replies. This reduces the
    amount of probe traffic even more.
    
    To work, gratuitous replies should be sent slightly more often than
    udp_discovery_keepalive_interval, so probe requests won't be triggered.
    This also means that the timer resolution must be smaller than the
    difference between the two, and at the moment it's kind of a hack.

commit 7b76b7ac35b49b8a94ad91c432886a0a54e144d1
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 16:14:05 2015 +0100

    Send the size of the largest recently received packets in type 2 probe replies.

commit 79b6adb489dde4ae92207ae7b9146f4e141c946c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 16:12:57 2015 +0100

    Move UDP probe reply code into its own function.
    
    This reduces the level of indentation, and prepares for sending gratuitous type 2 probe replies.

commit f0afde0467443969eb408090d6b8ee542768ee33
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 16:10:58 2015 +0100

    Keep track of the largest UDP packet size received from a node.

commit d63941593736fbf268f2770d42e7f3f6a2132fae
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 15:38:56 2015 +0100

    Move detection of PMTU decrease to try_mtu().
    
    When we have fixed the PMTU, n->mtuprobes == -1. When we send MTU probes
    when mtuprobes == -1, decrease mtuprobes, and reset it back to -1 in
    mtu_probe_h(). If mtuprobes < -1, send MTU probes every second, until
    mtuprobes <= -4, in which case we will restart MTU discovery.

commit e97e9b22cb6061070611212a06756fb493846955
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 14:44:27 2015 +0100

    Send MTU probes only once every PingInterval.

commit 088b5fd9ee6d5f566e8726eae861cbc7cd832b17
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 14:44:15 2015 +0100

    Remove RTT and packet loss estimation code.
    
    This is not working at all anymore. Just remove it, and we'll do another
    attempt at RTT, bandwidth and packet loss estimation after the new
    probing code stabilizes.

commit ce7079f4af3157eaef514d6d160933a016b2ab62
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 13:53:16 2015 +0100

    Only send small packets during UDP probes.
    
    We are trying to decouple UDP probing from MTU probing, so only send
    very small packets during UDP probing. This significantly reduces the
    amount of traffic sent (54 to 67 bytes per probe instead of 1500 bytes).
    
    This means the MTU probing code takes over sending PMTU sized probes,
    but this commit does not take care of detecting PMTU decreases.

commit e4077c00c6fead63467d296c89d5afc2860e2935
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 13:51:55 2015 +0100

    Immediately send our key when a meta-connection is established.
    
    This is what 1.0 does, and speeds up the UDP probing.

commit eb7a0db18ea71a44999d6a37b4b179dac0ed9bc7
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 13:31:01 2015 +0100

    Always keep UDP mappings alive for nodes that also have a meta-connection.
    
    This is necessary for assisting with UDP hole punching. But we don't
    need to know the PMTU for this, so only send UDP probes.

commit 545ecb339654573b3ee91bffb45c8282154885c6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 11 01:52:37 2015 +0100

    Fix segfault when sptps_test cannot open the key files.

commit 69d4ccc43781152dc90521b3f517b0d9588ae207
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Dec 30 09:56:30 2014 +0000

    Fix typo in logging statement.
    
    This was introduced in cfe9285adf391ab66faeb5def811fe08e47a221a.

commit 6fcfe763aa54e0522e726dc088b23d24899794d8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 23:58:35 2015 +0100

    Don't send probe replies if we don't have the other's key.
    
    This can happen with the legacy protocol. Don't try to send anything
    back in this case, otherwise it will be sent via TCP, which is silly.

commit f3801cb54311da2c30cbe27cd66559a2ea5daa91
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 23:52:23 2015 +0100

    Proactively send our own key when we request another node's key.

commit c26bb47af130d48d003afd29af4d7ea6ad0538c5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 23:33:55 2015 +0100

    Fix size of type 2 probe replies.
    
    Type 2 replies should be as small as possible. The minimum payload size
    for probe packets is 14 bytes, otherwise they won't be recognized as
    such.

commit 0209f12d27d29f3aedc09b228bd289305851c75d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 23:00:51 2015 +0100

    Correctly estimate the initial MTU for legacy packets.

commit 0e653260478005eb7c824a9a1a3df04f39938cd6
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 22:28:47 2015 +0100

    Try to clarify the new code in net_packet.c a bit.
    
    Mainly by trying to reduce complex if statements, by splitting try_tx() into try_tx_legacy() and
    try_tx_sptps(), since they don't share a lot of code.

commit 6056f1c13bb37bf711dff9c25a6eaea99f14d31f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jan 10 22:26:33 2015 +0100

    Remember whether we sent our key to another node.
    
    In tinc 1.0.x, this was tracked in node->inkey, however in tinc 1.1 we have an abstraction layer for
    the legacy cipher and digest, and we don't keep an explicit copy of the key around. We cannot use
    cipher_active() or digest_active(), since it is possible to set both to the null algorithm. So add a bit to
    node_status_t.

commit f1f2df07387bc48a3b165c85a0493ff2774de737
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 4 16:00:02 2015 +0100

    Use global "now" in try_udp() and try_mtu().

commit b737103a9187e0191dbc1995da3399ab3dbcdc66
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 4 14:19:23 2015 +0100

    Use void pointers for opaque data blobs in the SHA512 code.

commit 4b42518813de7459a1fb264fe9ddfaf066ecc22b
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jan 4 14:15:35 2015 +0100

    Fix indentation and some whitespace issues.

commit 07108117ceddaff0654f9def703e717c002f3e2d
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jan 3 10:05:57 2015 +0000

    Use a different UDP discovery interval if the tunnel is established.
    
    This introduces a new configuration option,
    UDPDiscoveryKeepaliveInterval, which is used as the UDP discovery
    interval once the UDP tunnel is established. The pre-existing option,
    UDPDiscoveryInterval, is therefore only used before UDP connectivity
    is established.
    
    The defaults are set so that tinc sends UDP pings more aggressively
    if the tunnel is not established yet. This is appropriate since the
    size of probes in that scenario is very small (16 bytes).

commit 06345f89b9a1e9acaf74cbbf896559b4286c102e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jan 1 16:59:45 2015 +0000

    Recalculate and resend MTU probes if they are too large for the system.
    
    Currently, if a MTU probe is sent and gets rejected by the system
    because it is too large (i.e. send() returns EMSGSIZE), the MTU
    discovery algorithm is not aware of it and still behaves as if the probe
    was actually sent.
    
    This patch makes the MTU discovery algorithm recalculate and send a new
    probe when this happens, so that the probe "slot" does not go to waste.

commit f89319f9815da5ece8e96f1a2a777fb6d2e31c33
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Dec 31 16:21:08 2014 +0000

    Fine-tune the MTU discovery multiplier for the maxmtu < MTU case.
    
    The original multiplier constant for the MTU discovery algorithm, 0.97,
    assumes a somewhat pessmistic scenario where we don't get any help from
    the OS - i.e. maxmtu never changes. This can happen if IP_MTU is not
    usable and the OS doesn't reject overly large packets.
    
    However, in most systems the OS will, in fact, contribute to the MTU
    discovery process. In these situations, an actual MTU equal to maxmtu
    is quite likely (as opposed to the maxmtu = 1518 case where that is
    highly unlikely, unless the physical network supports jumbo frames).
    It therefore makes sense to use a multiplier of 1 - that will make the
    first probe length equal to maxmtu.
    
    The best results are obtained if the OS supports the getsockopt(IP_MTU)
    call, and its result is accurate. In that case, tinc will typically fix
    the MTU after one single probe(!), like so:
    
        Using system-provided maximum tinc MTU for foobar (1.2.3.4 port 655): 1442
        Sending UDP probe length 1442 to foobar (1.2.3.4 port 655)
        Got type 2 UDP probe reply 1442 from foobar (1.2.3.4 port 655)
        Fixing MTU of foobar (1.2.3.4 port 655) to 1442 after 1 probes

commit bce17c83e871cb8a8c9158045eaf13f1be4b3d13
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Dec 31 16:12:11 2014 +0000

    Add IP_MTU-based maxmtu estimation.
    
    Linux provides a getsockopt() option, IP_MTU, to get the kernel's best
    guess at a connection MTU. In practice, it seems to return the MTU of
    the physical interface the socket is using.
    
    This patch uses this option to initialize maxmtu to a better value when
    MTU discovery starts.
    
    Unfortunately, this is not supported on Windows. Winsock has options
    such as SO_MAX_MSG_SIZE, SO_MAXDG and SO_MAXPATHDG but they seem useless
    as they always return absurdly large values (typically, 65507), as
    confirmed by http://support.microsoft.com/kb/822061/

commit c1532035e2850dc4ec0eb22a6d51208e3128eb94
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Wed Dec 31 09:26:14 2014 +0000

    Don't send MTU probes smaller than 512 bytes.
    
    If MTU discovery comes up with an MTU smaller than 512 bytes (e.g. due
    to massive packet loss), it's pretty much guaranteed to be wrong. Even
    if it's not, most Internet applications assume the MTU will be at least
    512, so fixing the MTU to a small value is likely to cause trouble
    anyway.
    
    This also makes the discovery algorithm converge even faster, since the
    interval it has to consider is smaller.

commit 172cbe6771fd3b98233f71e42ac9c9407d534568
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Dec 30 17:02:38 2014 +0000

    Adjust MTU probe counts.
    
    The recently introduced new MTU discovery algorithm converges much
    faster than the previous one, which allows us to reduce the number
    of probes required before we can confidently fix the MTU. This commit
    reduces the number of initial discovery probes from 90 to 20. With the
    new algorithm this is more than enough to get to the precise (byte-level
    accuracy) MTU value; in cases of packet loss or weird MTU values for
    which the algorithm is not optimized, we should get close to the actual
    value, and then we rely on MTU increase detection (steady state probes)
    to fine-tune it later if the need arises.
    
    This patch also triggers MTU increase detection even if the MTU we have
    is off by only one byte. Previously we only did that if it was off by at
    least 8 bytes. Considering that (1) this should happen less often,
    (2) restarting MTU discovery is cheaper than before and (3) having MTUs
    that are subtly off from their intended values by just a few bytes
    sounds like trouble, this sounds like a good idea.

commit 24d28adf64934c8d726959e25dce8c10dbd10d1f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Dec 30 16:34:48 2014 +0000

    Use a smarter algorithm for choosing MTU discovery probe sizes.
    
    Currently, tinc uses a naive algorithm for choosing MTU discovery probe
    sizes, picking a size at random between minmtu and maxmtu.
    
    This is of course suboptimal - since the behavior of probes is
    deterministic (assuming no packet loss), it seems likely that using a
    non-deterministic discovery algorithm will not yield the best results.
    Furthermore, the randomness introduces a lot of variation in convergence
    times.
    
    The random solution also suffers from pathological cases - since it's
    using a uniform distribution, it doesn't take into account the fact that
    it's often more interesting to send small probes rather than large ones,
    because getting replies is the only way we can make progress (assuming
    the worst case scenario in which the OS doesn't know anything, therefore
    keeping maxmtu constant). This can lead to absurd situations where the
    discovery algorithm is close to the real MTU, but can't get to it
    because the random number generator keeps generating numbers that are
    past it.
    
    The algorithm implemented in this patch aims to improve on the naive
    random algorithm. It is organized around "cycles" of 8 probes; the sizes
    of the probes decrease as we go through the cycle, thus making sure the
    algorithm can cover lots of ground quickly (in case we're far from
    actual MTU), but also examining the local area (in case we're close to
    actual MTU). Using cycles ensures that the algorithm will "go back" to
    large probes to better cover the new interval and to protect against
    packet loss.
    
    For the probe size itself, various mathematical models were simulated in
    an attempt to find the one that converges the fastest; it has been
    determined that using an exponential based on the size of the remaining
    interval was the most effective option. The exponential is adjusted with
    a magic multiplier fine-tuned to make tinc jump to the "most
    interesting" (i.e. 1400+) section as soon as discovery starts.
    
    Simulations indicate that assuming no packet loss and no help from the
    OS (i.e. maxmtu stays constant), this algorithm will typically converge
    to the *exact* MTU value in less than 10 probes, and will get within 8
    bytes in less than 5 probes, for actual MTUs between 1417 and ~1450
    (which is the range the algorithm is fine-tuned for). In contrast, the
    previous algorithm gives results all over the place, sometimes taking
    30+ probes to get in the ballpark. Because of the issues with the
    distribution, the previous algorithm sometimes never gets to the precise
    MTU value within any reasonable amount of time - in contrast, the new
    algorithm will always get to the precise value in less than 30 probes,
    even if the actual MTU is completely outside the optimized range.

commit c22560ae3283a8f5f12eee8ee4dcaa5e65ee8cf9
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Dec 30 10:47:56 2014 +0000

    Remove bandwidth estimation code.
    
    tinc bandwidth estimation has always been quite unreliable (at least in
    my experience), but there's no chance of it working anymore since the
    last changes to MTU discovery code, because packets are not sent in
    batches of three anymore.
    
    This commit removes the dead code - fortunately, nothing depends on this
    estimation (it's not even shown in node info). We probably need be
    smarter about this if we do want this estimation back.

commit 1b972f22733dc979568bc0ad8ebe0c711887e447
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Tue Dec 30 10:16:32 2014 +0000

    Send one MTU probe at a time.
    
    Currently, tinc sends MTU probes in batches of three every second. This
    commit changes that to send one packet every 333 milliseconds instead.
    
    This change brings two benefits:
    
     - It makes MTU probing faster, because MTU probe lengths are calculated
       based on minmtu, and minmtu is adjusted based on the replies. When
       sending batches of three packets, all three packets are based on the
       same minmtu estimation; in contrast, by sending one packet more
       frequently, each subsequent packet can benefit from the replies that
       have been received since the last packet was sent. As a result, MTU
       discovery converges much faster (2-3 times as fast, typically).
    
     - It reduces network spikiness - it's more network-friendly to send
       one packet from time to time as opposed to sending bursts.

commit 5bdc1f2b82869d379812879334dbf2b549ff48db
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jan 1 16:04:08 2015 +0000

    Use -1 to identify the post-initial MTU discovery state.
    
    This is a minor cosmetic nit to emphasise the distinction between the
    initial MTU discovery phase, and the post-initial phase (i.e. maxmtu
    checking).
    
    Furthermore, this is an improvement with regard to the DRY (Don't
    Repeat Yourself) principle, as the maximum mtuprobes value is only
    written once.

commit df6f67895723dd0c4226fa0f94257245a81a273f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jan 1 10:32:14 2015 +0000

    Fix MTU as soon as possible.
    
    If a probe reply is received that makes minmtu equal to maxmtu, we
    have to wait until try_mtu() runs to realize that. Since try_mtu()
    runs after a packet is sent, this means there is at least one packet
    (possibly more, depending on timing) that won't benefit from the
    fixed MTU. This also happens when maxmtu is updated from the send()
    path.
    
    This commit fixes that by making sure we check whether the MTU can be
    fixed every time minmtu or maxmtu is touched.

commit 97cf4783188b8027d2309ce594fea5fc6daf31d1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Dec 29 17:05:19 2014 +0000

    Move try_mtu() closer to try_tx().
    
    This moves related functions together, and is a pure cut-and-paste
    change. The reason it was not done in the previous commit is because it
    would have made the diff harder to review.

commit 98716a227ee39fdcdfafa7309adb73499311a2ce
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Dec 29 16:47:49 2014 +0000

    Move PMTU discovery code into the TX path.
    
    Currently, the PMTU discovery code is run by a timeout callback,
    independently of tunnel activity. This commit moves it into the TX
    path, meaning that send_mtu_probe_handler() is only called if a
    packet is about to be sent. Consequently, it has been renamed to
    try_mtu() for consistency with try_tx(), try_udp() and try_sptps().
    
    Running PMTU discovery code only as part of the TX path prevents
    PMTU discovery from generating unreasonable amounts of traffic when
    the "real" traffic is negligible. One extreme example is sending one
    real packet and then going silent: in the current code this one little
    packet will result in the entire PMTU discovery algorithm being run
    from start to finish, resulting in absurd write traffic amplification.
    With this patch, PMTU discovery stops as soon as "real" packets stop
    flowing, and will be no more aggressive than the underlying traffic.
    
    Furthermore, try_mtu() only runs if there is confirmed UDP
    connectivity as per the UDP discovery mechanism. This prevents
    unnecessary network chatter - previously, the PMTU discovery code
    would send bursts of (potentially large) probe packets every second
    even if there was nothing on the other side. With this patch, the
    PMTU code only does that if something replied to the lightweight UDP
    discovery pings.
    
    These inefficiencies were made even worse when the node is not a
    direct neighbour, as tinc will use PMTU discovery both on the
    destination node *and* the relay. UDP discovery is more lightweight for
    this purpose.
    
    As a bonus, this code simplifies overall code somewhat - state is
    easier to manage when code is run in predictable contexts as opposed
    to "surprise callbacks". In addition, there is no need to call PMTU
    discovery code outside of net_packet.c anymore, thereby simplifying
    module boundaries.

commit eef792c01ed1704c03d55163de3f302a3c1d42fa
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Dec 29 16:11:04 2014 +0000

    Remove PMTU discovery code redundant with UDP discovery.
    
    This is a rewrite of the send_mtu_probe_handler() function to make it
    focus on the actual discovery of PMTU. In particular, the PMTU
    discovery code doesn't care about tunnel state anymore - it only cares
    about doing the initial PMTU discovery, and once that's done, making
    sure PMTU did not increase by checking it from time to time. All other
    duties have already been rewritten in the UDP discovery code.
    
    As a result, the send_mtu_probe_handler(), which previously implemented
    a nightmarish state machine which was very difficult to follow and
    understand, has been massively simplified. We moved from four persistent
    states to only two - initial discovery and steady state.
    
    Furthermore, a side effect is that network chatter is reduced: instead
    of sending bursts of three minmtu-sized packets in the steady state,
    there is only one such packet that's sent from the UDP discovery code.
    However, that introduces a slight regression in the bandwidth estimation
    code, which relies on three-packet bursts in order to function.
    Considering that this estimation is extremely unreliable (in my
    experience) and isn't relied on by anything, this seems like an
    acceptable regression.

commit 88026f27715774a7647c109ba5594068f0ba56af
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Dec 29 15:40:55 2014 +0000

    Move responsibility for local discovery to UDP discovery.
    
    Since UDP discovery is the place where UDP feasibility is checked, it
    makes sense to test for local connectivity as well. This was previously
    done as part of PMTU discovery.

commit 7939ee12836bf2ef772f2a6a1e805ee0d64a8e70
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Dec 29 10:34:39 2014 +0000

    Add UDP discovery mechanism.
    
    This adds a new mechanism by which tinc can determine if a node is
    reachable via UDP. The new mechanism is currently redundant with the
    PMTU discovery mechanism - that will be fixed in a future commit.
    
    Conceptually, the UDP discovery mechanism works similarly to PMTU
    discovery: it sends UDP probes (of minmtu size, to make sure the tunnel
    is fully usable), and assumes UDP is usable if it gets replies. It
    assumes UDP is broken if too much time has passed since the last reply.
    
    The big difference with the current PMTU discovery mechanism, however,
    is that UDP discovery probes are only triggered as part of the
    packet TX path (through try_tx()). This is quite interesting, because
    it means tinc will never send UDP pings more often than normal packets,
    and most importantly, it will automatically stop sending pings as soon
    as packets stop flowing, thereby nicely reducing network chatter.
    
    Of course, there are small drawbacks in some edge cases: for example,
    if a node only sends one packet every minute to another node, these
    packets will only be sent over TCP, because the interval between packets
    is too long for tinc to maintain the UDP tunnel. I consider this a
    feature, not a bug: I believe it is appropriate to use TCP in scenarios
    where traffic is negligible, so that we don't pollute the network with
    pings just to maintain a UDP tunnel that's seeing negligible usage.

commit 5d6478b9fbb7379fe6017b2b74c0f1ccb3d2501f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 28 17:29:03 2014 +0000

    Move try_sptps() closer to try_tx().
    
    This moves related functions together. try_tx() is at the right place
    since its only caller is send_packet().
    
    This is a pure cut-and-paste change. The reason it was not done in the
    previous commit is because it would have made the diff harder to review.

commit 81578484dc74fd92f1b01f71f882016f120ab1de
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Dec 28 17:16:27 2014 +0000

    Add the try_tx() function.
    
    Currently, the TX path (starting from send_packet()) in tinc has three
    responsabilities:
    
     - Making sure packets can be sent (e.g. fetching SPTPS keys);
     - Making sure they can be sent optimally (e.g. fetching non-SPTPS keys
       so that UDP can be used);
     - Sending the actual packet, if feasible.
    
    The first two are closely related; the third one, however, can be
    cleanly separated from the other two - meaning, we can loosen code
    coupling between sending packets and "optimizing" the way packets are
    sent. This will become increasingly important as future commits will
    move more tunnel establishment and maintenance code into the TX path,
    so we will benefit from a cleaner separation of concerns.
    
    This is especially relevant because of the dual nature of the TX path
    (SPTPS versus non-SPTPS), which can make things really complicated when
    trying to share low-level code between both.
    
    In this commit, code related to establishing or improving tunnels is
    moved away from the core TX path by introducing the "try_*()" family of
    function, of which try_sptps() already existed before this commit.
    
    This is a pure refactoring; this commit shouldn't introduce any change
    in behavior.

commit 950edc0744dfa04790ae274e8b7f55b1a990a43c
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Oct 12 19:44:33 2014 +0100

    Clarify the send_mtu_probe() function.
    
    This cleans up the PMTU probing function a little bit. It moves the
    low-level sending of packets to a separate function, so that the code
    reads naturally instead of using a weird for loop with "special
    indexes". In addition, comments are moved inside the body of the
    function for additional context.
    
    This shouldn't introduce any change of behavior, except for local
    discovery which has some minor logic fixes and which now always uses
    small packets (16 bytes) because there's no need for a full-length
    probe just to try the local network.

commit d28f33228635e78dac8f9e9bcaec92690f2ca10a
Author: Guus Sliepen <guus@sliepen.org>
Date:   Thu Jan 1 00:52:39 2015 +0100

    Fixes for bugs in src/Makefile.am and tincctl.c introduced by cfe9285adf391ab66faeb5def811fe08e47a221a.

commit 4d50f9f3485503099f5cb6e8486e9b98b72cb9be
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Dec 30 11:16:08 2014 +0100

    Add missing nolegacy/crypto.c and prf.c.

commit cfe9285adf391ab66faeb5def811fe08e47a221a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Dec 29 22:57:18 2014 +0100

    Allow tinc to be compiled without OpenSSL.
    
    The option "--disable-legacy-protocol" was added to the configure
    script. The new protocol does not depend on any external crypto
    libraries, so when the option is used tinc is no longer linked to
    OpenSSL's libcrypto.

commit 8d32b283b016e205b051b0bacb49a1e86fd5e1bc
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Dec 27 09:22:31 2014 +0100

    Releasing 1.1pre11.

commit db465434e2736f6e052e5c52d3613ad81b4bde10
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Dec 27 09:20:46 2014 +0100

    Add BroadcastSubnet and DeviceStandby options to the manual and completion.

commit 26d3ee0dd9b770a857615752b5c5588be0354a16
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Dec 27 09:08:34 2014 +0100

    Better default paths for log and PID files on Windows.

commit b78436ff1e9afd767c3da473d34b7553d8411b6a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 18:22:13 2014 +0100

    Remove AES-GCM support.

commit 128a37397432e5e63099633e275c65a652c16673
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 18:12:28 2014 +0100

    Linux doesn't like .PHONY .o files.
    
    In order to please every OS, make version.c .PHONY again, and add an
    empty rule to make version.c.

commit 69689f908b0c9a14b7108b7ab8edd92facc53ddf
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 17:53:40 2014 +0100

    We don't depend on ECDH functions from OpenSSL anymore.

commit aa2d4f8dd9bab794dd197b92ba54e6428400555f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 15:58:28 2014 +0100

    BSD make doesn't like .PHONY .c files.
    
    It then thinks there should be a rule to make the .c file, which does
    not exist of course. Luckily, we can tell it that version.o is .PHONY,
    and this will still cause the .o file to be regenerated and linked into
    the binaries everytime make is called.

commit 8ee4004edfbc79b1a17bf03c262f063f2f4c128d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 15:40:09 2014 +0100

    Check whether res_init() really lives in libresolv.
    
    On some platforms (Mac OS X for example), the res_init() function requires
    linking with libresolv. On others (Linux, OpenBSD for example), res_init()
    lives in libc.

commit 9f20922d62d258d7f5f1ef30dcd538c661062439
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 14:59:15 2014 +0100

    Update THANKS file.

commit 880d74ad2d8a6d73c2e94ec54df542b88dc0c6f4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Dec 26 14:38:01 2014 +0100

    Allow running tinc without RSA keys.
    
    This allows one to run tinc with only Ed25519 keys, forcing tinc to
    always use the SPTPS protocol.

commit 266afc6c63d3d02584feb24b69063f97057daac8
Merge: 7730d5f3 c269a17c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Dec 25 18:13:24 2014 +0100

    Merge remote-tracking branch 'groxxda/gui-fixes' into 1.1

commit 7730d5f3ed9bd7c011dced5808130ffcbd74ea6b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Oct 12 12:14:46 2014 +0100

    Use plain old PACKET for TCP packets sent directly to a neighbor.
    
    Currently, when sending packets over TCP where the final recipient is
    a node we have a direct metaconnection to, tinc first establishes a
    SPTPS handshake between the two neighbors.
    
    It turns out this SPTPS tunnel is not actually useful, because the
    packet is only being sent over one metaconnection with no intermediate
    nodes, and the metaconnection itself is already secured using a separate
    SPTPS handshake.
    
    Therefore it seems simpler and more efficient to simply send these
    packets directly over the metaconnection itself without any additional
    layer. This commits implements this solution without any changes to the
    metaprotocol, since the appropriate message already exists: it's the
    good old "plaintext" PACKET message.
    
    This change brings two significant benefits:
    
    - Packets to neighbors can be sent immediately - there is no initial
      delay and packet loss previously caused by the SPTPS handshake;
    
    - Performance of sending packets to neighbors over TCP is greatly
      improved since the data only goes through one round of encryption
      instead of two.
    
    Conflicts:
            src/net_packet.c

commit 0356efecb6385b59a69bea220057396d6daa30bc
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Oct 12 11:41:08 2014 +0100

    Don't spontaneously start SPTPS with neighbors.
    
    Currently, when tinc establishes a metaconnection, it automatically
    starts a VPN SPTPS tunnel with the other side of the metaconnection.
    
    It is not clear what this is trying to accomplish. Having a
    metaconnection with a node does not necessarily mean we're going to send
    packets to that node. This patch removes this behavior, thereby
    simplifying code paths and removing unnecessary network chatter.
    
    Naturally, this introduces a slight delay (as well as at least one
    initial packet loss) between the moment a metaconnection is established
    and the moment VPN packets can be exchanged between the two nodes.
    However this is no different to the non-neighbor case, so it makes
    things more consistent and therefore easier to reason about.

commit 6b92ac505d2cd5c7e390d49bf1f0b399ef9f8327
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 22:23:24 2014 +0100

    Add a variable offset to vpn_packet_t, drop sptps_packet_t.
    
    The offset value indicates where the actual payload starts, so we can
    process both legacy and SPTPS UDP packets without having to do casting
    tricks and/or moving memory around.

commit 107d9c7da5b206425a8e1643a6849ea990f725f8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 22:15:40 2014 +0100

    Use void pointers for opaque data blobs in the SPTPS code.

commit 3df86ef17bce9f24c3dad79ccc2b17aa6e93ea34
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 17:31:33 2014 +0100

    Fix memory leaks found by Valgrind.

commit d00d8dbb9b122a17ef93090de10396ebdd2c4a84
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 17:06:05 2014 +0100

    Don't use myself->name in device_disable(), it's already freed.

commit 313de46e70b249de2938b04e7fc9c3872d99474a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 16:59:08 2014 +0100

    Don't pass uninitialized bytes to ioctl().

commit a99ded7d987c3242f972162e02767c498257f2b8
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 24 16:54:12 2014 +0100

    Avoid using OpenSSL's random number functions.

commit 199573f1e834290290a1c278072a153b90443b05
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 14 13:05:30 2014 +0100

    Fix reception of SPTPS UDP packets.
    
    Some bugs were introduced in 46fa12e666badb79e480c4b2399787551f8266d0.

commit 558b19c2432d938afc4a659668bd461ace6ed744
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 14 12:42:03 2014 +0100

    Fix segfault when receiving UDP packets with an unknown source address.

commit 5104001bae7d09040703ddbe18cf8781c7aaa94f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Dec 8 08:43:15 2014 +0100

    Changes that should have been in commit 46fa12e666badb79e480c4b2399787551f8266d0.

commit 46fa12e666badb79e480c4b2399787551f8266d0
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Dec 8 00:58:09 2014 +0100

    Make UDP packet handling more efficient.
    
    Limit the amount of address/ID lookups to the minimum in all cases:
    
    1) Legacy packets, need an address lookup.
    2) Indirect SPTPS packets, need an address lookup + two ID lookups.
    3) Direct SPTPS packets, need an ID or an address lookup.
    
    So we start with an address lookup. If the source is an 1.1 node, we know it's an SPTPS packet,
    and then the check for direct packets is a simple check if dstid is zero. If not, do the srcid and dstid
    lookup. If the source is an 1.0 node, we don't have to do anything else.
    
    If the address is unknown, we first check whether it's from a 1.1 node by assuming it has a valid srcid
    and verifying the packet. If not, use the old try_harder().

commit 263d9903826ffb65aec89bdf5d46f72bd183d467
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Dec 8 00:44:38 2014 +0100

    Avoid memmove() for legacy UDP packets.

commit c2319e90b16962fe899bc60abc8af0e2542bb176
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 7 22:11:37 2014 +0100

    Cache node IDs in a hash table for faster lookups.

commit 9d48d5b7d48ad23e23eae02feae69bdc5ae80c8e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 7 22:10:16 2014 +0100

    Add an explicit hash_delete() function.

commit 6062df4a0fa6214d21ac83d885087e9dbdac3f39
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 7 21:42:20 2014 +0100

    Better log messages when we already know the peer's key during an upgrade.
    
    If the peer presents a different one from the one we already know, log
    an error. Otherwise, log an informational message, and terminate in the
    same way as we would if we didn't already have that key.

commit 148a4c9161735a76b0a4ce73ffaaec21d76ca702
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Fri Dec 5 03:06:44 2014 +0100

    Try handling the case when the first side knows the ecdsa key of
    the second, but the second not the key of the first.
    (And both have the experimental protocol enabled)

commit b90c42a33b78f22b7046da5a5445c712020f30eb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 7 17:25:30 2014 +0100

    Log an error message with the node's name when receiving bad SPTPS packets.
    
    The SPTPS code doesn't know about nodes, so when it logs an error about
    a bad packet, it doesn't log which node it came from. So add a log
    message with the node's name and hostname in receive_udppacket().

commit 660a2c7d1bf7f5fba905b525bc7c3b9a5ac2ec99
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Dec 7 17:20:18 2014 +0100

    Check validity of Ed25519 key during an upgrade.

commit 5716c8877fd705d5af36d82e27632b123fa5dde0
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Fri Dec 5 02:41:55 2014 +0100

    Do not disconnect when no ecdsa key is known yet.
    
    This is the normal case when we support the experimental protocol,
    but the other side is a tinc 1.0 which does not.

commit dd6b0e65b96280235893705a947eac4a1c71276e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Dec 3 14:51:45 2014 +0100

    Fix compiler warnings.

commit 790b107f668a886c3b335e68b9440ef5152a2844
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Oct 4 16:33:33 2014 +0100

    Query the Linux device for its MAC address.
    
    On Linux, tinc doesn't know the MAC address of the TAP device until the
    first read. This means that if no packets are sent through the
    interface, tinc won't be able to figure out which MAC address to tag
    incoming packets with. As a result, it is impossible to receive any
    packet until at least one packet has been sent.
    
    When IPv6 is disabled Linux does not spontanously send any packets
    when the interface comes up. At first users wonder why the node is not
    responding to ICMP pings, and then as soon as at least one packet is
    sent through the interface, pings mysteriously start working, resulting
    in user confusion.
    
    This change fixes that problem by making sure tinc is aware of the
    device's MAC address even before the first packet is sent.

commit c269a17ca4d4e4946a3f8ab05da8cdd338d97ffb
Author: groxxda <ried@mytum.de>
Date:   Tue Oct 14 22:18:56 2014 +0200

      tinc-gui: Don't assign broadcast subnets to any node, fix parsing of Edges, fix diplay of Subnet.weight.

commit 9a366544c297d5c558800f9ffc301e2cb5a6a672
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Oct 4 15:01:11 2014 +0100

    Make sure to discover MTU with relays.
    
    Currently, when tinc sends UDP SPTPS datagrams through a relay, it
    doesn't automatically start discovering PMTU with the relay. This means
    that unless something else triggers PMTU discovery, tinc will keep using
    TCP when sending packets through the relay.
    
    This patches fixes the issue by explicitly establishing UDP tunnels with
    relays.

commit 63daebcd1ec2975c0c2ad8e0ee0fced33b1fbbf0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Oct 4 14:25:16 2014 +0100

    Don't send MTU probes to nodes we can't reach directly.
    
    Currently, we send MTU probes to each node we receive a key for, even if
    we know we will never send UDP packets to that node because of
    indirection. This commit disables MTU probing between nodes that have
    direct communication disabled, otherwise MTU probes end up getting sent
    through relays.
    
    With the legacy protocol this was never a problem because we would never
    request the key of a node with indirection enabled; with SPTPS this was
    not a problem until we introduced relaying because send_sptps_data()
    would simply ignore indirections, but this is not the case anymore.
    
    Note that the fix is implemented in a quick and dirty way, by disabling
    the call to send_mtu_probe() in ans_key_h(); this is not a clean fix
    because there's no code to resume sending MTU probes in case the
    indirection disappears because of a graph change.

commit 111040d7d1993c67246c52cbfd073183818655f9
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 28 12:38:06 2014 +0100

    Add UDP datagram relay support to SPTPS.
    
    This commit changes the layout of UDP datagrams to include a 6-byte
    destination node ID at the very beginning of the datagram (i.e. before
    the source node ID and the seqno). Note that this only applies to SPTPS.
    
    Thanks to this new field, it is now possible to send SPTPS datagrams to
    nodes that are not the final recipient of the packets, thereby using
    these nodes as relay nodes. Previously SPTPS was unable to relay packets
    using UDP, and required a fallback to TCP if the final recipient could
    not be contacted directly using UDP. In that sense it fixes a regression
    that SPTPS introduced with regard to the legacy protocol.
    
    This change also updates tinc's low-level routing logic (i.e.
    send_sptps_data()) to automatically use this relaying facility if at all
    possible. Specifically, it will relay packets if we don't have a
    confirmed UDP link to the final recipient (but we have one with the next
    hop node), or if IndirectData is specified. This is similar to how the
    legacy protocol forwards packets.
    
    When sending packets directly without any relaying, the sender node uses
    a special value for the destination node ID: instead of setting the
    field to the ID of the recipient node, it writes a zero ID instead. This
    allows the recipient node to distinguish between a relayed packet and a
    direct packet, which is important when determining the UDP address of
    the sending node.
    
    On the relay side, relay nodes will happily relay packets that have a
    destination ID which is non-zero *and* is different from their own,
    provided that the source IP address of the packet is known. This is to
    prevent abuse by random strangers, since a node can't authenticate the
    packets that are being relayed through it.
    
    This change keeps the protocol number from the previous datagram format
    change (source IDs), 17.4. Compatibility is still preserved with 1.0 and
    with pre-1.1 releases. Note, however, that nodes running this code won't
    understand datagrams sent from nodes that only use source IDs and
    vice-versa (not that we really care).
    
    There is one caveat: in the current state, there is no way for the
    original sender to know what the PMTU is beyond the first hop, and
    contrary to the legacy protocol, relay nodes can't apply MSS clamping
    because they can't decrypt the relayed packets. This leads to
    inefficient scenarios where a reduced PMTU over some link that's part of
    the relay path will result in relays falling back to TCP to send packets
    to their final destinations.
    
    Another caveat is that once a packet gets sent over TCP, it will use
    TCP over the entire path, even if it is technically possible to use UDP
    beyond the TCP-only link(s).
    
    Arguably, these two caveats can be fixed by improving the
    metaconnection protocol, but that's out of scope for this change. TODOs
    are added instead. In any case, this is no worse than before.
    
    In addition, this change increases SPTPS datagram overhead by another
    6 bytes for the destination ID, on top of the existing 6-byte overhead
    from the source ID.

commit 8dd1c8a020e3babf5054179b0d30e2aa850d2e2b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Sep 27 18:13:33 2014 +0100

    Prepend source node ID information to UDP datagrams.
    
    This commit changes the layout of UDP datagrams to include the 6-byte ID
    (i.e. node name hash) of the node that crafted the packet at the very
    beginning of the datagram (i.e. before the seqno). Note that this only
    applies to SPTPS.
    
    This is implemented at the lowest layer, i.e. in
    handle_incoming_vpn_data() and send_sptps_data() functions. Source ID is
    added and removed there, in such a way that the upper layers are unaware
    of its presence.
    
    This is the first stepping stone towards supporting UDP relaying in
    SPTPS, by providing information about the original sender in the packet
    itself. Nevertheless, even without relaying this commit already provides
    a few benefits such as being able to reliably determine the source node
    of a packet in the presence of an unknown source IP address, without
    having to painfully go through all node keys. This makes tinc's behavior
    much more scalable in this regard.
    
    This change does not break anything with regard to the protocol: It
    preserves compatibility with 1.0 and even with older pre-1.1 releases
    thanks to a minor protocol version change (17.4). Source ID information
    won't be included in packets sent to nodes with minor version < 4.
    
    One drawback, however, is that this change increases SPTPS datagram
    overhead by 6 bytes (the size of the source ID itself).

commit 092d620dbb3fdc8226ea0a4e1cfd5cd53d608420
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Sep 27 13:34:56 2014 +0100

    Change vpn_packet_t::seqno from uint32_t to uint8_t[4].
    
    This is to make sure on-wire vpn_packet_t fields are always 1-byte
    aligned, otherwise padding could get in the way.

commit 55a78da4e0b496fc599704473f41d5ea52669737
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 18:17:02 2014 +0100

    Introduce node IDs.
    
    This introduces a new type of identifier for nodes, which complements
    node names: node IDs. Node IDs are defined as the first 6 bytes of the
    SHA-256 hash of the node name. They will be used in future code in lieu
    of node names as unique node identifiers in contexts where space is at
    a premium (such as VPN packets).
    
    The semantics of node IDs is that they are supposed to be unique in a
    tinc graph; i.e. two different nodes that are part of the same graph
    should not have the same ID, otherwise things could break. This
    solution provides this guarantee based on realistic probabilities:
    indeed, according to the birthday problem, with a 48-bit hash, the
    probability of at least one collision is 1e-13 with 10 nodes, 1e-11
    with 100 nodes, 1e-9 with 1000 nodes and 1e-7 with 10000 nodes. Things
    only start getting hairy with more than 1 million nodes, as the
    probability gets over 0.2%.

commit ac77e3c1eb9d7503e30dd69e96e411e7baaa1dfd
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 15:44:59 2014 +0100

    Invalidate UDP information on address changes.
    
    Currently, when tinc receives an UDP packet from an unexpected address
    (i.e. an address different from the node's current address), it just
    updates its internal UDP address record and carries on like nothing
    happened.
    
    This poses two problems:
    
     - It assumes that the PMTU for the new address is the same as the
       old address, which is risky. Packets might get dropped if the PMTU
       turns out to be smaller (or if UDP communication on the new address
       turns out to be impossible).
    
     - Because the source address in the UDP packet itself is not
       authenticated (i.e. it can be forged by an attacker), this
       introduces a potential vulnerability by which an attacker with
       control over one link can trick a tinc node into dumping its network
       traffic to an arbitrary IP address.
    
    This commit fixes the issue by invalidating UDP/PMTU state for a node
    when its UDP address changes. This will trigger a temporary fallback
    to indirect communication until we get confirmation via PMTU discovery
    that the node is indeed sitting at the other end of the new UDP address.

commit f57d53c3ad9af89489e15a8cfd94b56937bf3179
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Sep 27 17:51:33 2014 +0100

    Fix protocol version check for type 2 MTU probe replies.
    
    Currently tinc only uses type 2 MTU probe replies if the recipient uses
    protocol version 17.3. It should of course support any higher minor
    protocol version as well.

commit f6b008d7317cb1c3766419bdf6bd97d7b4d561f1
Author: Franz Pletz <fpletz@fnordicwalking.de>
Date:   Mon Sep 22 22:43:15 2014 +0200

    tinc-gui: Use /usr/bin/env to resolve path to python

commit daf65919d1ccc40f6c11f3f723f325de9021c422
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 11:38:41 2014 +0200

    Preemptively mirror REQ_PUBKEY messages from nodes with unknown keys.
    
    In this commit, if a node receives a REQ_PUBKEY message from a node it
    doesn't have the key for, it will send a REQ_PUBKEY message in return
    *before* sending its own key.
    
    The rationale is to prevent delays when establishing communication
    between two nodes that see each other for the first time. These delays
    are caused by the first SPTPS packet being dropped on the floor, as
    shown in the following typical exchange:
    
            node1: No Ed25519 key known for node2
            REQ_PUBKEY ->
            <- ANS_PUBKEY
            node1: Learned Ed25519 public key from node2
            REQ_SPTPS_START ->
            node2: No Ed25519 key known for zyklos
            <- REQ_PUBKEY
            ANS_PUBKEY ->
            node2: Learned Ed25519 public key from node1
            -- 10-second delay --
            node1: No key from node2 after 10 seconds, restarting SPTPS
            REQ_SPTPS_START ->
            <- SPTPS ->
            node1: SPTPS key exchange with node2 succesful
            node2: SPTPS key exchange with node1 succesful
    
    With this patch, the following happens instead:
    
            node1: No Ed25519 key known for node2
            REQ_PUBKEY ->
            node2: Preemptively requesting Ed25519 key for node1
            <- REQ_PUBKEY
            <- ANS_PUBKEY
            ANS_PUBKEY ->
            node2: Learned Ed25519 public key from node1
            node1: Learned Ed25519 public key from node2
            REQ_SPTPS_START ->
            <- SPTPS ->
            node1: SPTPS key exchange with node2 succesful
            node2: SPTPS key exchange with node1 succesful

commit c897f8c99e0b0827cff60f098bd3f9852a062233
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 12:58:23 2014 +0200

    Fix default device path selection on BSD.
    
    Currently, if DeviceType = tap but Mode = router, the default
    device path is /dev/tun0, which is wrong. This commit fixes that.

commit a649aa51bf8e5b5fcc76061c9f660122a08245a8
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 11:25:49 2014 +0100

    Ignore the Interface option if device rename is impossible.
    
    There are platforms on which it is impossible to rename the TUN/TAP
    device. An example is Mac OS X (tuntapx). On these platforms,
    specifying the Interface option will not rename the interface, but
    the specified name will still be passed to tinc-up scripts and the
    like, resulting in potential confusion for the user.

commit 053925efebf466b5866de12434010c1e8127c172
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Sep 21 11:14:19 2014 +0100

    Fix default TAP device on Darwin.
    
    On Darwin (tuntapx), the first TAP device is /dev/tap0, not /dev/tun0.

commit 1ac9a3fbd18f961d604c2c080374b8fc32f155d6
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Sep 6 18:16:46 2014 +0100

    Fix wrong identifier in SO_NOSIGPIPE call.
    
    f134bd0c9c2213fbbb3967f3d784759cb65e2c76 broke the Mac OS X build by
    introducing a reference to an identifier, c, that doesn't exist.

commit 7ac52637659b7f17ab5139010f0436aefcf9625c
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Sep 6 10:43:15 2014 +0100

    Don't enable the device if the reachable count is zero.
    
    A logic bug was introduced in bd451cfe1512fa69eac35a60dbe6df17bfc39154
    in which running graph() several times with zero reachable nodes had
    the effect of calling device_enable() (instead of keeping the device
    disabled).
    
    This results in weird behavior when DeviceStandby is enabled, especially
    on Windows where calling device_enable() several times in a row corrupts
    I/O structures for the device, rendering it unusable.

commit 9ad656b512582ed95a574b3fd74b948f876953ce
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Aug 31 13:59:30 2014 +0100

    Fix undefined HOST_NAME_MAX on Windows.
    
    The Windows build was broken by commit
    826ad11e419db90b66b3f76a90b54df021bb39fc which introduced a dependency
    on the HOST_NAME_MAX macro, which is not defined on Windows. According
    to MSDN for gethostname(), the maximum length of the returned string
    is 256 bytes (including the terminating null byte), so let's use that
    as a fallback.

commit 0f09260b1377f2d6f14bcdf5de7cbad415743c1e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Aug 30 10:57:57 2014 +0100

    Remove Google from the list of copyright owners.
    
    Google released copyright to me for my own contributions.

commit 38d7e730e619a8b86dfbf68d77773564595f12a1
Author: William A. Kennington III <william@wkennington.com>
Date:   Sun Aug 24 22:35:25 2014 -0700

    tincctl: Use replace_name to properly replace and validate input hostnames

commit 511b51ffe60c20a9091829c03863197b76027716
Author: William A. Kennington III <william@wkennington.com>
Date:   Sun Aug 24 21:55:42 2014 -0700

    utils: Refactor check_id out of protocol for global access

commit 826ad11e419db90b66b3f76a90b54df021bb39fc
Author: William A. Kennington III <william@wkennington.com>
Date:   Sun Aug 24 19:49:27 2014 -0700

    utils: Refactor get_name's functionality into util for global access

commit 78bf82cf332327889f0f61388b73053850d8e59b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Aug 17 20:22:44 2014 +0100

    Clarify copyright ownership for code authored by Etienne Dechamps.

commit 73d8393bd6c54e0ec28d5f6c114a6eb3821a8ec1
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Thu Aug 7 22:14:20 2014 +0200

    commandline.test: Adding test that fetching non-existing config setting really fails.

commit 9fe5ab7ccb60537810b60b76a415507ef2cadfdd
Author: Sven-Haegar Koch <haegar@sdinet.de>
Date:   Thu Aug 7 23:01:05 2014 +0200

    Fix exit code of "tinc get".
    
    Successfully getting an existing variable ("tinc get name") should
    not result in an error exitcode (1) from the tinc command.
    
    This changes the result of test/commandline.test from FAIL to PASS.

commit 5ae1ec8d80393182b6ff235062b6816b64edfa9b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 19 18:11:42 2014 +0100

    Handle TAP-Win32 immediate reads correctly.
    
    The handling of TAP-Win32 virtual network device reads that complete
    immediately (ReadFile() returns TRUE) is incorrect - instead of
    starting a new read, tinc will continue listening for the overlapped
    read completion event which will never fire. As a result, tinc stops
    receiving packets on the interface.

commit 1d10afd3d33f5623494d9eeb2fa8237712f8aa2e
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 19 16:05:23 2014 +0100

    Only read from TAP-Win32 if the device is enabled.
    
    With newer TAP-Win32 versions (such as the experimental
    tap-windows6 9.21.0), tinc is unable to read from the virtual network
    device:
    
        Error while reading from (null) {23810A13-BCA9-44CE-94C6-9AEDFBF85736}: No such file or directory
    
    This is because these new drivers apparently don't accept reads when
    the device is not in the connected state (media status).
    
    This commit fixes the issue by making sure we start reading no sooner
    than when the device is enabled, and that we stop reading when the
    device is disabled. This also makes the behavior somewhat cleaner,
    because it doesn't make much sense to read from a disabled device
    anyway.

commit cc9203ee75c49360dd29710ac12bb67fe503f97b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jul 13 15:54:34 2014 +0100

    Add a non-interactive mode to tinc commands.
    
    Some tinc commands, such as "tinc generate-keys", use the terminal to
    ask the user for information. This can be bypassed by making sure
    there is no terminal, which is trivial on *nix but might require
    jumping through some hoops on Windows depending on how the command is
    invoked.
    
    This commit adds a --batch option that ensures tinc will never ask the
    user for input, even if it is attached to a terminal.

commit afb175873e6aa10d2d4dca3572edf054968c538d
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 22:51:37 2014 +0200

    Revert "Use git description as the tinc version."
    
    This reverts commit e024b7a2c50e23311834e6d180e5acc72783b339. Automatic version
    number generation needs a little bit more work to get it working correctly in
    all cases.

commit 19e42b76f546dc3baee4a5d6a4f161155d279c74
Merge: f7043048 b12f122f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 22:25:55 2014 +0200

    Merge branch 'keysegfault' of https://github.com/dechamps/tinc into 1.1

commit f704304823df0ac868786ac89355eda38592dc3f
Merge: 54fd228e ea12a0fb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 22:22:31 2014 +0200

    Merge branch 'tincstart' of https://github.com/dechamps/tinc into 1.1

commit 54fd228e696acc9d78a17845402640cc04e2c54c
Merge: 53036a58 14be1d30
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 22:21:01 2014 +0200

    Merge branch 'ctrl' of https://github.com/dechamps/tinc into 1.1

commit 53036a58790168e18f524bd923f9a7d34691ba2d
Merge: ddd0cd47 b2a6381a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 22:19:45 2014 +0200

    Merge branch 'winwarnings' of https://github.com/dechamps/tinc into 1.1

commit ddd0cd47bc0bb3478b7d250192248a1e3aa2a243
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Mon Jun 30 14:03:17 2014 +0100

    Verify seqno early in sptps_verify_datagram().
    
    This is a slight optimization for sptps_verify_datagram(), which might
    come in handy since this function is called in a loop via try_harder().
    
    It turns out that since sptps_verify_datagram() doesn't update any
    state, it doesn't matter in which order verifications are done. However,
    it does affect performance since it's much cheaper to check the seqno
    than to try to decrypt the packet.
    
    Since this function is called with the wrong node most of the time, it
    makes verification vastly faster for the majority of calls because the
    seqno will be wrong in most cases.

commit 7bf61575fe1009ecb93b3f6b8f5145525874e470
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jul 6 11:34:57 2014 +0100

    Add documentation about using system-assigned ports.
    
    There are two caveats to be aware of which are documented in this
    commit:
    
     - Because the system will likely assign different ports when binding
       several times to different address families, it is recommended to
       only use a single address family, otherwise other nodes will only
       get one port among the several that were assigned, possibly breaking
       communication.
    
     - AutoConnect won't work in this scenario, because it relies on the UDP
       port being the same as the TCP port, which is not the case when using
       system-assigned ports.

commit ea12a0fb066793c316ccc9ef21444f092f74b4ba
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 18:53:25 2014 +0100

    Improve subprocess behavior in tinc start command.
    
    When invoking tincd, tinc start currently uses the execvp() function,
    which doesn't behave well in a console as the console displays a new
    prompt before the subprocess finishes (which makes me suspect the exit
    value is not handled at all). This new code uses spawnvp() instead,
    which seems like a better fit.

commit b22499668a7aa63c619cb8fa8535282a38841ce9
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 18:37:56 2014 +0100

    Fix "tinc start" on Windows when the path contains spaces.
    
    When invoking "tinc start" with spaces in the path, the following
    happens:
    
        > "c:\Program Files (x86)\tinc\tinc.exe" start
        c:\Program: unrecognized argument 'Files'
        Try `c:\Program --help' for more information.
    
    This is caused by inconsistent handling of command line strings between
    execvp() and the spawned process' CRT, as documented on MSDN:
    http://msdn.microsoft.com/library/431x4c1w.aspx

commit 14be1d30ec3727906907dad49d3bcb868c19d777
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 17:47:01 2014 +0100

    Shutdown cleanly when receiving a Windows console shutdown request.
    
    This commit makes tinc exit cleanly on Windows when hitting CTRL+C at
    the console or when the user logs off. This change has no effect when
    running tinc as a service.

commit b12f122f1be89b49d8a3e39fb1b10c6e4d3ada94
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 13:56:01 2014 +0100

    Check if devops is valid before closing the device.
    
    This fixes a segfault that occurs on exit if tinc fails before the
    device is initialized (for example, if it fails to read the private
    key).

commit 5ffdff685a0e7d25f7c016f3a6cd89bb82fed71c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 14:35:29 2014 +0200

    Fix unsafe use of strncpy() and sprintf().
    
    The strncpy() problem was found by cppcheck.

commit 31361075d36fd3f4a393eeb90b75ae2567992ef2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 14:34:39 2014 +0200

    Fix a potential file descriptor leak.
    
    Found by cppcheck.

commit b2a6381ab28dbae4bf976627afccbf6c2fcb0625
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 13:32:23 2014 +0100

    Resolve KEY_EVENT conflict between Windows and ncurses.
    
    This fixes the following compiler warning when building for Windows:
    
    In file included from top.c:24:0:
    /usr/local/mingw/ncurses/include/curses.h:1478:0: error: "KEY_EVENT" redefined [-Werror]
     #define KEY_EVENT 0633  /* We were interrupted by an event */
     ^
    In file included from /usr/share/mingw-w64/include/windows.h:74:0,
                     from /usr/share/mingw-w64/include/winsock2.h:23,
                     from have.h:46,
                     from system.h:26,
                     from top.c:20:
    /usr/share/mingw-w64/include/wincon.h:101:0: note: this is the location of the previous definition
     #define KEY_EVENT 0x1
     ^

commit 5217c16db4babd64580c2fd7aa36180bb9bd838c
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 13:27:05 2014 +0100

    Remove unused device stats variables.
    
    This removes a bunch of variables that are never actually used anywhere.
    
    This fixes the following compiler warning when building for Windows:
    
    mingw/device.c:46:17: error: ‘device_total_in’ defined but not used [-Werror=unused-variable]
     static uint64_t device_total_in = 0;
                      ^

commit 6e221a828f87a511aecee9d9263a1db0836701c4
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 12:57:11 2014 +0100

    Remove unused variable in TAP-Win32 setup_device().
    
    This fixes the following compiler warning when building for Windows:
    
    mingw/device.c: In function ‘setup_device’:
    mingw/device.c:92:9: error: unused variable ‘thread’ [-Werror=unused-variable]
      HANDLE thread;
               ^

commit 2d2e94406c5f595eff67a01ee6bb1190f77c37ff
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 12:54:45 2014 +0100

    Fix callback signature for TAP-Win32 device_handle_read().
    
    This fixes the following compiler warning when building for Windows:
    
    mingw/device.c: In function ‘setup_device’:
    mingw/device.c:186:2: error: passing argument 2 of ‘io_add_event’ from incompatible pointer type [-Werror]
      io_add_event(&device_read_io, device_handle_read, NULL, CreateEvent(NULL, TRUE, FALSE, NULL));
      ^
    In file included from mingw/../net.h:27:0,
                     from mingw/../subnet.h:24,
                     from mingw/../conf.h:34,
                     from mingw/device.c:26:
    mingw/../event.h:61:13: note: expected ‘io_cb_t’ but argument is of type ‘void (*)(void *)’
     extern void io_add_event(io_t *io, io_cb_t cb, void* data, WSAEVENT event);

commit f693cb7295298ecd6993a4feac1faf9129aa204d
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 12:52:25 2014 +0100

    Remove an unnecessary pointer dereference in execute_script().
    
    This fixes the following compiler warning when building for Windows:
    
    script.c: In function ‘execute_script’:
    script.c:52:5: error: value computed is not used [-Werror=unused-value]
         *q++;
              ^

commit d7f89a79448dd1633342ea5ee344d403c8e6890b
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 12:49:59 2014 +0100

    Only declare the origpriority variable if we support priority.
    
    This fixes the following compiler warning when building for Windows:
    
    net_packet.c: In function ‘send_udppacket’:
    net_packet.c:633:6: error: unused variable ‘origpriority’ [-Werror=unused-variable]
      int origpriority = origpkt->priority;
            ^

commit 5aed916ef4fd75e6843f8fe739444dae91ea106a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jul 12 14:24:16 2014 +0200

    Reserve legacy active bit in connection_status_t.
    
    This is so the positions of the other bits don't change, making it easier to
    debug problems with different versions of tinc.
    
    Also fix the padding so connection_status_t is exactly 32 bits.

commit b23bf132838156d2fe5a18d50a2b5e068ae18ec3
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 11:57:03 2014 +0100

    Remove redundant connection_t::status.active field.
    
    The only places where connection_t::status.active is modified is in
    ack_h() and terminate_connection(). In both cases, connection_t::edge
    is added and removed at the same time, and that's the only places
    connection_t::edge is set. Therefore, the following is true at all
    times:
    
        !c->status.active == !c->edge
    
    This commit removes the redundant state information by getting rid of
    connection_t::status.active, and using connection_t::edge instead.

commit 127f2f99f3d43e0565782750f26f1d3980c72711
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 11:13:04 2014 +0100

    Don't initialize outpkt to an unused value.
    
    in receive_udppacket(), we initialize outpkt to a default value but the
    value is never read anywhere, as every read is preceded by a write.
    
    This issue was found by the clang static analyzer tool:
    http://clang-analyzer.llvm.org/

commit 77e96c07912c2a8b280d3e812c71fa1f12efb0ff
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 12 11:06:36 2014 +0100

    Handle the "no local address" case in send_sptps_data().
    
    If choose_local_address() is unable to find a local address (e.g.
    because of old nodes that don't send their local address information),
    then send_sptps_data() ends up using uninitialized variables for the
    socket and address.
    
    This regression was introduced in
    415910897122da0073a862784d148802ca390020. The commit took care of
    handling that case in send_udppacket() but was missing the same fix
    for send_sptps_data().
    
    This bug was found by the clang static analyzer tool:
    http://clang-analyzer.llvm.org/

commit 45a30f71572fab8e73c456737b7506b2cf12be25
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Thu Jul 10 22:41:01 2014 +0200

    Fix incorrect format qualifiers.
    
    Based on a patch from Etienne Dechamps. We avoid the use of %hhx, since even
    though it is C99, not all compilers support it yet. We use %x instead, since
    it's guaranteed that the minimum size of function arguments on the stack or in
    registers is that of an int.

commit d8ed5cf36d0c6d5a863497674248c8e8b63b9d98
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jul 10 20:29:12 2014 +0100

    Fix a typo (FORTIFY_SOURCE).

commit 2f4075f7da2c6ddf777c5bab93992a6c6ac5ec40
Author: Baptiste Jonglez <baptiste--git@jonglez.org>
Date:   Sun Jul 6 20:55:26 2014 +0900

    Fix typos in the manual page

commit d8ea4c11dec5946c135ad2d2d05954473a0bfda9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jul 8 14:20:11 2014 +0200

    Fix segmentation fault when dumping subnets.

commit 23a22ea1ceb9d0a6b6c288142130f0e30c0fdec9
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jul 8 14:20:01 2014 +0200

    Fix compiler warnings.

commit 163773d7107b7726bed24cb1c31b1cecc0d0c239
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jul 6 12:35:32 2014 +0100

    Fix event loop io tree inconsistency on Windows.
    
    On Windows, the event loop io tree uses the Windows Event handle to
    differentiate between io_t objects. Unfortunately, there is a bug in
    the io_add_event() function (introduced in
    2f9a1d4ab5ff51b05a5e8cc41a1528fdeb36c723) as it sets the event after
    inserting the object into the tree, resulting in objects appearing in
    io_tree out of order.
    
    This can lead to crashes on Windows as the event loop is unable to
    determine which events fired.

commit fcf5b53e785fd191dd951b77ad831fe6ac78dce4
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jul 6 10:55:23 2014 +0100

    Make sure myport is set correctly when running with Port = 0.
    
    Setting the Port configuration variable to zero can be used to make tinc
    listen on a system-assigned port. Unfortunately, in this scenario myport
    will be zero, which means that tinc won't transmit its actual UDP
    listening port to other nodes. This breaks UDP hole punching and local
    discovery.

commit c786ed116805c0bc911f592c03dc0d5562287283
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 5 00:23:05 2014 +0100

    Fix tinc event loop reentrancy from timeout handlers.
    
    Commit 611217c96ec684799882cf330f40a0936131b6b5 introduced a regression
    because it accidentally reordered the timeout handler calls and the
    fdset setup code. This means that any io_add(), io_del() or io_set()
    calls in timeout handlers would be ignored in the current event loop
    iteration, resulting in erratic behavior.
    
    The most visible symptom is when a metaconnection timeout occurs and the
    connection is closed; the timeout handler closes the socket but it still
    ends up in the select() call, typically resulting in the following
    crash:
    
        Error while waiting for input: Bad file descriptor

commit d0d01a44485ee04f60a8fccf9bdf8311e23ffa43
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 5 19:51:19 2014 +0100

    Canonicalize IPv6 addresses as per RFC 5952 before printing them.
    
    Currently we don't do any shortening on IPv6 addresses (aside from
    removing trailing zeroes) before printing them. This commit makes
    textual addresses smaller by shortening them according to the rules
    described in RFC 5952. This is also the canonical textual representation
    for IPv6 addresses, thus making them easier to compare.

commit dec0400714cc6b125f615c224ac37903f44addb9
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 5 19:02:02 2014 +0100

    Don't print subnet prefix lengths and weights for one-host subnets.
    
    This commit suppresses subnet prefix length output (/xx) for subnets
    that only contain one address (/32 for IPv4, /128 for IPv6). It also
    suppresses weight information if the subnet is using the default
    weight. This improves readability of net2str() output in the majority
    of cases.

commit dc55691ca7399bab28963f92e4c3dea9d6bf8eb1
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 5 18:52:03 2014 +0100

    When printing MAC addresses, always use trailing zeroes.
    
    tinc currently prints MAC addresses without trailing zeroes, for example:
    
        1:2:3:4:5:6
    
    This looks weird and is inconsistent with how MAC addresses are
    displayed everywhere else. This commit adds trailing zeroes, so the
    above address will be printed as the following:
    
        01:02:03:04:05:06

commit 3d730a40a42d9b238da8725438a612296dea3860
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jul 5 18:05:55 2014 +0100

    Rewrite, fix and improve str2net().
    
    This is a complete rewrite of the str2net() function. Besides
    refactoring duplicate code, this new code brings the following fixes
    and improvements:
    
     - Fixes handling of leading/trailing double colon in IPv6 addresses.
       For example, with the previous code the address
       2001:0db8:85a3:0000:0000:8a2e:0370:: is interpreted as a MAC address,
       and ::0db8:85a3:0000:0000:8a2e:0370:7334 is rejected.
    
     - Catches more invalid cases, such as garbage at the end of the string.
    
     - Adds support for dotted quad notation in IPv6 (e.g. ::1.2.3.4).
    
    See RFC 4291, section 2.2 for details on the textual format of IPv6
    addresses.

commit e024b7a2c50e23311834e6d180e5acc72783b339
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 15:22:10 2014 +0100

    Use git description as the tinc version.
    
    Instead of using a hardcoded version number in configure.ac, this makes
    tinc use the live version reported by "git describe", queried on-the-fly
    during the build process and regenerated for every build.
    
    This provides several advantages:
     - Less redundancy: git is now the source of truth for version
       information, no need to store it in the repository itself.
     - Simpler release process: just creating a git tag automatically
       updates the version. No need to change files.
     - More useful version information: tinc will now display the number of
       commits since the last tag as well as the commit the binary is built
       from, following the format described in git-describe(1).
    
    Here's an example of tincd --version output:
    
      tinc version release-1.1pre10-48-gc149315 (built Jun 29 2014 15:21:10, protocol 17.3)
    
    When building directly from a release tag, this would like the following:
    
      tinc version release-1.1pre10 (built Jun 29 2014 15:21:10, protocol 17.3)
    
    (Note that the format is slightly different - because of the way the
    tags are named, it says "release-1.1pre10" instead of just "1.1pre10")

commit aec82bb1c94af6d3142cdef0c51f42f38e9be3e0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 14:57:42 2014 +0100

    Regenerate build date and time every time tinc is built.
    
    This prevents the date and time shown in version information from
    getting stale because of partial builds. With these changes, date and
    time information is written to a dedicated object file that gets rebuilt
    every time make is run, even if there are no changes.

commit 116f2ed27a74982e4d1a19b7a8fd08b0aaee1f8d
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 14:15:58 2014 +0100

    Make IPv4 multicast space 224.0.0.0/4 broadcast by default.
    
    We already do this for IPv6 multicast space (ff00::/8), so why not
    extend it to IPv4.

commit 46a5aa0d674914f4220d8583b1b2f87c7f05a804
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 13:18:25 2014 +0100

    Make broadcast addresses configurable.
    
    This adds a new option, BroadcastSubnet, that allows the user to
    declare broadcast subnets, i.e. subnets which are considered broadcast
    addresses by the tinc routing layer. Previously only the global IPv4
    and IPv6 broadcast addresses were supported by virtue of being
    hardcoded.
    
    This is useful when using tinc in router mode with Ethernet virtual
    devices, as it can be used to provide broadcast support for a local
    broadcast address (e.g. 10.42.255.255) instead of just the global
    address (255.255.255.255).
    
    This is implemented by removing hardcoded broadcast addresses and
    introducing "broadcast subnets", which are subnets with a NULL owner.
    By default, behavior is unchanged; this is accomplished by adding
    the global broadcast addresses for Ethernet, IPv4 and IPv6 at start
    time.

commit b54fde67474e7201e94fa4be34dae65d295b2936
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 09:57:11 2014 +0100

    Implement sptps_verify_datagram().
    
    Implementation of sptps_verify_datagram() was left as a TODO. This
    causes problems when using SPTPS in tinc, because this function is
    used in try_mac(), which itself is used in try_harder() to locate
    nodes sending UDP packets from unexpected addresses. In the current
    state this function always returns true, resulting in UDP addresses
    of random nodes getting changed which makes UDP communication
    fragile and unreliable. In addition, this makes UDP communication
    impossible through port translation and local discovery.
    
    This commit adds the missing implementation, thus fixing the issue.

commit 498f1b1d5835ab1ac21886cdf0d1471ac90f75b2
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 11:06:44 2014 +0100

    Enable LocalDiscovery by default.
    
    Recent improvements to the local discovery mechanism makes it cheaper,
    more network-friendly, and now it cannot make things worse (as opposed
    to the old mechanism). Thus there is no reason not to enable it by
    default.

commit 415910897122da0073a862784d148802ca390020
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 29 11:01:24 2014 +0100

    Remove broadcast-based local discovery mechanism.
    
    The new local address based local discovery mechanism is technically
    superior to the old broadcast-based one. In fact, the old algorithm
    can technically make things worse by e.g. sending broadcasts over the
    VPN itself and then selecting the VPN address as the node's UDP
    address. This cannot happen with the new mechanism.
    
    Note that this means old nodes that don't send their local addresses in
    ADD_EDGE messages can't be discovered, because there is no address to
    send discovery packets to. Old nodes can still discover new nodes by
    sending them broadcasts, though.

commit e16ade874d08f82481dca7302b98305bcfbe27cf
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 17:27:55 2014 +0100

    Use edge local addresses for local discovery.
    
    This introduces a new way of doing local discovery: when tinc has
    local address information for the recipient node, it will send local
    discovery packets directly to the local address of that node, instead
    of using broadcast packets.
    
    This new way of doing local discovery provides numerous advantages compared to
    using broadcasts:
    
     - No broadcast packets "polluting" the local network;
    
     - Reliable even if the sending host has multiple network interfaces (in
       contrast, broadcasts will only be sent through one unpredictable
       interface)
    
     - Works even if the two hosts are not on the same broadcast domain. One
       example is a large LAN where the two hosts might be on different local
       subnets. In fact, thanks to UDP hole punching this might even work if
       there is a NAT sitting in the middle of the LAN between the two nodes!
    
     - Sometimes a node is reachable through its "normal" address, and via a
       local subnet as well. One might think the local subnet is the best route
       to the node in this case, but more often than not it's actually worse -
       one example is where the local segment is a third party VPN running in
       parallel, or ironically it can be the local segment formed by the tinc
       VPN itself! Because this new algorithm only checks the addresses for
       which an edge is already established, it is less likely to fall into
       these traps.

commit bfce56d473e1e01a8af0260262ca84f09154e71f
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 16:29:30 2014 +0100

    Add local address information to edges.
    
    In addition to the remote address, each edge now stores the local address from
    the point of view of the "from" node. This information is then made available
    to other nodes through a backwards-compatible extension to ADD_EDGE messages.
    
    This information can be used in future code to improve packet routing.

commit 762db91ef7d3b2eab00c23250ca61c7f814899c7
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jun 28 21:54:34 2014 +0200

    Give getsockopt() a reference to a socklen_t.

commit e57daac63b6f703af8e7c8209ef61a4d3b2180c3
Merge: cc284e7c 313a752c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sat Jun 28 21:49:55 2014 +0200

    Merge branch 'winevents-clean' of https://github.com/dechamps/tinc into 1.1

commit 313a752cb5fbf27450d34c15b0085d2d8a4147af
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jun 28 18:39:00 2014 +0100

    Remove the TAP-Win32 reader thread.
    
    tinc is using a separate thread to read from the TAP device on Windows.
    The rationale was that the notification mechanism for packets arriving
    on the virtual network device is based on Win32 events, and the event
    loop did not support listening to these events.
    
    Thanks to recent improvements, this event loop limitation has been
    lifted. Therefore we can get rid of the separate thread and simply add
    the Win32 "incoming packet" event to the event loop, just like a socket.
    The result is cleaner code that's easier to reason about.

commit ffbc99558cae4dff876645fe205349d8c4cd7acb
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jun 28 15:19:11 2014 +0100

    Use a Windows event to stop tinc when running as a service.
    
    Currently, when the tinc service handler callback (which runs in a
    separate thread) receives a service shutdown request, it calls
    event_exit() to request the event loop to exit.
    
    This approach has a few issues:
    
     - The event loop will only notice the exit request when the next event
       fires. This slows down tinc service shutdown. In some extreme cases
       (DeviceStandby enabled, long PingTimeout and no connections),
       shutdown can take ages.
    
     - Strictly speaking, because of the absence of memory barriers, there
       is no guarantee that the event loop will even notice an exit request
       coming from another thread. I suppose marking the "running" variable
       as "volatile" is supposed to alleviate that, but it's unclear whether
       that provides any guarantees with modern systems and compilers.
    
    This commit fixes the issue by leveraging the new event loop Windows
    interface, using a custom Windows event that is manually set when
    shutdown is requested.

commit 2f9a1d4ab5ff51b05a5e8cc41a1528fdeb36c723
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jun 28 15:15:41 2014 +0100

    Make the event loop expose a Windows event interface.
    
    This allows event loop users to specify Win32 events to wait on,
    thus making the event loop more flexible.

commit 611217c96ec684799882cf330f40a0936131b6b5
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Fri Jun 27 21:58:35 2014 +0100

    Use native Windows events for the event loop.
    
    This commit changes the event loop to use WSAEventSelect() and
    WSAWaitForMultipleEvents() on Windows. This paves the way for making the
    event loop more flexible on Windows by introducing the required
    infrastructure to make the event loop wait on any Win32 event.
    
    This commit only affects the internal implementation of the event
    module. Externally visible behavior remains strictly unchanged (for
    now).

commit cc284e7c5d298ca887c07f918da35e376bf98720
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sat Jun 28 11:13:29 2014 +0100

    Fix connection event error handling.
    
    Commit 86a99c6b999671ed444711139db1937617e802a0 changed the way we
    handle connection events to protect against spurious event loop
    callbacks. Unfortunately, it turns out that calling connect() twice on
    the same socket results in different behaviors depending on the platform
    (even though it seems well defined in POSIX). On Windows this resulted
    in the connection handling code being unable to react to connection
    errors (such as connection refused), always hitting the timeout; on
    Linux this resulted in spurious error messages about connect() returning
    success.
    
    In POSIX and on Linux, using connect() on a socket where the previous
    attempt failed will attempt to connect again, resulting in unnecessary
    network activity. Using getsockopt(SO_ERROR) before connect() solves
    that, but introduces a race condition if a connection failure happens
    between the two calls.
    
    For this reason, this commit switches from connect() to a zero-sized
    send() call, which is more consistent (though not completely, see the
    truth table in the comments) and simpler to use for that purpose. Note
    that Windows explictly support empty send() calls; POSIX says nothing
    on the subject, but testing shows it works at least on Linux.
    
    (Surprisingly enough, Windows seems more POSIX-compliant than Linux on
    this one!)

commit 86a99c6b999671ed444711139db1937617e802a0
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Fri Jun 27 19:33:31 2014 +0100

    Protect against spurious connection events.
    
    The event loop does not guarantee that spurious write I/O events do not
    happen; in fact, they are guaranteed to happen on Windows when
    event_flush_output() is called. Because handle_meta_io() does not check
    for spurious events, a metaconnection socket might appear connected even
    though it's not, and will fail immediately when sending the ID request.
    
    This commit fixes this issue by making handle_meta_io() check the
    connection status before assuming the socket is connected. It seems that
    the only reliable way to do that is to try to call connect() again and
    look at the error code, which will be EISCONN if the socket is
    connected, or EALREADY if it's not.

commit 0c026f3c6dec784c3267ad7e2c4709d5393dc292
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Thu Jun 26 20:42:40 2014 +0100

    Fix errno references when handling socket errors.
    
    When using socket functions, "sockerrno" is supposed to be used to
    retrieve the error code as opposed to "errno", so that it is translated
    to the correct call on Windows (WSAGetLastError() - Windows does not
    update errno on socket errors). Unfortunately, the use of sockerrno is
    inconsistent throughout the tinc codebase, as errno is often used
    incorrectly on socket-related calls.
    
    This commit fixes these oversights, which improves socket error
    handling on Windows.

commit 058473dc8d4cf60f79aee18d473342b8a3c25fbe
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 18:45:49 2014 +0100

    Fix Windows includes.
    
    These Windows include lines are capitalized, which causes the build to fail
    when cross-compiling from Linux to Windows using MinGW as the MinGW headers
    are entirely lower case.

commit b24faf3cbe07dd931911ec4d70f1a9e0d6a87519
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 11 17:11:02 2014 +0200

    Remove the warnings when IP_DONTFRAGMENT/IPV6-DONTFRAG is not supported.
    
    There is nothing we can do about it, and tinc will run fine anyway.

commit b99e1a306c7fb8f43dd61e432f3c896f5142e4ac
Author: Alexis Hildebrandt <afh@surryhill.net>
Date:   Sun Jun 22 16:43:15 2014 +0200

    Add support to link against libresolv Mac OS X

commit e76df30cb2af7a22e9c1dc91bb47a76c2fcbc43d
Author: Armin Fisslthaler <armin@fisslthaler.net>
Date:   Fri Apr 25 14:44:06 2014 +0200

    reload /etc/resolv.conf in SIGALRM handler

commit 132bdb77a0792d85d03ad89f846cbd4024037393
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 10:48:34 2014 +0100

    Make DeviceStandby control network interface link status on Windows.
    
    Besides controlling when tinc-up and tinc-down get called, this commit makes
    DeviceStandby control when the virtual network interface "cable" is "plugged"
    on Windows. This is more user-friendly as the status of the tinc network can
    be seen just by looking at the state of the network interface, and it makes
    Windows behave better when isolated.

commit bd451cfe1512fa69eac35a60dbe6df17bfc39154
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 10:48:34 2014 +0100

    Add DeviceStandby option to only enable the device when nodes are reachable.
    
    This adds a new DeviceStandby option; when it is disabled (the default),
    behavior is unchanged. If it is enabled, tinc-up will not be called during
    tinc initialization, but will instead be deferred until the first node is
    reachable, and it will be closed as soon as no nodes are reachable.
    
    This is useful because it means the device won't be set up until we are fairly
    sure there is something listening on the other side. This is more user-friendly,
    as one can check on the status of the tinc network connection just by checking
    the status of the network interface. Besides, it prevents the OS from thinking
    it is connected to some network when it is in fact completely isolated.

commit f0885b8d2fe69610e7e294735795d98db11157a5
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 14:06:44 2014 +0100

    Cleanly remove the device FD from the event loop before closing it.

commit ed1d0878afe53032a4b63e87afd4a435015cf5de
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 09:53:26 2014 +0100

    Make device close cleaner.

commit 638260865399693c3ced9337ef2664c5ba968a2a
Author: Etienne Dechamps <etienne@edechamps.fr>
Date:   Sun Jun 22 09:54:45 2014 +0100

    Move Solaris if_fd to local scope.
    
    This variable is never used outside of setup_device(), therefore there is no
    reason to declare it in global scope.

commit 9bfc228ef5fcd4166897e32fbe82f4cc4e252922
Author: Baptiste Jonglez <baptiste--git@jonglez.org>
Date:   Fri Jun 20 15:56:13 2014 +0900

    Clarify man page regarding the IndirectData option

commit 31c68993989fbca3c88df1449ea2077baafce481
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 15 12:19:10 2014 +0200

    Unconditionally return non-zero exit code when "tinc del" does not find the requested variable.

commit 1ce0f7613964c7441ef683f9d875dd09cbfd667c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Jun 15 12:14:01 2014 +0200

    Return non-zero exit code when "tinc get" does not find the requested variable.

commit ef5e8b6920d1dd3097f36bd0c50170100acf2f28
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Jun 3 11:02:58 2014 +0200

    Fix base64 decoding of Ed25519 keys.

commit b0d80c7f28528c2c8857c5662b4aca779b3184bb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 18 21:51:42 2014 +0200

    Allow Cipher and Digest "none".
    
    This is for backwards compatibility with tinc 1.0, it has no effect on
    the SPTPS protocol.

commit 666718998eaa044f6f25fe99810a78dca8471393
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 18 20:49:35 2014 +0200

    Implement a PEM-like format for Ed25519 keys.
    
    We don't require compatibility with any other software, but we do want Ed25519 keys to work
    the same as RSA keys for now.

commit f0e7e6b03e34e69cac5b01a2d943ad3b9b59d36c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun May 18 20:47:04 2014 +0200

    Rename ECDSA to Ed25519.

commit 35437a50e2a46861742b6fb8e49d065aa52a04dc
Author: Guus Sliepen <guus@sliepen.org>
Date:   Tue May 13 20:29:09 2014 +0200

    Add sanity checks when generating new RSA keys.
    
    The key size should be a multiple of 8 bits, and it should be between 1024 and
    8192 bits.

commit 66f325f4674e70d83744626f3b8dda6760f8d613
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon May 12 15:57:40 2014 +0200

    Fix PMTU discovery via datagram SPTPS.
    
    In send_sptps_data(), the len variable contains the length of the whole
    datagram that needs to be sent to the peer, including the overhead from SPTPS
    itself.

commit c35bfa18ec49439d4a028990fcf0ae6d8c4508a5
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon May 12 15:56:29 2014 +0200

    Fix a crash when we have a malformed public ECDSA key of another node.

commit c32fcdfc1dde289c52bc359b7b6c5f8c30186e58
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon May 12 14:35:56 2014 +0200

    Add missing closedir().

commit 75e5b2e906bd8563bf0f53a76065618c88122e1c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon May 12 14:35:12 2014 +0200

    Use void pointers to opaque buffers.

commit 332b55d4720fadea76c0a5d9b9d484af6a724006
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 6 14:11:55 2014 +0200

    Change AutoConnect from int to bool.
    
    The proper value is 3, not 2 or 4, and 5 is right out. So just hardcode this value,
    and only have the option to turn AutoConnect on or off.

commit 27acb5d04792f2da70e937543de9110e16aae21c
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 6 13:01:48 2014 +0200

    Fix compiler warnings.

commit bc33a073d82cd4b5e75d00e379ddfeeaa6ade962
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue May 6 12:58:25 2014 +0200

    Nexthop calculation should always use the shortest path.
    
    When tinc runs the graph algorithms and updates the nexthop and via pointers,
    it uses a breadth-first search, but it can sometimes revisit nodes that have
    already been visited if the previous path is marked as being indirect, and
    there is a longer path that is "direct". The via pointer should be updated in
    this case, because this points to the closest hop to the destination that can
    be reached directly. However, the nexthop pointer should not be updated.
    
    This fixes a bug where there could potentially be a routing loop if a node in
    the graph has an edge with the indirect flag set, and some other edge without
    that flag, the indirect edge is part of the minimum spanning tree, and a
    broadcast packet is being sent.

commit b6e2b416bf9a5788c8847267b849efcd9e5bbf95
Author: Saverio Proto <zioproto@gmail.com>
Date:   Mon May 5 15:23:25 2014 +0200

    Fix typo in comment

commit 18698c4e123d1ed22f3a2fc5529fac62fbabaf19
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Apr 25 17:00:55 2014 +0200

    Put brackets around IPv6 addresses in invitation URL, even if there is no port number.

commit 475088ed77df925ce0680c9993305cd746742708
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Tue Apr 15 17:26:08 2014 +0200

    sptps_test: allow using a tun device instead of stdio.

commit 2980173ee7f8142598fe5e1ab117e463751da310
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 14 21:43:45 2014 +0200

    Use the ChaCha-Poly1305 cipher for the SPTPS protocol.
    
    The main reason to switch from AES-256-GCM to ChaCha-Poly1305 is to remove a
    dependency on OpenSSL, whose behaviour of the AES-256-GCM decryption function
    changes between versions. The source code for ChaCha-Pol1305 is small and in
    the public domain, and can therefore be easily included in tinc itself.
    Moreover, it is very fast even without using any optimized assembler, easily
    outperforming AES-256-GCM on platforms that don't have special AES instructions
    in hardware.

commit 49e3baec20ddad9cc297c3eeb1d13f0e421f69c8
Merge: 37b729d7 2f01744f
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Mon Apr 14 20:49:43 2014 +0200

    Merge branch '1.1-ed25519' into 1.1

commit 37b729d7fdd49da5466696f7995a96ebb54fbcbb
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Apr 13 12:09:48 2014 +0200

    Properly initialize buffers.
    
    Valgrind complained about use of uninitialized data.

commit 2f01744f82be542894fe2ceecbfb9ead93c9ffa5
Author: Guus Sliepen <guus@sliepen.org>
Date:   Sun Apr 6 22:47:26 2014 +0200

    Use Ed25519 keys.
    
    This uses the portable Ed25519 library made by Orson Peters, which in turn uses
    the reference implementation made by Daniel J. Bernstein.
    
    This implementation also allows Ed25519 keys to be used for key exchange, so
    there is no need to add a separate implementation of Curve25519.

commit d6734a2da483675f5bcc9cf7b15723a409b1019f
Author: Guus Sliepen <guus@sliepen.org>
Date:   Sun Apr 6 22:46:06 2014 +0200

    Fix return value of b64encode().

commit f134bd0c9c2213fbbb3967f3d784759cb65e2c76
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Sun Mar 9 15:32:10 2014 +0100

    Handle a disconnecting tincd better.
    
    - Try to prevent SIGPIPE from being sent for errors sending to the control
      socket. We don't outright block the SIGPIPE signal because we still want the
      tinc CLI to exit when its output is actually sent to a real (broken) pipe.
    
    - Don't call exit() from top(), and properly detect when the control socket is
      closed by the tincd.

commit 09e000ba54fd4a4ffe3e5c15ee7aeadac35d6996
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Feb 26 17:27:57 2014 +0100

    Rewind the file before trying to use PEM_read_RSA_PUBKEY().

commit 44c7f554c7a6eb411428cfd30ca2cb21a613830e
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Wed Feb 26 11:00:30 2014 +0100

    Add "network" command to list or switch networks.

commit 48ecff6ddb7e6f9d6b6df7f8952c4cfb318572fa
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Feb 7 23:06:26 2014 +0100

    Add missing attribution for 1.1pre10 to the NEWS file.

commit 9f7e2dffb27297385c56698638386b264c9aff1a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Feb 7 23:05:33 2014 +0100

    Really fix compiling under Windows.

commit 173072ff078a8917b60c24dbe58aa7c258450de2
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Feb 7 21:40:42 2014 +0100

    Releasing 1.1pre10.

commit cb5c1b5986861361207fa244662bb2c7f3d6a3a4
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Feb 7 21:40:29 2014 +0100

    Check whether OpenSSL has support for GCM.

commit cdda0388a82eb44ff260e25c0902794c8db9643a
Author: Guus Sliepen <guus@tinc-vpn.org>
Date:   Fri Feb 7 21:14:41 2014 +0100

